{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getBitcoinReceiversReceiverTransactions
module StripeAPI.Operations.GetBitcoinReceiversReceiverTransactions where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/bitcoin/receivers/{receiver}/transactions
--
-- \<p>List bitcoin transacitons for a given receiver.\<\/p>
getBitcoinReceiversReceiverTransactions ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetBitcoinReceiversReceiverTransactionsParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response GetBitcoinReceiversReceiverTransactionsResponse)
getBitcoinReceiversReceiverTransactions parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetBitcoinReceiversReceiverTransactionsResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetBitcoinReceiversReceiverTransactionsResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            GetBitcoinReceiversReceiverTransactionsResponseBody200
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetBitcoinReceiversReceiverTransactionsResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    ( StripeAPI.Common.doCallWithConfigurationM
        (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
        (Data.Text.pack ("/v1/bitcoin/receivers/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel (getBitcoinReceiversReceiverTransactionsParametersPathReceiver parameters))) GHC.Base.++ "/transactions")))
        [ StripeAPI.Common.QueryParameter (Data.Text.pack "customer") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getBitcoinReceiversReceiverTransactionsParametersQueryCustomer parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "ending_before") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getBitcoinReceiversReceiverTransactionsParametersQueryEndingBefore parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getBitcoinReceiversReceiverTransactionsParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "limit") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getBitcoinReceiversReceiverTransactionsParametersQueryLimit parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "starting_after") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getBitcoinReceiversReceiverTransactionsParametersQueryStartingAfter parameters) (Data.Text.pack "form") GHC.Types.True
        ]
    )

-- | Defines the object schema located at @paths.\/v1\/bitcoin\/receivers\/{receiver}\/transactions.GET.parameters@ in the specification.
data GetBitcoinReceiversReceiverTransactionsParameters = GetBitcoinReceiversReceiverTransactionsParameters
  { -- | pathReceiver: Represents the parameter named \'receiver\'
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getBitcoinReceiversReceiverTransactionsParametersPathReceiver :: Data.Text.Internal.Text,
    -- | queryCustomer: Represents the parameter named \'customer\'
    --
    -- Only return transactions for the customer specified by this customer ID.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getBitcoinReceiversReceiverTransactionsParametersQueryCustomer :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryEnding_before: Represents the parameter named \'ending_before\'
    --
    -- A cursor for use in pagination. \`ending_before\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, starting with \`obj_bar\`, your subsequent call can include \`ending_before=obj_bar\` in order to fetch the previous page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getBitcoinReceiversReceiverTransactionsParametersQueryEndingBefore :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getBitcoinReceiversReceiverTransactionsParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | queryLimit: Represents the parameter named \'limit\'
    --
    -- A limit on the number of objects to be returned. Limit can range between 1 and 100, and the default is 10.
    getBitcoinReceiversReceiverTransactionsParametersQueryLimit :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | queryStarting_after: Represents the parameter named \'starting_after\'
    --
    -- A cursor for use in pagination. \`starting_after\` is an object ID that defines your place in the list. For instance, if you make a list request and receive 100 objects, ending with \`obj_foo\`, your subsequent call can include \`starting_after=obj_foo\` in order to fetch the next page of the list.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getBitcoinReceiversReceiverTransactionsParametersQueryStartingAfter :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetBitcoinReceiversReceiverTransactionsParameters where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["pathReceiver" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsParametersPathReceiver obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryCustomer" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryEnding_before" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryEndingBefore obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryLimit" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryLimit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryStarting_after" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryStartingAfter obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["pathReceiver" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsParametersPathReceiver obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryCustomer" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryCustomer obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryEnding_before" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryEndingBefore obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryLimit" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryLimit obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryStarting_after" Data.Aeson.Types.ToJSON..=)) (getBitcoinReceiversReceiverTransactionsParametersQueryStartingAfter obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GetBitcoinReceiversReceiverTransactionsParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetBitcoinReceiversReceiverTransactionsParameters" (\obj -> (((((GHC.Base.pure GetBitcoinReceiversReceiverTransactionsParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "pathReceiver")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryCustomer")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryEnding_before")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryExpand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryLimit")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryStarting_after"))

-- | Create a new 'GetBitcoinReceiversReceiverTransactionsParameters' with all required fields.
mkGetBitcoinReceiversReceiverTransactionsParameters ::
  -- | 'getBitcoinReceiversReceiverTransactionsParametersPathReceiver'
  Data.Text.Internal.Text ->
  GetBitcoinReceiversReceiverTransactionsParameters
mkGetBitcoinReceiversReceiverTransactionsParameters getBitcoinReceiversReceiverTransactionsParametersPathReceiver =
  GetBitcoinReceiversReceiverTransactionsParameters
    { getBitcoinReceiversReceiverTransactionsParametersPathReceiver = getBitcoinReceiversReceiverTransactionsParametersPathReceiver,
      getBitcoinReceiversReceiverTransactionsParametersQueryCustomer = GHC.Maybe.Nothing,
      getBitcoinReceiversReceiverTransactionsParametersQueryEndingBefore = GHC.Maybe.Nothing,
      getBitcoinReceiversReceiverTransactionsParametersQueryExpand = GHC.Maybe.Nothing,
      getBitcoinReceiversReceiverTransactionsParametersQueryLimit = GHC.Maybe.Nothing,
      getBitcoinReceiversReceiverTransactionsParametersQueryStartingAfter = GHC.Maybe.Nothing
    }

-- | Represents a response of the operation 'getBitcoinReceiversReceiverTransactions'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetBitcoinReceiversReceiverTransactionsResponseError' is used.
data GetBitcoinReceiversReceiverTransactionsResponse
  = -- | Means either no matching case available or a parse error
    GetBitcoinReceiversReceiverTransactionsResponseError GHC.Base.String
  | -- | Successful response.
    GetBitcoinReceiversReceiverTransactionsResponse200 GetBitcoinReceiversReceiverTransactionsResponseBody200
  | -- | Error response.
    GetBitcoinReceiversReceiverTransactionsResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)

-- | Defines the object schema located at @paths.\/v1\/bitcoin\/receivers\/{receiver}\/transactions.GET.responses.200.content.application\/json.schema@ in the specification.
data GetBitcoinReceiversReceiverTransactionsResponseBody200 = GetBitcoinReceiversReceiverTransactionsResponseBody200
  { -- | data: Details about each object.
    getBitcoinReceiversReceiverTransactionsResponseBody200Data :: ([BitcoinTransaction]),
    -- | has_more: True if this list has another page of items after this one that can be fetched.
    getBitcoinReceiversReceiverTransactionsResponseBody200HasMore :: GHC.Types.Bool,
    -- | url: The URL where this list can be accessed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getBitcoinReceiversReceiverTransactionsResponseBody200Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetBitcoinReceiversReceiverTransactionsResponseBody200 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["data" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200Data obj] : ["has_more" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200HasMore obj] : ["url" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200Url obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["data" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200Data obj] : ["has_more" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200HasMore obj] : ["url" Data.Aeson.Types.ToJSON..= getBitcoinReceiversReceiverTransactionsResponseBody200Url obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GetBitcoinReceiversReceiverTransactionsResponseBody200 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetBitcoinReceiversReceiverTransactionsResponseBody200" (\obj -> ((GHC.Base.pure GetBitcoinReceiversReceiverTransactionsResponseBody200 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_more")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'GetBitcoinReceiversReceiverTransactionsResponseBody200' with all required fields.
mkGetBitcoinReceiversReceiverTransactionsResponseBody200 ::
  -- | 'getBitcoinReceiversReceiverTransactionsResponseBody200Data'
  [BitcoinTransaction] ->
  -- | 'getBitcoinReceiversReceiverTransactionsResponseBody200HasMore'
  GHC.Types.Bool ->
  -- | 'getBitcoinReceiversReceiverTransactionsResponseBody200Url'
  Data.Text.Internal.Text ->
  GetBitcoinReceiversReceiverTransactionsResponseBody200
mkGetBitcoinReceiversReceiverTransactionsResponseBody200 getBitcoinReceiversReceiverTransactionsResponseBody200Data getBitcoinReceiversReceiverTransactionsResponseBody200HasMore getBitcoinReceiversReceiverTransactionsResponseBody200Url =
  GetBitcoinReceiversReceiverTransactionsResponseBody200
    { getBitcoinReceiversReceiverTransactionsResponseBody200Data = getBitcoinReceiversReceiverTransactionsResponseBody200Data,
      getBitcoinReceiversReceiverTransactionsResponseBody200HasMore = getBitcoinReceiversReceiverTransactionsResponseBody200HasMore,
      getBitcoinReceiversReceiverTransactionsResponseBody200Url = getBitcoinReceiversReceiverTransactionsResponseBody200Url
    }
