{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation getSetupIntentsIntent
module StripeAPI.Operations.GetSetupIntentsIntent where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > GET /v1/setup_intents/{intent}
--
-- \<p>Retrieves the details of a SetupIntent that has previously been created. \<\/p>
--
-- \<p>Client-side retrieval using a publishable key is allowed when the \<code>client_secret\<\/code> is provided in the query string. \<\/p>
--
-- \<p>When retrieved with a publishable key, only a subset of properties will be returned. Please refer to the \<a href=\"\#setup_intent_object\">SetupIntent\<\/a> object reference for more details.\<\/p>
getSetupIntentsIntent ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | Contains all available parameters of this operation (query and path parameters)
  GetSetupIntentsIntentParameters ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response GetSetupIntentsIntentResponse)
getSetupIntentsIntent parameters =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either GetSetupIntentsIntentResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetSetupIntentsIntentResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            SetupIntent
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   GetSetupIntentsIntentResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    ( StripeAPI.Common.doCallWithConfigurationM
        (Data.Text.toUpper GHC.Base.$ Data.Text.pack "GET")
        (Data.Text.pack ("/v1/setup_intents/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel (getSetupIntentsIntentParametersPathIntent parameters))) GHC.Base.++ "")))
        [ StripeAPI.Common.QueryParameter (Data.Text.pack "client_secret") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSetupIntentsIntentParametersQueryClientSecret parameters) (Data.Text.pack "form") GHC.Types.True,
          StripeAPI.Common.QueryParameter (Data.Text.pack "expand") (Data.Aeson.Types.ToJSON.toJSON Data.Functor.<$> getSetupIntentsIntentParametersQueryExpand parameters) (Data.Text.pack "deepObject") GHC.Types.True
        ]
    )

-- | Defines the object schema located at @paths.\/v1\/setup_intents\/{intent}.GET.parameters@ in the specification.
data GetSetupIntentsIntentParameters = GetSetupIntentsIntentParameters
  { -- | pathIntent: Represents the parameter named \'intent\'
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getSetupIntentsIntentParametersPathIntent :: Data.Text.Internal.Text,
    -- | queryClient_secret: Represents the parameter named \'client_secret\'
    --
    -- The client secret of the SetupIntent. Required if a publishable key is used to retrieve the SetupIntent.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    getSetupIntentsIntentParametersQueryClientSecret :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | queryExpand: Represents the parameter named \'expand\'
    --
    -- Specifies which fields in the response should be expanded.
    getSetupIntentsIntentParametersQueryExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text]))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON GetSetupIntentsIntentParameters where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["pathIntent" Data.Aeson.Types.ToJSON..= getSetupIntentsIntentParametersPathIntent obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryClient_secret" Data.Aeson.Types.ToJSON..=)) (getSetupIntentsIntentParametersQueryClientSecret obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getSetupIntentsIntentParametersQueryExpand obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["pathIntent" Data.Aeson.Types.ToJSON..= getSetupIntentsIntentParametersPathIntent obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryClient_secret" Data.Aeson.Types.ToJSON..=)) (getSetupIntentsIntentParametersQueryClientSecret obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("queryExpand" Data.Aeson.Types.ToJSON..=)) (getSetupIntentsIntentParametersQueryExpand obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON GetSetupIntentsIntentParameters where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "GetSetupIntentsIntentParameters" (\obj -> ((GHC.Base.pure GetSetupIntentsIntentParameters GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "pathIntent")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryClient_secret")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "queryExpand"))

-- | Create a new 'GetSetupIntentsIntentParameters' with all required fields.
mkGetSetupIntentsIntentParameters ::
  -- | 'getSetupIntentsIntentParametersPathIntent'
  Data.Text.Internal.Text ->
  GetSetupIntentsIntentParameters
mkGetSetupIntentsIntentParameters getSetupIntentsIntentParametersPathIntent =
  GetSetupIntentsIntentParameters
    { getSetupIntentsIntentParametersPathIntent = getSetupIntentsIntentParametersPathIntent,
      getSetupIntentsIntentParametersQueryClientSecret = GHC.Maybe.Nothing,
      getSetupIntentsIntentParametersQueryExpand = GHC.Maybe.Nothing
    }

-- | Represents a response of the operation 'getSetupIntentsIntent'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'GetSetupIntentsIntentResponseError' is used.
data GetSetupIntentsIntentResponse
  = -- | Means either no matching case available or a parse error
    GetSetupIntentsIntentResponseError GHC.Base.String
  | -- | Successful response.
    GetSetupIntentsIntentResponse200 SetupIntent
  | -- | Error response.
    GetSetupIntentsIntentResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
