{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postBillingPortalConfigurationsConfiguration
module StripeAPI.Operations.PostBillingPortalConfigurationsConfiguration where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/billing_portal/configurations/{configuration}
--
-- \<p>Updates a configuration that describes the functionality of the customer portal.\<\/p>
postBillingPortalConfigurationsConfiguration ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | configuration | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostBillingPortalConfigurationsConfigurationResponse)
postBillingPortalConfigurationsConfiguration
  configuration
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostBillingPortalConfigurationsConfigurationResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostBillingPortalConfigurationsConfigurationResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              BillingPortal'configuration
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostBillingPortalConfigurationsConfigurationResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/billing_portal/configurations/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel configuration)) GHC.Base.++ ""))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBody = PostBillingPortalConfigurationsConfigurationRequestBody
  { -- | active: Whether the configuration is active and can be used to create portal sessions.
    postBillingPortalConfigurationsConfigurationRequestBodyActive :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | business_profile: The business information shown to customers in the portal.
    postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'),
    -- | default_return_url: The default URL to redirect customers to when they click on the portal\'s link to return to your website. This can be [overriden](https:\/\/stripe.com\/docs\/api\/customer_portal\/sessions\/create\#create_portal_session-return_url) when creating the session.
    postBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Variants),
    -- | expand: Specifies which fields in the response should be expanded.
    postBillingPortalConfigurationsConfigurationRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | features: Information about the features available in the portal.
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
    postBillingPortalConfigurationsConfigurationRequestBodyMetadata :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("active" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyActive obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("business_profile" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_return_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("features" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyMetadata obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("active" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyActive obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("business_profile" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_return_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("features" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyMetadata obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBody" (\obj -> (((((GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "active")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "business_profile")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "default_return_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "features")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBody' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBody :: PostBillingPortalConfigurationsConfigurationRequestBody
mkPostBillingPortalConfigurationsConfigurationRequestBody =
  PostBillingPortalConfigurationsConfigurationRequestBody
    { postBillingPortalConfigurationsConfigurationRequestBodyActive = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyExpand = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyMetadata = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.business_profile@ in the specification.
--
-- The business information shown to customers in the portal.
data PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' = PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'
  { -- | headline
    --
    -- Constraints:
    --
    -- * Maximum length of 60
    postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'Headline :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | privacy_policy_url
    postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Variants),
    -- | terms_of_service_url
    postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("headline" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'Headline obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("privacy_policy_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("terms_of_service_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("headline" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'Headline obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("privacy_policy_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("terms_of_service_url" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'" (\obj -> ((GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "headline")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "privacy_policy_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "terms_of_service_url"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' :: PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'
mkPostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile' =
  PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'
    { postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'Headline = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.business_profile.properties.privacy_policy_url.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'PrivacyPolicyUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.business_profile.properties.terms_of_service_url.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyBusinessProfile'TermsOfServiceUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.default_return_url.anyOf@ in the specification.
--
-- The default URL to redirect customers to when they click on the portal\'s link to return to your website. This can be [overriden](https:\/\/stripe.com\/docs\/api\/customer_portal\/sessions\/create\#create_portal_session-return_url) when creating the session.
data PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Text Data.Text.Internal.Text
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyDefaultReturnUrl'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features@ in the specification.
--
-- Information about the features available in the portal.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'
  { -- | customer_update
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'),
    -- | invoice_history
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'),
    -- | payment_method_update
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'),
    -- | subscription_cancel
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'),
    -- | subscription_pause
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'),
    -- | subscription_update
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("invoice_history" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_cancel" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_pause" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("invoice_history" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_cancel" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_pause" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_update" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'" (\obj -> (((((GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer_update")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "invoice_history")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_update")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "subscription_cancel")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "subscription_pause")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "subscription_update"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures' :: PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures' =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.customer_update@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'
  { -- | allowed_updates
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'Variants),
    -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'Enabled :: (GHC.Maybe.Maybe GHC.Types.Bool)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_updates" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'Enabled obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_updates" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'Enabled obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'" (\obj -> (GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allowed_updates")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "enabled"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' :: PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate' =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'Enabled = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.customer_update.properties.allowed_updates.anyOf.items@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"address"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumAddress
  | -- | Represents the JSON value @"email"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumEmail
  | -- | Represents the JSON value @"phone"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumPhone
  | -- | Represents the JSON value @"shipping"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumShipping
  | -- | Represents the JSON value @"tax_id"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumTaxId
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1 where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumAddress) = "address"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumEmail) = "email"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumPhone) = "phone"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumShipping) = "shipping"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumTaxId) = "tax_id"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1 where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "address" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumAddress
            | val GHC.Classes.== "email" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumEmail
            | val GHC.Classes.== "phone" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumPhone
            | val GHC.Classes.== "shipping" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumShipping
            | val GHC.Classes.== "tax_id" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1EnumTaxId
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.customer_update.properties.allowed_updates.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1 ([PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'CustomerUpdate'AllowedUpdates'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.invoice_history@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'
  { -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'" (\obj -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' ::
  -- | 'postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled'
  GHC.Types.Bool ->
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory' {postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled = postBillingPortalConfigurationsConfigurationRequestBodyFeatures'InvoiceHistory'Enabled}

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.payment_method_update@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'
  { -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'" (\obj -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' ::
  -- | 'postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled'
  GHC.Types.Bool ->
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate' {postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled = postBillingPortalConfigurationsConfigurationRequestBodyFeatures'PaymentMethodUpdate'Enabled}

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'
  { -- | cancellation_reason
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'),
    -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Enabled :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | mode
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'),
    -- | proration_behavior
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cancellation_reason" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Enabled obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mode" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("proration_behavior" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("cancellation_reason" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Enabled obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("mode" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("proration_behavior" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'" (\obj -> (((GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "cancellation_reason")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "mode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "proration_behavior"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' :: PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel' =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Enabled = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel.properties.cancellation_reason@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'
  { -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled :: GHC.Types.Bool,
    -- | options
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("options" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("options" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'" (\obj -> (GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "options"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' ::
  -- | 'postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled'
  GHC.Types.Bool ->
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason' postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled = postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Enabled,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel.properties.cancellation_reason.properties.options.anyOf.items@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"customer_service"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumCustomerService
  | -- | Represents the JSON value @"low_quality"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumLowQuality
  | -- | Represents the JSON value @"missing_features"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumMissingFeatures
  | -- | Represents the JSON value @"other"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumOther
  | -- | Represents the JSON value @"switched_service"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumSwitchedService
  | -- | Represents the JSON value @"too_complex"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooComplex
  | -- | Represents the JSON value @"too_expensive"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooExpensive
  | -- | Represents the JSON value @"unused"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumUnused
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1 where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumCustomerService) = "customer_service"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumLowQuality) = "low_quality"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumMissingFeatures) = "missing_features"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumOther) = "other"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumSwitchedService) = "switched_service"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooComplex) = "too_complex"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooExpensive) = "too_expensive"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumUnused) = "unused"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1 where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "customer_service" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumCustomerService
            | val GHC.Classes.== "low_quality" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumLowQuality
            | val GHC.Classes.== "missing_features" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumMissingFeatures
            | val GHC.Classes.== "other" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumOther
            | val GHC.Classes.== "switched_service" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumSwitchedService
            | val GHC.Classes.== "too_complex" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooComplex
            | val GHC.Classes.== "too_expensive" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumTooExpensive
            | val GHC.Classes.== "unused" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1EnumUnused
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel.properties.cancellation_reason.properties.options.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1 ([PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'CancellationReason'Options'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel.properties.mode@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"at_period_end"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumAtPeriodEnd
  | -- | Represents the JSON value @"immediately"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumImmediately
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode' where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumAtPeriodEnd) = "at_period_end"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumImmediately) = "immediately"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "at_period_end" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumAtPeriodEnd
            | val GHC.Classes.== "immediately" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'EnumImmediately
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'Mode'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_cancel.properties.proration_behavior@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always_invoice"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumAlwaysInvoice
  | -- | Represents the JSON value @"create_prorations"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumCreateProrations
  | -- | Represents the JSON value @"none"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior' where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumAlwaysInvoice) = "always_invoice"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumCreateProrations) = "create_prorations"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always_invoice" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumAlwaysInvoice
            | val GHC.Classes.== "create_prorations" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumCreateProrations
            | val GHC.Classes.== "none" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'EnumNone
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionCancel'ProrationBehavior'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_pause@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'
  { -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'Enabled :: (GHC.Maybe.Maybe GHC.Types.Bool)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'Enabled obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'Enabled obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'" (\obj -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "enabled"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' :: PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause' {postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionPause'Enabled = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'
  { -- | default_allowed_updates
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'Variants),
    -- | enabled
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Enabled :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | products
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'Variants),
    -- | proration_behavior
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior :: (GHC.Maybe.Maybe PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_allowed_updates" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Enabled obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("products" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("proration_behavior" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("default_allowed_updates" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("enabled" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Enabled obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("products" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("proration_behavior" Data.Aeson.Types.ToJSON..=)) (postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'" (\obj -> (((GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "default_allowed_updates")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "products")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "proration_behavior"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' :: PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate' =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Enabled = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products = GHC.Maybe.Nothing,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update.properties.default_allowed_updates.anyOf.items@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"price"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPrice
  | -- | Represents the JSON value @"promotion_code"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPromotionCode
  | -- | Represents the JSON value @"quantity"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumQuantity
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1 where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPrice) = "price"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPromotionCode) = "promotion_code"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumQuantity) = "quantity"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1 where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "price" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPrice
            | val GHC.Classes.== "promotion_code" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumPromotionCode
            | val GHC.Classes.== "quantity" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1EnumQuantity
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update.properties.default_allowed_updates.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1 ([PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'DefaultAllowedUpdates'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update.properties.products.anyOf.items@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 = PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1
  { -- | prices
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices :: ([Data.Text.Internal.Text]),
    -- | product
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["prices" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices obj] : ["product" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["prices" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices obj] : ["product" Data.Aeson.Types.ToJSON..= postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1" (\obj -> (GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "prices")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "product"))

-- | Create a new 'PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1' with all required fields.
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 ::
  -- | 'postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices'
  [Data.Text.Internal.Text] ->
  -- | 'postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product'
  Data.Text.Internal.Text ->
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1
mkPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product =
  PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1
    { postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices = postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Prices,
      postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product = postBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1Product
    }

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update.properties.products.anyOf@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 ([PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1])
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'ListTPostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'Products'OneOf1 Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the enum schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.features.properties.subscription_update.properties.proration_behavior@ in the specification.
data PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always_invoice"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumAlwaysInvoice
  | -- | Represents the JSON value @"create_prorations"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumCreateProrations
  | -- | Represents the JSON value @"none"@
    PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumNone
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior' where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'Other val) = val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumAlwaysInvoice) = "always_invoice"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumCreateProrations) = "create_prorations"
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumNone) = "none"

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always_invoice" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumAlwaysInvoice
            | val GHC.Classes.== "create_prorations" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumCreateProrations
            | val GHC.Classes.== "none" -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'EnumNone
            | GHC.Base.otherwise -> PostBillingPortalConfigurationsConfigurationRequestBodyFeatures'SubscriptionUpdate'ProrationBehavior'Other val
      )

-- | Defines the oneOf schema located at @paths.\/v1\/billing_portal\/configurations\/{configuration}.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.metadata.anyOf@ in the specification.
--
-- Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`.
data PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Variants
  = -- | Represents the JSON value @""@
    PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'EmptyString
  | PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Object Data.Aeson.Types.Internal.Object
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Variants where
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Object a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'EmptyString) = ""

instance Data.Aeson.Types.FromJSON.FromJSON PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Variants where
  parseJSON val =
    if
        | val GHC.Classes.== "" -> GHC.Base.pure PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'EmptyString
        | GHC.Base.otherwise -> case (PostBillingPortalConfigurationsConfigurationRequestBodyMetadata'Object Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched" of
          Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
          Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Represents a response of the operation 'postBillingPortalConfigurationsConfiguration'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostBillingPortalConfigurationsConfigurationResponseError' is used.
data PostBillingPortalConfigurationsConfigurationResponse
  = -- | Means either no matching case available or a parse error
    PostBillingPortalConfigurationsConfigurationResponseError GHC.Base.String
  | -- | Successful response.
    PostBillingPortalConfigurationsConfigurationResponse200 BillingPortal'configuration
  | -- | Error response.
    PostBillingPortalConfigurationsConfigurationResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
