{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postPaymentLinks
module StripeAPI.Operations.PostPaymentLinks where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/payment_links
--
-- \<p>Creates a payment link.\<\/p>
postPaymentLinks ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | The request body to send
  PostPaymentLinksRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostPaymentLinksResponse)
postPaymentLinks body =
  GHC.Base.fmap
    ( \response_0 ->
        GHC.Base.fmap
          ( Data.Either.either PostPaymentLinksResponseError GHC.Base.id
              GHC.Base.. ( \response body ->
                             if
                                 | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostPaymentLinksResponse200
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            PaymentLink
                                                      )
                                 | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                   PostPaymentLinksResponseDefault
                                     Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                          Data.Either.Either
                                                            GHC.Base.String
                                                            Error
                                                      )
                                 | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                         )
                response_0
          )
          response_0
    )
    (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack "/v1/payment_links") GHC.Base.mempty (GHC.Maybe.Just body) StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostPaymentLinksRequestBody = PostPaymentLinksRequestBody
  { -- | after_completion: Behavior after the purchase is complete.
    postPaymentLinksRequestBodyAfterCompletion :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyAfterCompletion'),
    -- | allow_promotion_codes: Enables user redeemable promotion codes.
    postPaymentLinksRequestBodyAllowPromotionCodes :: (GHC.Maybe.Maybe GHC.Types.Bool),
    -- | application_fee_amount: The amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner\'s Stripe account. Can only be applied when there are no line items with recurring prices.
    postPaymentLinksRequestBodyApplicationFeeAmount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | application_fee_percent: A non-negative decimal between 0 and 100, with at most two decimal places. This represents the percentage of the subscription invoice subtotal that will be transferred to the application owner\'s Stripe account. There must be at least 1 line item with a recurring price to use this field.
    postPaymentLinksRequestBodyApplicationFeePercent :: (GHC.Maybe.Maybe GHC.Types.Double),
    -- | automatic_tax: Configuration for automatic tax collection.
    postPaymentLinksRequestBodyAutomaticTax :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyAutomaticTax'),
    -- | billing_address_collection: Configuration for collecting the customer\'s billing address.
    postPaymentLinksRequestBodyBillingAddressCollection :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyBillingAddressCollection'),
    -- | consent_collection: Configure fields to gather active consent from customers.
    postPaymentLinksRequestBodyConsentCollection :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyConsentCollection'),
    -- | customer_creation: Configures whether [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link create a [Customer](https:\/\/stripe.com\/docs\/api\/customers).
    postPaymentLinksRequestBodyCustomerCreation :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyCustomerCreation'),
    -- | expand: Specifies which fields in the response should be expanded.
    postPaymentLinksRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | line_items: The line items representing what is being sold. Each line item represents an item being sold. Up to 20 line items are supported.
    postPaymentLinksRequestBodyLineItems :: ([PostPaymentLinksRequestBodyLineItems']),
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format. Individual keys can be unset by posting an empty value to them. All keys can be unset by posting an empty value to \`metadata\`. Metadata associated with this Payment Link will automatically be copied to [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link.
    postPaymentLinksRequestBodyMetadata :: (GHC.Maybe.Maybe Data.Aeson.Types.Internal.Object),
    -- | on_behalf_of: The account on behalf of which to charge.
    postPaymentLinksRequestBodyOnBehalfOf :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | payment_intent_data: A subset of parameters to be passed to PaymentIntent creation for Checkout Sessions in \`payment\` mode.
    postPaymentLinksRequestBodyPaymentIntentData :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyPaymentIntentData'),
    -- | payment_method_types: The list of payment method types that customers can use. If no value is passed, Stripe will dynamically show relevant payment methods from your [payment method settings](https:\/\/dashboard.stripe.com\/settings\/payment_methods) (20+ payment methods [supported](https:\/\/stripe.com\/docs\/payments\/payment-methods\/integration-options\#payment-method-product-support)).
    postPaymentLinksRequestBodyPaymentMethodTypes :: (GHC.Maybe.Maybe ([PostPaymentLinksRequestBodyPaymentMethodTypes'])),
    -- | phone_number_collection: Controls phone number collection settings during checkout.
    --
    -- We recommend that you review your privacy policy and check with your legal contacts.
    postPaymentLinksRequestBodyPhoneNumberCollection :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyPhoneNumberCollection'),
    -- | shipping_address_collection: Configuration for collecting the customer\'s shipping address.
    postPaymentLinksRequestBodyShippingAddressCollection :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyShippingAddressCollection'),
    -- | shipping_options: The shipping rate options to apply to [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link.
    postPaymentLinksRequestBodyShippingOptions :: (GHC.Maybe.Maybe ([PostPaymentLinksRequestBodyShippingOptions'])),
    -- | submit_type: Describes the type of transaction being performed in order to customize relevant text on the page, such as the submit button.
    postPaymentLinksRequestBodySubmitType :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodySubmitType'),
    -- | subscription_data: When creating a subscription, the specified configuration data will be used. There must be at least one line item with a recurring price to use \`subscription_data\`.
    postPaymentLinksRequestBodySubscriptionData :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodySubscriptionData'),
    -- | tax_id_collection: Controls tax ID collection during checkout.
    postPaymentLinksRequestBodyTaxIdCollection :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyTaxIdCollection'),
    -- | transfer_data: The account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to.
    postPaymentLinksRequestBodyTransferData :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyTransferData')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("after_completion" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allow_promotion_codes" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAllowPromotionCodes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_percent" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyApplicationFeePercent obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyBillingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("consent_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyConsentCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_creation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyCustomerCreation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyExpand obj) : ["line_items" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_intent_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPhoneNumberCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_options" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("submit_type" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubmitType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubscriptionData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTaxIdCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTransferData obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("after_completion" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allow_promotion_codes" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAllowPromotionCodes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_percent" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyApplicationFeePercent obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("automatic_tax" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAutomaticTax obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("billing_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyBillingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("consent_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyConsentCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("customer_creation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyCustomerCreation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyExpand obj) : ["line_items" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("metadata" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyMetadata obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_intent_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentMethodTypes obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPhoneNumberCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingAddressCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_options" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingOptions obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("submit_type" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubmitType obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubscriptionData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id_collection" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTaxIdCollection obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTransferData obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBody" (\obj -> ((((((((((((((((((((GHC.Base.pure PostPaymentLinksRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "after_completion")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allow_promotion_codes")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "application_fee_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "application_fee_percent")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "automatic_tax")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "billing_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "consent_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "customer_creation")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "line_items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "on_behalf_of")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_intent_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone_number_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "submit_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "subscription_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_id_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transfer_data"))

-- | Create a new 'PostPaymentLinksRequestBody' with all required fields.
mkPostPaymentLinksRequestBody ::
  -- | 'postPaymentLinksRequestBodyLineItems'
  [PostPaymentLinksRequestBodyLineItems'] ->
  PostPaymentLinksRequestBody
mkPostPaymentLinksRequestBody postPaymentLinksRequestBodyLineItems =
  PostPaymentLinksRequestBody
    { postPaymentLinksRequestBodyAfterCompletion = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyAllowPromotionCodes = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyApplicationFeeAmount = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyApplicationFeePercent = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyAutomaticTax = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyBillingAddressCollection = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyConsentCollection = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyCustomerCreation = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyExpand = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyLineItems = postPaymentLinksRequestBodyLineItems,
      postPaymentLinksRequestBodyMetadata = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyOnBehalfOf = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyPaymentIntentData = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyPaymentMethodTypes = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyPhoneNumberCollection = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyShippingAddressCollection = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyShippingOptions = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodySubmitType = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodySubscriptionData = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyTaxIdCollection = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyTransferData = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion@ in the specification.
--
-- Behavior after the purchase is complete.
data PostPaymentLinksRequestBodyAfterCompletion' = PostPaymentLinksRequestBodyAfterCompletion'
  { -- | hosted_confirmation
    postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'),
    -- | redirect
    postPaymentLinksRequestBodyAfterCompletion'Redirect :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyAfterCompletion'Redirect'),
    -- | type
    postPaymentLinksRequestBodyAfterCompletion'Type :: PostPaymentLinksRequestBodyAfterCompletion'Type'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyAfterCompletion' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_confirmation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("redirect" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'Redirect obj) : ["type" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAfterCompletion'Type obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("hosted_confirmation" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("redirect" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'Redirect obj) : ["type" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAfterCompletion'Type obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyAfterCompletion' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyAfterCompletion'" (\obj -> ((GHC.Base.pure PostPaymentLinksRequestBodyAfterCompletion' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "hosted_confirmation")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "redirect")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'PostPaymentLinksRequestBodyAfterCompletion'' with all required fields.
mkPostPaymentLinksRequestBodyAfterCompletion' ::
  -- | 'postPaymentLinksRequestBodyAfterCompletion'Type'
  PostPaymentLinksRequestBodyAfterCompletion'Type' ->
  PostPaymentLinksRequestBodyAfterCompletion'
mkPostPaymentLinksRequestBodyAfterCompletion' postPaymentLinksRequestBodyAfterCompletion'Type =
  PostPaymentLinksRequestBodyAfterCompletion'
    { postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyAfterCompletion'Redirect = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyAfterCompletion'Type = postPaymentLinksRequestBodyAfterCompletion'Type
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.hosted_confirmation@ in the specification.
data PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' = PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'
  { -- | custom_message
    --
    -- Constraints:
    --
    -- * Maximum length of 500
    postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'CustomMessage :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_message" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'CustomMessage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("custom_message" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'CustomMessage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "custom_message"))

-- | Create a new 'PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'' with all required fields.
mkPostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' :: PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'
mkPostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' = PostPaymentLinksRequestBodyAfterCompletion'HostedConfirmation' {postPaymentLinksRequestBodyAfterCompletion'HostedConfirmation'CustomMessage = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.redirect@ in the specification.
data PostPaymentLinksRequestBodyAfterCompletion'Redirect' = PostPaymentLinksRequestBodyAfterCompletion'Redirect'
  { -- | url
    --
    -- Constraints:
    --
    -- * Maximum length of 2048
    postPaymentLinksRequestBodyAfterCompletion'Redirect'Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyAfterCompletion'Redirect' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["url" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAfterCompletion'Redirect'Url obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["url" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAfterCompletion'Redirect'Url obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyAfterCompletion'Redirect' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyAfterCompletion'Redirect'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyAfterCompletion'Redirect' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'PostPaymentLinksRequestBodyAfterCompletion'Redirect'' with all required fields.
mkPostPaymentLinksRequestBodyAfterCompletion'Redirect' ::
  -- | 'postPaymentLinksRequestBodyAfterCompletion'Redirect'Url'
  Data.Text.Internal.Text ->
  PostPaymentLinksRequestBodyAfterCompletion'Redirect'
mkPostPaymentLinksRequestBodyAfterCompletion'Redirect' postPaymentLinksRequestBodyAfterCompletion'Redirect'Url = PostPaymentLinksRequestBodyAfterCompletion'Redirect' {postPaymentLinksRequestBodyAfterCompletion'Redirect'Url = postPaymentLinksRequestBodyAfterCompletion'Redirect'Url}

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.after_completion.properties.type@ in the specification.
data PostPaymentLinksRequestBodyAfterCompletion'Type'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyAfterCompletion'Type'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyAfterCompletion'Type'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"hosted_confirmation"@
    PostPaymentLinksRequestBodyAfterCompletion'Type'EnumHostedConfirmation
  | -- | Represents the JSON value @"redirect"@
    PostPaymentLinksRequestBodyAfterCompletion'Type'EnumRedirect
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyAfterCompletion'Type' where
  toJSON (PostPaymentLinksRequestBodyAfterCompletion'Type'Other val) = val
  toJSON (PostPaymentLinksRequestBodyAfterCompletion'Type'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyAfterCompletion'Type'EnumHostedConfirmation) = "hosted_confirmation"
  toJSON (PostPaymentLinksRequestBodyAfterCompletion'Type'EnumRedirect) = "redirect"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyAfterCompletion'Type' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "hosted_confirmation" -> PostPaymentLinksRequestBodyAfterCompletion'Type'EnumHostedConfirmation
            | val GHC.Classes.== "redirect" -> PostPaymentLinksRequestBodyAfterCompletion'Type'EnumRedirect
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyAfterCompletion'Type'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.automatic_tax@ in the specification.
--
-- Configuration for automatic tax collection.
data PostPaymentLinksRequestBodyAutomaticTax' = PostPaymentLinksRequestBodyAutomaticTax'
  { -- | enabled
    postPaymentLinksRequestBodyAutomaticTax'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyAutomaticTax' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyAutomaticTax'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyAutomaticTax' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyAutomaticTax'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyAutomaticTax' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostPaymentLinksRequestBodyAutomaticTax'' with all required fields.
mkPostPaymentLinksRequestBodyAutomaticTax' ::
  -- | 'postPaymentLinksRequestBodyAutomaticTax'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksRequestBodyAutomaticTax'
mkPostPaymentLinksRequestBodyAutomaticTax' postPaymentLinksRequestBodyAutomaticTax'Enabled = PostPaymentLinksRequestBodyAutomaticTax' {postPaymentLinksRequestBodyAutomaticTax'Enabled = postPaymentLinksRequestBodyAutomaticTax'Enabled}

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.billing_address_collection@ in the specification.
--
-- Configuration for collecting the customer\'s billing address.
data PostPaymentLinksRequestBodyBillingAddressCollection'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyBillingAddressCollection'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyBillingAddressCollection'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostPaymentLinksRequestBodyBillingAddressCollection'EnumAuto
  | -- | Represents the JSON value @"required"@
    PostPaymentLinksRequestBodyBillingAddressCollection'EnumRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyBillingAddressCollection' where
  toJSON (PostPaymentLinksRequestBodyBillingAddressCollection'Other val) = val
  toJSON (PostPaymentLinksRequestBodyBillingAddressCollection'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyBillingAddressCollection'EnumAuto) = "auto"
  toJSON (PostPaymentLinksRequestBodyBillingAddressCollection'EnumRequired) = "required"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyBillingAddressCollection' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostPaymentLinksRequestBodyBillingAddressCollection'EnumAuto
            | val GHC.Classes.== "required" -> PostPaymentLinksRequestBodyBillingAddressCollection'EnumRequired
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyBillingAddressCollection'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.consent_collection@ in the specification.
--
-- Configure fields to gather active consent from customers.
data PostPaymentLinksRequestBodyConsentCollection' = PostPaymentLinksRequestBodyConsentCollection'
  { -- | promotions
    postPaymentLinksRequestBodyConsentCollection'Promotions :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyConsentCollection'Promotions')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyConsentCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotions" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyConsentCollection'Promotions obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotions" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyConsentCollection'Promotions obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyConsentCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyConsentCollection'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyConsentCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "promotions"))

-- | Create a new 'PostPaymentLinksRequestBodyConsentCollection'' with all required fields.
mkPostPaymentLinksRequestBodyConsentCollection' :: PostPaymentLinksRequestBodyConsentCollection'
mkPostPaymentLinksRequestBodyConsentCollection' = PostPaymentLinksRequestBodyConsentCollection' {postPaymentLinksRequestBodyConsentCollection'Promotions = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.consent_collection.properties.promotions@ in the specification.
data PostPaymentLinksRequestBodyConsentCollection'Promotions'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyConsentCollection'Promotions'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyConsentCollection'Promotions'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostPaymentLinksRequestBodyConsentCollection'Promotions'EnumAuto
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyConsentCollection'Promotions' where
  toJSON (PostPaymentLinksRequestBodyConsentCollection'Promotions'Other val) = val
  toJSON (PostPaymentLinksRequestBodyConsentCollection'Promotions'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyConsentCollection'Promotions'EnumAuto) = "auto"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyConsentCollection'Promotions' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostPaymentLinksRequestBodyConsentCollection'Promotions'EnumAuto
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyConsentCollection'Promotions'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.customer_creation@ in the specification.
--
-- Configures whether [checkout sessions](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) created by this payment link create a [Customer](https:\/\/stripe.com\/docs\/api\/customers).
data PostPaymentLinksRequestBodyCustomerCreation'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyCustomerCreation'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyCustomerCreation'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always"@
    PostPaymentLinksRequestBodyCustomerCreation'EnumAlways
  | -- | Represents the JSON value @"if_required"@
    PostPaymentLinksRequestBodyCustomerCreation'EnumIfRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyCustomerCreation' where
  toJSON (PostPaymentLinksRequestBodyCustomerCreation'Other val) = val
  toJSON (PostPaymentLinksRequestBodyCustomerCreation'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyCustomerCreation'EnumAlways) = "always"
  toJSON (PostPaymentLinksRequestBodyCustomerCreation'EnumIfRequired) = "if_required"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyCustomerCreation' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always" -> PostPaymentLinksRequestBodyCustomerCreation'EnumAlways
            | val GHC.Classes.== "if_required" -> PostPaymentLinksRequestBodyCustomerCreation'EnumIfRequired
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyCustomerCreation'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items@ in the specification.
data PostPaymentLinksRequestBodyLineItems' = PostPaymentLinksRequestBodyLineItems'
  { -- | adjustable_quantity
    postPaymentLinksRequestBodyLineItems'AdjustableQuantity :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'),
    -- | price
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postPaymentLinksRequestBodyLineItems'Price :: Data.Text.Internal.Text,
    -- | quantity
    postPaymentLinksRequestBodyLineItems'Quantity :: GHC.Types.Int
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyLineItems' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("adjustable_quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity obj) : ["price" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'Price obj] : ["quantity" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'Quantity obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("adjustable_quantity" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity obj) : ["price" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'Price obj] : ["quantity" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'Quantity obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyLineItems' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyLineItems'" (\obj -> ((GHC.Base.pure PostPaymentLinksRequestBodyLineItems' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "adjustable_quantity")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "price")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "quantity"))

-- | Create a new 'PostPaymentLinksRequestBodyLineItems'' with all required fields.
mkPostPaymentLinksRequestBodyLineItems' ::
  -- | 'postPaymentLinksRequestBodyLineItems'Price'
  Data.Text.Internal.Text ->
  -- | 'postPaymentLinksRequestBodyLineItems'Quantity'
  GHC.Types.Int ->
  PostPaymentLinksRequestBodyLineItems'
mkPostPaymentLinksRequestBodyLineItems' postPaymentLinksRequestBodyLineItems'Price postPaymentLinksRequestBodyLineItems'Quantity =
  PostPaymentLinksRequestBodyLineItems'
    { postPaymentLinksRequestBodyLineItems'AdjustableQuantity = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyLineItems'Price = postPaymentLinksRequestBodyLineItems'Price,
      postPaymentLinksRequestBodyLineItems'Quantity = postPaymentLinksRequestBodyLineItems'Quantity
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.line_items.items.properties.adjustable_quantity@ in the specification.
data PostPaymentLinksRequestBodyLineItems'AdjustableQuantity' = PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'
  { -- | enabled
    postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled :: GHC.Types.Bool,
    -- | maximum
    postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Maximum :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | minimum
    postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Minimum :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyLineItems'AdjustableQuantity' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Minimum obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("maximum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Maximum obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("minimum" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Minimum obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyLineItems'AdjustableQuantity' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'" (\obj -> ((GHC.Base.pure PostPaymentLinksRequestBodyLineItems'AdjustableQuantity' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "maximum")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "minimum"))

-- | Create a new 'PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'' with all required fields.
mkPostPaymentLinksRequestBodyLineItems'AdjustableQuantity' ::
  -- | 'postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'
mkPostPaymentLinksRequestBodyLineItems'AdjustableQuantity' postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled =
  PostPaymentLinksRequestBodyLineItems'AdjustableQuantity'
    { postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled = postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Enabled,
      postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Maximum = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyLineItems'AdjustableQuantity'Minimum = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data@ in the specification.
--
-- A subset of parameters to be passed to PaymentIntent creation for Checkout Sessions in \`payment\` mode.
data PostPaymentLinksRequestBodyPaymentIntentData' = PostPaymentLinksRequestBodyPaymentIntentData'
  { -- | capture_method
    postPaymentLinksRequestBodyPaymentIntentData'CaptureMethod :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'),
    -- | setup_future_usage
    postPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage :: (GHC.Maybe.Maybe PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyPaymentIntentData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData'CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData'CaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyPaymentIntentData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyPaymentIntentData'" (\obj -> (GHC.Base.pure PostPaymentLinksRequestBodyPaymentIntentData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PostPaymentLinksRequestBodyPaymentIntentData'' with all required fields.
mkPostPaymentLinksRequestBodyPaymentIntentData' :: PostPaymentLinksRequestBodyPaymentIntentData'
mkPostPaymentLinksRequestBodyPaymentIntentData' =
  PostPaymentLinksRequestBodyPaymentIntentData'
    { postPaymentLinksRequestBodyPaymentIntentData'CaptureMethod = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.capture_method@ in the specification.
data PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod' where
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'Other val) = val
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic) = "automatic"
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'EnumManual
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyPaymentIntentData'CaptureMethod'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_intent_data.properties.setup_future_usage@ in the specification.
data PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"off_session"@
    PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage' where
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'Other val) = val
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "off_session" -> PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyPaymentIntentData'SetupFutureUsage'Other val
      )

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.payment_method_types.items@ in the specification.
data PostPaymentLinksRequestBodyPaymentMethodTypes'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyPaymentMethodTypes'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyPaymentMethodTypes'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"card"@
    PostPaymentLinksRequestBodyPaymentMethodTypes'EnumCard
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyPaymentMethodTypes' where
  toJSON (PostPaymentLinksRequestBodyPaymentMethodTypes'Other val) = val
  toJSON (PostPaymentLinksRequestBodyPaymentMethodTypes'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyPaymentMethodTypes'EnumCard) = "card"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyPaymentMethodTypes' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "card" -> PostPaymentLinksRequestBodyPaymentMethodTypes'EnumCard
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyPaymentMethodTypes'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.phone_number_collection@ in the specification.
--
-- Controls phone number collection settings during checkout.
--
-- We recommend that you review your privacy policy and check with your legal contacts.
data PostPaymentLinksRequestBodyPhoneNumberCollection' = PostPaymentLinksRequestBodyPhoneNumberCollection'
  { -- | enabled
    postPaymentLinksRequestBodyPhoneNumberCollection'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyPhoneNumberCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyPhoneNumberCollection'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyPhoneNumberCollection'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyPhoneNumberCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyPhoneNumberCollection'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyPhoneNumberCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostPaymentLinksRequestBodyPhoneNumberCollection'' with all required fields.
mkPostPaymentLinksRequestBodyPhoneNumberCollection' ::
  -- | 'postPaymentLinksRequestBodyPhoneNumberCollection'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksRequestBodyPhoneNumberCollection'
mkPostPaymentLinksRequestBodyPhoneNumberCollection' postPaymentLinksRequestBodyPhoneNumberCollection'Enabled = PostPaymentLinksRequestBodyPhoneNumberCollection' {postPaymentLinksRequestBodyPhoneNumberCollection'Enabled = postPaymentLinksRequestBodyPhoneNumberCollection'Enabled}

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection@ in the specification.
--
-- Configuration for collecting the customer\'s shipping address.
data PostPaymentLinksRequestBodyShippingAddressCollection' = PostPaymentLinksRequestBodyShippingAddressCollection'
  { -- | allowed_countries
    postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries :: ([PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'])
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyShippingAddressCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["allowed_countries" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyShippingAddressCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyShippingAddressCollection'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyShippingAddressCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allowed_countries"))

-- | Create a new 'PostPaymentLinksRequestBodyShippingAddressCollection'' with all required fields.
mkPostPaymentLinksRequestBodyShippingAddressCollection' ::
  -- | 'postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'
  [PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'] ->
  PostPaymentLinksRequestBodyShippingAddressCollection'
mkPostPaymentLinksRequestBodyShippingAddressCollection' postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries = PostPaymentLinksRequestBodyShippingAddressCollection' {postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries = postPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries}

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_address_collection.properties.allowed_countries.items@ in the specification.
data PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries' where
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'Other val) = val
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAC) = "AC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAD) = "AD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAE) = "AE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAF) = "AF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAG) = "AG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAI) = "AI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAL) = "AL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAM) = "AM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAO) = "AO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ) = "AQ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAR) = "AR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAT) = "AT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAU) = "AU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAW) = "AW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAX) = "AX"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ) = "AZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBA) = "BA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBB) = "BB"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBD) = "BD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBE) = "BE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBF) = "BF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBG) = "BG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBH) = "BH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBI) = "BI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ) = "BJ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBL) = "BL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBM) = "BM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBN) = "BN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBO) = "BO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ) = "BQ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBR) = "BR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBS) = "BS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBT) = "BT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBV) = "BV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBW) = "BW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBY) = "BY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ) = "BZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCA) = "CA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCD) = "CD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCF) = "CF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCG) = "CG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCH) = "CH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCI) = "CI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCK) = "CK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCL) = "CL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCM) = "CM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCN) = "CN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCO) = "CO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCR) = "CR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCV) = "CV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCW) = "CW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCY) = "CY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ) = "CZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDE) = "DE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ) = "DJ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDK) = "DK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDM) = "DM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDO) = "DO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ) = "DZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEC) = "EC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEE) = "EE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEG) = "EG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEH) = "EH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumER) = "ER"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumES) = "ES"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumET) = "ET"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFI) = "FI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ) = "FJ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFK) = "FK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFO) = "FO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFR) = "FR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGA) = "GA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGB) = "GB"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGD) = "GD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGE) = "GE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGF) = "GF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGG) = "GG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGH) = "GH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGI) = "GI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGL) = "GL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGM) = "GM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGN) = "GN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGP) = "GP"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ) = "GQ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGR) = "GR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGS) = "GS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGT) = "GT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGU) = "GU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGW) = "GW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGY) = "GY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHK) = "HK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHN) = "HN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHR) = "HR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHT) = "HT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHU) = "HU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumID) = "ID"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIE) = "IE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIL) = "IL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIM) = "IM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIN) = "IN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIO) = "IO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ) = "IQ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIS) = "IS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIT) = "IT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJE) = "JE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJM) = "JM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJO) = "JO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJP) = "JP"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKE) = "KE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKG) = "KG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKH) = "KH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKI) = "KI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKM) = "KM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKN) = "KN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKR) = "KR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKW) = "KW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKY) = "KY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ) = "KZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLA) = "LA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLB) = "LB"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLC) = "LC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLI) = "LI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLK) = "LK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLR) = "LR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLS) = "LS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLT) = "LT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLU) = "LU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLV) = "LV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLY) = "LY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMA) = "MA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMC) = "MC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMD) = "MD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumME) = "ME"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMF) = "MF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMG) = "MG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMK) = "MK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumML) = "ML"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMM) = "MM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMN) = "MN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMO) = "MO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ) = "MQ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMR) = "MR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMS) = "MS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMT) = "MT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMU) = "MU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMV) = "MV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMW) = "MW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMX) = "MX"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMY) = "MY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ) = "MZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNA) = "NA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNC) = "NC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNE) = "NE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNG) = "NG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNI) = "NI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNL) = "NL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNO) = "NO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNP) = "NP"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNR) = "NR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNU) = "NU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ) = "NZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumOM) = "OM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPA) = "PA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPE) = "PE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPF) = "PF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPG) = "PG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPH) = "PH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPK) = "PK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPL) = "PL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPM) = "PM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPN) = "PN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPR) = "PR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPS) = "PS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPT) = "PT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPY) = "PY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumQA) = "QA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRE) = "RE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRO) = "RO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRS) = "RS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRU) = "RU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRW) = "RW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSA) = "SA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSB) = "SB"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSC) = "SC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSE) = "SE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSG) = "SG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSH) = "SH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSI) = "SI"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ) = "SJ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSK) = "SK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSL) = "SL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSM) = "SM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSN) = "SN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSO) = "SO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSR) = "SR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSS) = "SS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumST) = "ST"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSV) = "SV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSX) = "SX"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ) = "SZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTA) = "TA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTC) = "TC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTD) = "TD"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTF) = "TF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTG) = "TG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTH) = "TH"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ) = "TJ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTK) = "TK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTL) = "TL"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTM) = "TM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTN) = "TN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTO) = "TO"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTR) = "TR"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTT) = "TT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTV) = "TV"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTW) = "TW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ) = "TZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUA) = "UA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUG) = "UG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUS) = "US"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUY) = "UY"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ) = "UZ"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVA) = "VA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVC) = "VC"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVE) = "VE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVG) = "VG"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVN) = "VN"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVU) = "VU"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWF) = "WF"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWS) = "WS"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumXK) = "XK"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYE) = "YE"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYT) = "YT"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZA) = "ZA"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZM) = "ZM"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZW) = "ZW"
  toJSON (PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodyShippingAddressCollection'AllowedCountries'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.shipping_options.items@ in the specification.
data PostPaymentLinksRequestBodyShippingOptions' = PostPaymentLinksRequestBodyShippingOptions'
  { -- | shipping_rate
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    postPaymentLinksRequestBodyShippingOptions'ShippingRate :: (GHC.Maybe.Maybe Data.Text.Internal.Text)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyShippingOptions' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingOptions'ShippingRate obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_rate" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyShippingOptions'ShippingRate obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyShippingOptions' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyShippingOptions'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyShippingOptions' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_rate"))

-- | Create a new 'PostPaymentLinksRequestBodyShippingOptions'' with all required fields.
mkPostPaymentLinksRequestBodyShippingOptions' :: PostPaymentLinksRequestBodyShippingOptions'
mkPostPaymentLinksRequestBodyShippingOptions' = PostPaymentLinksRequestBodyShippingOptions' {postPaymentLinksRequestBodyShippingOptions'ShippingRate = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.submit_type@ in the specification.
--
-- Describes the type of transaction being performed in order to customize relevant text on the page, such as the submit button.
data PostPaymentLinksRequestBodySubmitType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostPaymentLinksRequestBodySubmitType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostPaymentLinksRequestBodySubmitType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PostPaymentLinksRequestBodySubmitType'EnumAuto
  | -- | Represents the JSON value @"book"@
    PostPaymentLinksRequestBodySubmitType'EnumBook
  | -- | Represents the JSON value @"donate"@
    PostPaymentLinksRequestBodySubmitType'EnumDonate
  | -- | Represents the JSON value @"pay"@
    PostPaymentLinksRequestBodySubmitType'EnumPay
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodySubmitType' where
  toJSON (PostPaymentLinksRequestBodySubmitType'Other val) = val
  toJSON (PostPaymentLinksRequestBodySubmitType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostPaymentLinksRequestBodySubmitType'EnumAuto) = "auto"
  toJSON (PostPaymentLinksRequestBodySubmitType'EnumBook) = "book"
  toJSON (PostPaymentLinksRequestBodySubmitType'EnumDonate) = "donate"
  toJSON (PostPaymentLinksRequestBodySubmitType'EnumPay) = "pay"

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodySubmitType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PostPaymentLinksRequestBodySubmitType'EnumAuto
            | val GHC.Classes.== "book" -> PostPaymentLinksRequestBodySubmitType'EnumBook
            | val GHC.Classes.== "donate" -> PostPaymentLinksRequestBodySubmitType'EnumDonate
            | val GHC.Classes.== "pay" -> PostPaymentLinksRequestBodySubmitType'EnumPay
            | GHC.Base.otherwise -> PostPaymentLinksRequestBodySubmitType'Other val
      )

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.subscription_data@ in the specification.
--
-- When creating a subscription, the specified configuration data will be used. There must be at least one line item with a recurring price to use \`subscription_data\`.
data PostPaymentLinksRequestBodySubscriptionData' = PostPaymentLinksRequestBodySubscriptionData'
  { -- | trial_period_days
    postPaymentLinksRequestBodySubscriptionData'TrialPeriodDays :: (GHC.Maybe.Maybe GHC.Types.Int)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodySubscriptionData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("trial_period_days" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubscriptionData'TrialPeriodDays obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("trial_period_days" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodySubscriptionData'TrialPeriodDays obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodySubscriptionData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodySubscriptionData'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodySubscriptionData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "trial_period_days"))

-- | Create a new 'PostPaymentLinksRequestBodySubscriptionData'' with all required fields.
mkPostPaymentLinksRequestBodySubscriptionData' :: PostPaymentLinksRequestBodySubscriptionData'
mkPostPaymentLinksRequestBodySubscriptionData' = PostPaymentLinksRequestBodySubscriptionData' {postPaymentLinksRequestBodySubscriptionData'TrialPeriodDays = GHC.Maybe.Nothing}

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.tax_id_collection@ in the specification.
--
-- Controls tax ID collection during checkout.
data PostPaymentLinksRequestBodyTaxIdCollection' = PostPaymentLinksRequestBodyTaxIdCollection'
  { -- | enabled
    postPaymentLinksRequestBodyTaxIdCollection'Enabled :: GHC.Types.Bool
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyTaxIdCollection' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyTaxIdCollection'Enabled obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["enabled" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyTaxIdCollection'Enabled obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyTaxIdCollection' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyTaxIdCollection'" (\obj -> GHC.Base.pure PostPaymentLinksRequestBodyTaxIdCollection' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "enabled"))

-- | Create a new 'PostPaymentLinksRequestBodyTaxIdCollection'' with all required fields.
mkPostPaymentLinksRequestBodyTaxIdCollection' ::
  -- | 'postPaymentLinksRequestBodyTaxIdCollection'Enabled'
  GHC.Types.Bool ->
  PostPaymentLinksRequestBodyTaxIdCollection'
mkPostPaymentLinksRequestBodyTaxIdCollection' postPaymentLinksRequestBodyTaxIdCollection'Enabled = PostPaymentLinksRequestBodyTaxIdCollection' {postPaymentLinksRequestBodyTaxIdCollection'Enabled = postPaymentLinksRequestBodyTaxIdCollection'Enabled}

-- | Defines the object schema located at @paths.\/v1\/payment_links.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.transfer_data@ in the specification.
--
-- The account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to.
data PostPaymentLinksRequestBodyTransferData' = PostPaymentLinksRequestBodyTransferData'
  { -- | amount
    postPaymentLinksRequestBodyTransferData'Amount :: (GHC.Maybe.Maybe GHC.Types.Int),
    -- | destination
    postPaymentLinksRequestBodyTransferData'Destination :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostPaymentLinksRequestBodyTransferData' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTransferData'Amount obj) : ["destination" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyTransferData'Destination obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (postPaymentLinksRequestBodyTransferData'Amount obj) : ["destination" Data.Aeson.Types.ToJSON..= postPaymentLinksRequestBodyTransferData'Destination obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostPaymentLinksRequestBodyTransferData' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostPaymentLinksRequestBodyTransferData'" (\obj -> (GHC.Base.pure PostPaymentLinksRequestBodyTransferData' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "destination"))

-- | Create a new 'PostPaymentLinksRequestBodyTransferData'' with all required fields.
mkPostPaymentLinksRequestBodyTransferData' ::
  -- | 'postPaymentLinksRequestBodyTransferData'Destination'
  Data.Text.Internal.Text ->
  PostPaymentLinksRequestBodyTransferData'
mkPostPaymentLinksRequestBodyTransferData' postPaymentLinksRequestBodyTransferData'Destination =
  PostPaymentLinksRequestBodyTransferData'
    { postPaymentLinksRequestBodyTransferData'Amount = GHC.Maybe.Nothing,
      postPaymentLinksRequestBodyTransferData'Destination = postPaymentLinksRequestBodyTransferData'Destination
    }

-- | Represents a response of the operation 'postPaymentLinks'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostPaymentLinksResponseError' is used.
data PostPaymentLinksResponse
  = -- | Means either no matching case available or a parse error
    PostPaymentLinksResponseError GHC.Base.String
  | -- | Successful response.
    PostPaymentLinksResponse200 PaymentLink
  | -- | Error response.
    PostPaymentLinksResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
