{-# LANGUAGE ExplicitForAll #-}
{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the different functions to run the operation postTestHelpersTreasuryOutboundTransfersOutboundTransferReturn
module StripeAPI.Operations.PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturn where

import qualified Control.Monad.Fail
import qualified Control.Monad.Trans.Reader
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Either
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified Data.Vector
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified Network.HTTP.Client
import qualified Network.HTTP.Client as Network.HTTP.Client.Request
import qualified Network.HTTP.Client as Network.HTTP.Client.Types
import qualified Network.HTTP.Simple
import qualified Network.HTTP.Types
import qualified Network.HTTP.Types as Network.HTTP.Types.Status
import qualified Network.HTTP.Types as Network.HTTP.Types.URI
import qualified StripeAPI.Common
import StripeAPI.Types
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | > POST /v1/test_helpers/treasury/outbound_transfers/{outbound_transfer}/return
--
-- \<p>Transitions a test mode created OutboundTransfer to the \<code>returned\<\/code> status. The OutboundTransfer must already be in the \<code>processing\<\/code> state.\<\/p>
postTestHelpersTreasuryOutboundTransfersOutboundTransferReturn ::
  forall m.
  StripeAPI.Common.MonadHTTP m =>
  -- | outbound_transfer | Constraints: Maximum length of 5000
  Data.Text.Internal.Text ->
  -- | The request body to send
  GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody ->
  -- | Monadic computation which returns the result of the operation
  StripeAPI.Common.ClientT m (Network.HTTP.Client.Types.Response PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponse)
postTestHelpersTreasuryOutboundTransfersOutboundTransferReturn
  outboundTransfer
  body =
    GHC.Base.fmap
      ( \response_0 ->
          GHC.Base.fmap
            ( Data.Either.either PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponseError GHC.Base.id
                GHC.Base.. ( \response body ->
                               if
                                   | (\status_1 -> Network.HTTP.Types.Status.statusCode status_1 GHC.Classes.== 200) (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponse200
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Treasury'outboundTransfer
                                                        )
                                   | GHC.Base.const GHC.Types.True (Network.HTTP.Client.Types.responseStatus response) ->
                                     PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponseDefault
                                       Data.Functor.<$> ( Data.Aeson.eitherDecodeStrict body ::
                                                            Data.Either.Either
                                                              GHC.Base.String
                                                              Error
                                                        )
                                   | GHC.Base.otherwise -> Data.Either.Left "Missing default response type"
                           )
                  response_0
            )
            response_0
      )
      (StripeAPI.Common.doBodyCallWithConfigurationM (Data.Text.toUpper GHC.Base.$ Data.Text.pack "POST") (Data.Text.pack ("/v1/test_helpers/treasury/outbound_transfers/" GHC.Base.++ (Data.ByteString.Char8.unpack (Network.HTTP.Types.URI.urlEncode GHC.Types.True GHC.Base.$ (Data.ByteString.Char8.pack GHC.Base.$ StripeAPI.Common.stringifyModel outboundTransfer)) GHC.Base.++ "/return"))) GHC.Base.mempty body StripeAPI.Common.RequestBodyEncodingFormData)

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_transfers\/{outbound_transfer}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema@ in the specification.
data PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody = PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody
  { -- | expand: Specifies which fields in the response should be expanded.
    postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyExpand :: (GHC.Maybe.Maybe ([Data.Text.Internal.Text])),
    -- | returned_details: Details about a returned OutboundTransfer.
    postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails :: (GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("returned_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("expand" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyExpand obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("returned_details" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody" (\obj -> (GHC.Base.pure PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "expand")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "returned_details"))

-- | Create a new 'PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody' with all required fields.
mkPostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody :: PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody
mkPostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody =
  PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBody
    { postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyExpand = GHC.Maybe.Nothing,
      postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_transfers\/{outbound_transfer}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.returned_details@ in the specification.
--
-- Details about a returned OutboundTransfer.
data PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' = PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'
  { -- | code
    postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code :: (GHC.Maybe.Maybe PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("code" Data.Aeson.Types.ToJSON..=)) (postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'" (\obj -> GHC.Base.pure PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "code"))

-- | Create a new 'PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'' with all required fields.
mkPostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' :: PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'
mkPostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' = PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails' {postTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @paths.\/v1\/test_helpers\/treasury\/outbound_transfers\/{outbound_transfer}\/return.POST.requestBody.content.application\/x-www-form-urlencoded.schema.properties.returned_details.properties.code@ in the specification.
data PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"account_closed"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountClosed
  | -- | Represents the JSON value @"account_frozen"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen
  | -- | Represents the JSON value @"bank_account_restricted"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted
  | -- | Represents the JSON value @"bank_ownership_changed"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged
  | -- | Represents the JSON value @"declined"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumDeclined
  | -- | Represents the JSON value @"incorrect_account_holder_name"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName
  | -- | Represents the JSON value @"invalid_account_number"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber
  | -- | Represents the JSON value @"invalid_currency"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency
  | -- | Represents the JSON value @"no_account"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumNoAccount
  | -- | Represents the JSON value @"other"@
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumOther
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code' where
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'Other val) = val
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountClosed) = "account_closed"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen) = "account_frozen"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted) = "bank_account_restricted"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged) = "bank_ownership_changed"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumDeclined) = "declined"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName) = "incorrect_account_holder_name"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber) = "invalid_account_number"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency) = "invalid_currency"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumNoAccount) = "no_account"
  toJSON (PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumOther) = "other"

instance Data.Aeson.Types.FromJSON.FromJSON PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "account_closed" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountClosed
            | val GHC.Classes.== "account_frozen" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumAccountFrozen
            | val GHC.Classes.== "bank_account_restricted" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankAccountRestricted
            | val GHC.Classes.== "bank_ownership_changed" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumBankOwnershipChanged
            | val GHC.Classes.== "declined" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumDeclined
            | val GHC.Classes.== "incorrect_account_holder_name" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumIncorrectAccountHolderName
            | val GHC.Classes.== "invalid_account_number" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidAccountNumber
            | val GHC.Classes.== "invalid_currency" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumInvalidCurrency
            | val GHC.Classes.== "no_account" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumNoAccount
            | val GHC.Classes.== "other" -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'EnumOther
            | GHC.Base.otherwise -> PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnRequestBodyReturnedDetails'Code'Other val
      )

-- | Represents a response of the operation 'postTestHelpersTreasuryOutboundTransfersOutboundTransferReturn'.
--
-- The response constructor is chosen by the status code of the response. If no case matches (no specific case for the response code, no range case, no default case), 'PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponseError' is used.
data PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponse
  = -- | Means either no matching case available or a parse error
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponseError GHC.Base.String
  | -- | Successful response.
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponse200 Treasury'outboundTransfer
  | -- | Error response.
    PostTestHelpersTreasuryOutboundTransfersOutboundTransferReturnResponseDefault Error
  deriving (GHC.Show.Show, GHC.Classes.Eq)
