{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema AccountSettings
module StripeAPI.Types.AccountSettings where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.AccountBacsDebitPaymentsSettings
import {-# SOURCE #-} StripeAPI.Types.AccountBrandingSettings
import {-# SOURCE #-} StripeAPI.Types.AccountCardIssuingSettings
import {-# SOURCE #-} StripeAPI.Types.AccountCardPaymentsSettings
import {-# SOURCE #-} StripeAPI.Types.AccountDashboardSettings
import {-# SOURCE #-} StripeAPI.Types.AccountPaymentsSettings
import {-# SOURCE #-} StripeAPI.Types.AccountPayoutSettings
import {-# SOURCE #-} StripeAPI.Types.AccountSepaDebitPaymentsSettings
import {-# SOURCE #-} StripeAPI.Types.AccountTreasurySettings
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.account_settings@ in the specification.
data AccountSettings = AccountSettings
  { -- | bacs_debit_payments:
    accountSettingsBacsDebitPayments :: (GHC.Maybe.Maybe AccountBacsDebitPaymentsSettings),
    -- | branding:
    accountSettingsBranding :: AccountBrandingSettings,
    -- | card_issuing:
    accountSettingsCardIssuing :: (GHC.Maybe.Maybe AccountCardIssuingSettings),
    -- | card_payments:
    accountSettingsCardPayments :: AccountCardPaymentsSettings,
    -- | dashboard:
    accountSettingsDashboard :: AccountDashboardSettings,
    -- | payments:
    accountSettingsPayments :: AccountPaymentsSettings,
    -- | payouts:
    accountSettingsPayouts :: (GHC.Maybe.Maybe AccountPayoutSettings),
    -- | sepa_debit_payments:
    accountSettingsSepaDebitPayments :: (GHC.Maybe.Maybe AccountSepaDebitPaymentsSettings),
    -- | treasury:
    accountSettingsTreasury :: (GHC.Maybe.Maybe AccountTreasurySettings)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON AccountSettings where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bacs_debit_payments" Data.Aeson.Types.ToJSON..=)) (accountSettingsBacsDebitPayments obj) : ["branding" Data.Aeson.Types.ToJSON..= accountSettingsBranding obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card_issuing" Data.Aeson.Types.ToJSON..=)) (accountSettingsCardIssuing obj) : ["card_payments" Data.Aeson.Types.ToJSON..= accountSettingsCardPayments obj] : ["dashboard" Data.Aeson.Types.ToJSON..= accountSettingsDashboard obj] : ["payments" Data.Aeson.Types.ToJSON..= accountSettingsPayments obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payouts" Data.Aeson.Types.ToJSON..=)) (accountSettingsPayouts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit_payments" Data.Aeson.Types.ToJSON..=)) (accountSettingsSepaDebitPayments obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("treasury" Data.Aeson.Types.ToJSON..=)) (accountSettingsTreasury obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("bacs_debit_payments" Data.Aeson.Types.ToJSON..=)) (accountSettingsBacsDebitPayments obj) : ["branding" Data.Aeson.Types.ToJSON..= accountSettingsBranding obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("card_issuing" Data.Aeson.Types.ToJSON..=)) (accountSettingsCardIssuing obj) : ["card_payments" Data.Aeson.Types.ToJSON..= accountSettingsCardPayments obj] : ["dashboard" Data.Aeson.Types.ToJSON..= accountSettingsDashboard obj] : ["payments" Data.Aeson.Types.ToJSON..= accountSettingsPayments obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payouts" Data.Aeson.Types.ToJSON..=)) (accountSettingsPayouts obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("sepa_debit_payments" Data.Aeson.Types.ToJSON..=)) (accountSettingsSepaDebitPayments obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("treasury" Data.Aeson.Types.ToJSON..=)) (accountSettingsTreasury obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON AccountSettings where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "AccountSettings" (\obj -> ((((((((GHC.Base.pure AccountSettings GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "bacs_debit_payments")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "branding")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "card_issuing")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "card_payments")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "dashboard")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "payments")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payouts")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "sepa_debit_payments")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "treasury"))

-- | Create a new 'AccountSettings' with all required fields.
mkAccountSettings ::
  -- | 'accountSettingsBranding'
  AccountBrandingSettings ->
  -- | 'accountSettingsCardPayments'
  AccountCardPaymentsSettings ->
  -- | 'accountSettingsDashboard'
  AccountDashboardSettings ->
  -- | 'accountSettingsPayments'
  AccountPaymentsSettings ->
  AccountSettings
mkAccountSettings accountSettingsBranding accountSettingsCardPayments accountSettingsDashboard accountSettingsPayments =
  AccountSettings
    { accountSettingsBacsDebitPayments = GHC.Maybe.Nothing,
      accountSettingsBranding = accountSettingsBranding,
      accountSettingsCardIssuing = GHC.Maybe.Nothing,
      accountSettingsCardPayments = accountSettingsCardPayments,
      accountSettingsDashboard = accountSettingsDashboard,
      accountSettingsPayments = accountSettingsPayments,
      accountSettingsPayouts = GHC.Maybe.Nothing,
      accountSettingsSepaDebitPayments = GHC.Maybe.Nothing,
      accountSettingsTreasury = GHC.Maybe.Nothing
    }
