{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema BalanceAmount
module StripeAPI.Types.BalanceAmount where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.BalanceAmountBySourceType
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.balance_amount@ in the specification.
data BalanceAmount = BalanceAmount
  { -- | amount: Balance amount.
    balanceAmountAmount :: GHC.Types.Int,
    -- | currency: Three-letter [ISO currency code](https:\/\/www.iso.org\/iso-4217-currency-codes.html), in lowercase. Must be a [supported currency](https:\/\/stripe.com\/docs\/currencies).
    balanceAmountCurrency :: Data.Text.Internal.Text,
    -- | source_types:
    balanceAmountSourceTypes :: (GHC.Maybe.Maybe BalanceAmountBySourceType)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON BalanceAmount where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= balanceAmountAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= balanceAmountCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_types" Data.Aeson.Types.ToJSON..=)) (balanceAmountSourceTypes obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["amount" Data.Aeson.Types.ToJSON..= balanceAmountAmount obj] : ["currency" Data.Aeson.Types.ToJSON..= balanceAmountCurrency obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_types" Data.Aeson.Types.ToJSON..=)) (balanceAmountSourceTypes obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON BalanceAmount where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "BalanceAmount" (\obj -> ((GHC.Base.pure BalanceAmount GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "currency")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "source_types"))

-- | Create a new 'BalanceAmount' with all required fields.
mkBalanceAmount ::
  -- | 'balanceAmountAmount'
  GHC.Types.Int ->
  -- | 'balanceAmountCurrency'
  Data.Text.Internal.Text ->
  BalanceAmount
mkBalanceAmount balanceAmountAmount balanceAmountCurrency =
  BalanceAmount
    { balanceAmountAmount = balanceAmountAmount,
      balanceAmountCurrency = balanceAmountCurrency,
      balanceAmountSourceTypes = GHC.Maybe.Nothing
    }
