{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema IssuingCardShipping
module StripeAPI.Types.IssuingCardShipping where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.Address
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing_card_shipping@ in the specification.
data IssuingCardShipping = IssuingCardShipping
  { -- | address:
    issuingCardShippingAddress :: Address,
    -- | carrier: The delivery company that shipped a card.
    issuingCardShippingCarrier :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable IssuingCardShippingCarrier'NonNullable)),
    -- | eta: A unix timestamp representing a best estimate of when the card will be delivered.
    issuingCardShippingEta :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int)),
    -- | name: Recipient name.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingCardShippingName :: Data.Text.Internal.Text,
    -- | service: Shipment service, such as \`standard\` or \`express\`.
    issuingCardShippingService :: IssuingCardShippingService',
    -- | status: The delivery status of the card.
    issuingCardShippingStatus :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable IssuingCardShippingStatus'NonNullable)),
    -- | tracking_number: A tracking number for a card shipment.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingCardShippingTrackingNumber :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | tracking_url: A link to the shipping carrier\'s site where you can view detailed information about a card shipment.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuingCardShippingTrackingUrl :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | type: Packaging options.
    issuingCardShippingType :: IssuingCardShippingType'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardShipping where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= issuingCardShippingAddress obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("carrier" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingCarrier obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eta" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingEta obj) : ["name" Data.Aeson.Types.ToJSON..= issuingCardShippingName obj] : ["service" Data.Aeson.Types.ToJSON..= issuingCardShippingService obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingStatus obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tracking_number" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingTrackingNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tracking_url" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingTrackingUrl obj) : ["type" Data.Aeson.Types.ToJSON..= issuingCardShippingType obj] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["address" Data.Aeson.Types.ToJSON..= issuingCardShippingAddress obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("carrier" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingCarrier obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("eta" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingEta obj) : ["name" Data.Aeson.Types.ToJSON..= issuingCardShippingName obj] : ["service" Data.Aeson.Types.ToJSON..= issuingCardShippingService obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("status" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingStatus obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tracking_number" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingTrackingNumber obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tracking_url" Data.Aeson.Types.ToJSON..=)) (issuingCardShippingTrackingUrl obj) : ["type" Data.Aeson.Types.ToJSON..= issuingCardShippingType obj] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardShipping where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "IssuingCardShipping" (\obj -> ((((((((GHC.Base.pure IssuingCardShipping GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "address")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "carrier")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "eta")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "service")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tracking_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tracking_url")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'IssuingCardShipping' with all required fields.
mkIssuingCardShipping ::
  -- | 'issuingCardShippingAddress'
  Address ->
  -- | 'issuingCardShippingName'
  Data.Text.Internal.Text ->
  -- | 'issuingCardShippingService'
  IssuingCardShippingService' ->
  -- | 'issuingCardShippingType'
  IssuingCardShippingType' ->
  IssuingCardShipping
mkIssuingCardShipping issuingCardShippingAddress issuingCardShippingName issuingCardShippingService issuingCardShippingType =
  IssuingCardShipping
    { issuingCardShippingAddress = issuingCardShippingAddress,
      issuingCardShippingCarrier = GHC.Maybe.Nothing,
      issuingCardShippingEta = GHC.Maybe.Nothing,
      issuingCardShippingName = issuingCardShippingName,
      issuingCardShippingService = issuingCardShippingService,
      issuingCardShippingStatus = GHC.Maybe.Nothing,
      issuingCardShippingTrackingNumber = GHC.Maybe.Nothing,
      issuingCardShippingTrackingUrl = GHC.Maybe.Nothing,
      issuingCardShippingType = issuingCardShippingType
    }

-- | Defines the enum schema located at @components.schemas.issuing_card_shipping.properties.carrier@ in the specification.
--
-- The delivery company that shipped a card.
data IssuingCardShippingCarrier'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardShippingCarrier'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardShippingCarrier'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"dhl"@
    IssuingCardShippingCarrier'NonNullableEnumDhl
  | -- | Represents the JSON value @"fedex"@
    IssuingCardShippingCarrier'NonNullableEnumFedex
  | -- | Represents the JSON value @"royal_mail"@
    IssuingCardShippingCarrier'NonNullableEnumRoyalMail
  | -- | Represents the JSON value @"usps"@
    IssuingCardShippingCarrier'NonNullableEnumUsps
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardShippingCarrier'NonNullable where
  toJSON (IssuingCardShippingCarrier'NonNullableOther val) = val
  toJSON (IssuingCardShippingCarrier'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardShippingCarrier'NonNullableEnumDhl) = "dhl"
  toJSON (IssuingCardShippingCarrier'NonNullableEnumFedex) = "fedex"
  toJSON (IssuingCardShippingCarrier'NonNullableEnumRoyalMail) = "royal_mail"
  toJSON (IssuingCardShippingCarrier'NonNullableEnumUsps) = "usps"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardShippingCarrier'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "dhl" -> IssuingCardShippingCarrier'NonNullableEnumDhl
            | val GHC.Classes.== "fedex" -> IssuingCardShippingCarrier'NonNullableEnumFedex
            | val GHC.Classes.== "royal_mail" -> IssuingCardShippingCarrier'NonNullableEnumRoyalMail
            | val GHC.Classes.== "usps" -> IssuingCardShippingCarrier'NonNullableEnumUsps
            | GHC.Base.otherwise -> IssuingCardShippingCarrier'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.issuing_card_shipping.properties.service@ in the specification.
--
-- Shipment service, such as \`standard\` or \`express\`.
data IssuingCardShippingService'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardShippingService'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardShippingService'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"express"@
    IssuingCardShippingService'EnumExpress
  | -- | Represents the JSON value @"priority"@
    IssuingCardShippingService'EnumPriority
  | -- | Represents the JSON value @"standard"@
    IssuingCardShippingService'EnumStandard
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardShippingService' where
  toJSON (IssuingCardShippingService'Other val) = val
  toJSON (IssuingCardShippingService'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardShippingService'EnumExpress) = "express"
  toJSON (IssuingCardShippingService'EnumPriority) = "priority"
  toJSON (IssuingCardShippingService'EnumStandard) = "standard"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardShippingService' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "express" -> IssuingCardShippingService'EnumExpress
            | val GHC.Classes.== "priority" -> IssuingCardShippingService'EnumPriority
            | val GHC.Classes.== "standard" -> IssuingCardShippingService'EnumStandard
            | GHC.Base.otherwise -> IssuingCardShippingService'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing_card_shipping.properties.status@ in the specification.
--
-- The delivery status of the card.
data IssuingCardShippingStatus'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardShippingStatus'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardShippingStatus'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"canceled"@
    IssuingCardShippingStatus'NonNullableEnumCanceled
  | -- | Represents the JSON value @"delivered"@
    IssuingCardShippingStatus'NonNullableEnumDelivered
  | -- | Represents the JSON value @"failure"@
    IssuingCardShippingStatus'NonNullableEnumFailure
  | -- | Represents the JSON value @"pending"@
    IssuingCardShippingStatus'NonNullableEnumPending
  | -- | Represents the JSON value @"returned"@
    IssuingCardShippingStatus'NonNullableEnumReturned
  | -- | Represents the JSON value @"shipped"@
    IssuingCardShippingStatus'NonNullableEnumShipped
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardShippingStatus'NonNullable where
  toJSON (IssuingCardShippingStatus'NonNullableOther val) = val
  toJSON (IssuingCardShippingStatus'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardShippingStatus'NonNullableEnumCanceled) = "canceled"
  toJSON (IssuingCardShippingStatus'NonNullableEnumDelivered) = "delivered"
  toJSON (IssuingCardShippingStatus'NonNullableEnumFailure) = "failure"
  toJSON (IssuingCardShippingStatus'NonNullableEnumPending) = "pending"
  toJSON (IssuingCardShippingStatus'NonNullableEnumReturned) = "returned"
  toJSON (IssuingCardShippingStatus'NonNullableEnumShipped) = "shipped"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardShippingStatus'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "canceled" -> IssuingCardShippingStatus'NonNullableEnumCanceled
            | val GHC.Classes.== "delivered" -> IssuingCardShippingStatus'NonNullableEnumDelivered
            | val GHC.Classes.== "failure" -> IssuingCardShippingStatus'NonNullableEnumFailure
            | val GHC.Classes.== "pending" -> IssuingCardShippingStatus'NonNullableEnumPending
            | val GHC.Classes.== "returned" -> IssuingCardShippingStatus'NonNullableEnumReturned
            | val GHC.Classes.== "shipped" -> IssuingCardShippingStatus'NonNullableEnumShipped
            | GHC.Base.otherwise -> IssuingCardShippingStatus'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.issuing_card_shipping.properties.type@ in the specification.
--
-- Packaging options.
data IssuingCardShippingType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    IssuingCardShippingType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    IssuingCardShippingType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"bulk"@
    IssuingCardShippingType'EnumBulk
  | -- | Represents the JSON value @"individual"@
    IssuingCardShippingType'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON IssuingCardShippingType' where
  toJSON (IssuingCardShippingType'Other val) = val
  toJSON (IssuingCardShippingType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (IssuingCardShippingType'EnumBulk) = "bulk"
  toJSON (IssuingCardShippingType'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON IssuingCardShippingType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "bulk" -> IssuingCardShippingType'EnumBulk
            | val GHC.Classes.== "individual" -> IssuingCardShippingType'EnumIndividual
            | GHC.Base.otherwise -> IssuingCardShippingType'Other val
      )
