{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema OrdersV2ResourceCardPaymentMethodOptions
module StripeAPI.Types.OrdersV2ResourceCardPaymentMethodOptions where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.orders_v2_resource_card_payment_method_options@ in the specification.
data OrdersV2ResourceCardPaymentMethodOptions = OrdersV2ResourceCardPaymentMethodOptions
  { -- | capture_method: Controls when the funds will be captured from the customer\'s account.
    ordersV2ResourceCardPaymentMethodOptionsCaptureMethod :: OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod',
    -- | setup_future_usage: Indicates that you intend to make future payments with the payment method.
    --
    -- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the order\'s Customer, if present, after the order\'s PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
    --
    -- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
    --
    -- If \`setup_future_usage\` is already set and you are performing a request using a publishable key, you may only update the value from \`on_session\` to \`off_session\`.
    ordersV2ResourceCardPaymentMethodOptionsSetupFutureUsage :: (GHC.Maybe.Maybe OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON OrdersV2ResourceCardPaymentMethodOptions where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["capture_method" Data.Aeson.Types.ToJSON..= ordersV2ResourceCardPaymentMethodOptionsCaptureMethod obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (ordersV2ResourceCardPaymentMethodOptionsSetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["capture_method" Data.Aeson.Types.ToJSON..= ordersV2ResourceCardPaymentMethodOptionsCaptureMethod obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (ordersV2ResourceCardPaymentMethodOptionsSetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON OrdersV2ResourceCardPaymentMethodOptions where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "OrdersV2ResourceCardPaymentMethodOptions" (\obj -> (GHC.Base.pure OrdersV2ResourceCardPaymentMethodOptions GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'OrdersV2ResourceCardPaymentMethodOptions' with all required fields.
mkOrdersV2ResourceCardPaymentMethodOptions ::
  -- | 'ordersV2ResourceCardPaymentMethodOptionsCaptureMethod'
  OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod' ->
  OrdersV2ResourceCardPaymentMethodOptions
mkOrdersV2ResourceCardPaymentMethodOptions ordersV2ResourceCardPaymentMethodOptionsCaptureMethod =
  OrdersV2ResourceCardPaymentMethodOptions
    { ordersV2ResourceCardPaymentMethodOptionsCaptureMethod = ordersV2ResourceCardPaymentMethodOptionsCaptureMethod,
      ordersV2ResourceCardPaymentMethodOptionsSetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.orders_v2_resource_card_payment_method_options.properties.capture_method@ in the specification.
--
-- Controls when the funds will be captured from the customer\'s account.
data OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumAutomatic
  | -- | Represents the JSON value @"manual"@
    OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod' where
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'Other val) = val
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumAutomatic) = "automatic"
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumAutomatic
            | val GHC.Classes.== "manual" -> OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'EnumManual
            | GHC.Base.otherwise -> OrdersV2ResourceCardPaymentMethodOptionsCaptureMethod'Other val
      )

-- | Defines the enum schema located at @components.schemas.orders_v2_resource_card_payment_method_options.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with the payment method.
--
-- Providing this parameter will [attach the payment method](https:\/\/stripe.com\/docs\/payments\/save-during-payment) to the order\'s Customer, if present, after the order\'s PaymentIntent is confirmed and any required actions from the user are complete. If no Customer was provided, the payment method can still be [attached](https:\/\/stripe.com\/docs\/api\/payment_methods\/attach) to a Customer after the transaction completes.
--
-- When processing card payments, Stripe also uses \`setup_future_usage\` to dynamically optimize your payment flow and comply with regional legislation and network rules, such as [SCA](https:\/\/stripe.com\/docs\/strong-customer-authentication).
--
-- If \`setup_future_usage\` is already set and you are performing a request using a publishable key, you may only update the value from \`on_session\` to \`off_session\`.
data OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"none"@
    OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumNone
  | -- | Represents the JSON value @"off_session"@
    OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOffSession
  | -- | Represents the JSON value @"on_session"@
    OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage' where
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'Other val) = val
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumNone) = "none"
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOffSession) = "off_session"
  toJSON (OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "none" -> OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumNone
            | val GHC.Classes.== "off_session" -> OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOffSession
            | val GHC.Classes.== "on_session" -> OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'EnumOnSession
            | GHC.Base.otherwise -> OrdersV2ResourceCardPaymentMethodOptionsSetupFutureUsage'Other val
      )
