{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentLink
module StripeAPI.Types.PaymentLink where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.Account
import {-# SOURCE #-} StripeAPI.Types.Item
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceAfterCompletion
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceAutomaticTax
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceConsentCollection
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourcePaymentIntentData
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourcePhoneNumberCollection
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceShippingAddressCollection
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceShippingOption
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceSubscriptionData
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceTaxIdCollection
import {-# SOURCE #-} StripeAPI.Types.PaymentLinksResourceTransferData
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_link@ in the specification.
--
-- A payment link is a shareable URL that will take your customers to a hosted payment page. A payment link can be shared and used multiple times.
--
-- When a customer opens a payment link it will open a new [checkout session](https:\/\/stripe.com\/docs\/api\/checkout\/sessions) to render the payment page. You can use [checkout session events](https:\/\/stripe.com\/docs\/api\/events\/types\#event_types-checkout.session.completed) to track payments through payment links.
--
-- Related guide: [Payment Links API](https:\/\/stripe.com\/docs\/payments\/payment-links\/api)
data PaymentLink = PaymentLink
  { -- | active: Whether the payment link\'s \`url\` is active. If \`false\`, customers visiting the URL will be shown a page saying that the link has been deactivated.
    paymentLinkActive :: GHC.Types.Bool,
    -- | after_completion:
    paymentLinkAfterCompletion :: PaymentLinksResourceAfterCompletion,
    -- | allow_promotion_codes: Whether user redeemable promotion codes are enabled.
    paymentLinkAllowPromotionCodes :: GHC.Types.Bool,
    -- | application_fee_amount: The amount of the application fee (if any) that will be requested to be applied to the payment and transferred to the application owner\'s Stripe account.
    paymentLinkApplicationFeeAmount :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int)),
    -- | application_fee_percent: This represents the percentage of the subscription invoice subtotal that will be transferred to the application owner\'s Stripe account.
    paymentLinkApplicationFeePercent :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Double)),
    -- | automatic_tax:
    paymentLinkAutomaticTax :: PaymentLinksResourceAutomaticTax,
    -- | billing_address_collection: Configuration for collecting the customer\'s billing address.
    paymentLinkBillingAddressCollection :: PaymentLinkBillingAddressCollection',
    -- | consent_collection: When set, provides configuration to gather active consent from customers.
    paymentLinkConsentCollection :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkConsentCollection'NonNullable)),
    -- | customer_creation: Configuration for Customer creation during checkout.
    paymentLinkCustomerCreation :: PaymentLinkCustomerCreation',
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentLinkId :: Data.Text.Internal.Text,
    -- | line_items: The line items representing what is being sold.
    paymentLinkLineItems :: (GHC.Maybe.Maybe PaymentLinkLineItems'),
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    paymentLinkLivemode :: GHC.Types.Bool,
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
    paymentLinkMetadata :: Data.Aeson.Types.Internal.Object,
    -- | on_behalf_of: The account on behalf of which to charge. See the [Connect documentation](https:\/\/support.stripe.com\/questions\/sending-invoices-on-behalf-of-connected-accounts) for details.
    paymentLinkOnBehalfOf :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkOnBehalfOf'NonNullableVariants)),
    -- | payment_intent_data: Indicates the parameters to be passed to PaymentIntent creation during checkout.
    paymentLinkPaymentIntentData :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkPaymentIntentData'NonNullable)),
    -- | payment_method_types: The list of payment method types that customers can use. When \`null\`, Stripe will dynamically show relevant payment methods you\'ve enabled in your [payment method settings](https:\/\/dashboard.stripe.com\/settings\/payment_methods).
    paymentLinkPaymentMethodTypes :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ([PaymentLinkPaymentMethodTypes'NonNullable]))),
    -- | phone_number_collection:
    paymentLinkPhoneNumberCollection :: PaymentLinksResourcePhoneNumberCollection,
    -- | shipping_address_collection: Configuration for collecting the customer\'s shipping address.
    paymentLinkShippingAddressCollection :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkShippingAddressCollection'NonNullable)),
    -- | shipping_options: The shipping rate options applied to the session.
    paymentLinkShippingOptions :: ([PaymentLinksResourceShippingOption]),
    -- | submit_type: Indicates the type of transaction being performed which customizes relevant text on the page, such as the submit button.
    paymentLinkSubmitType :: PaymentLinkSubmitType',
    -- | subscription_data: When creating a subscription, the specified configuration data will be used. There must be at least one line item with a recurring price to use \`subscription_data\`.
    paymentLinkSubscriptionData :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkSubscriptionData'NonNullable)),
    -- | tax_id_collection:
    paymentLinkTaxIdCollection :: PaymentLinksResourceTaxIdCollection,
    -- | transfer_data: The account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to.
    paymentLinkTransferData :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkTransferData'NonNullable)),
    -- | url: The public URL that can be shared with customers.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentLinkUrl :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLink where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["active" Data.Aeson.Types.ToJSON..= paymentLinkActive obj] : ["after_completion" Data.Aeson.Types.ToJSON..= paymentLinkAfterCompletion obj] : ["allow_promotion_codes" Data.Aeson.Types.ToJSON..= paymentLinkAllowPromotionCodes obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (paymentLinkApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_percent" Data.Aeson.Types.ToJSON..=)) (paymentLinkApplicationFeePercent obj) : ["automatic_tax" Data.Aeson.Types.ToJSON..= paymentLinkAutomaticTax obj] : ["billing_address_collection" Data.Aeson.Types.ToJSON..= paymentLinkBillingAddressCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("consent_collection" Data.Aeson.Types.ToJSON..=)) (paymentLinkConsentCollection obj) : ["customer_creation" Data.Aeson.Types.ToJSON..= paymentLinkCustomerCreation obj] : ["id" Data.Aeson.Types.ToJSON..= paymentLinkId obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (paymentLinkLineItems obj) : ["livemode" Data.Aeson.Types.ToJSON..= paymentLinkLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= paymentLinkMetadata obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (paymentLinkOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_intent_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentMethodTypes obj) : ["phone_number_collection" Data.Aeson.Types.ToJSON..= paymentLinkPhoneNumberCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (paymentLinkShippingAddressCollection obj) : ["shipping_options" Data.Aeson.Types.ToJSON..= paymentLinkShippingOptions obj] : ["submit_type" Data.Aeson.Types.ToJSON..= paymentLinkSubmitType obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkSubscriptionData obj) : ["tax_id_collection" Data.Aeson.Types.ToJSON..= paymentLinkTaxIdCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData obj) : ["url" Data.Aeson.Types.ToJSON..= paymentLinkUrl obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "payment_link"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["active" Data.Aeson.Types.ToJSON..= paymentLinkActive obj] : ["after_completion" Data.Aeson.Types.ToJSON..= paymentLinkAfterCompletion obj] : ["allow_promotion_codes" Data.Aeson.Types.ToJSON..= paymentLinkAllowPromotionCodes obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_amount" Data.Aeson.Types.ToJSON..=)) (paymentLinkApplicationFeeAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("application_fee_percent" Data.Aeson.Types.ToJSON..=)) (paymentLinkApplicationFeePercent obj) : ["automatic_tax" Data.Aeson.Types.ToJSON..= paymentLinkAutomaticTax obj] : ["billing_address_collection" Data.Aeson.Types.ToJSON..= paymentLinkBillingAddressCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("consent_collection" Data.Aeson.Types.ToJSON..=)) (paymentLinkConsentCollection obj) : ["customer_creation" Data.Aeson.Types.ToJSON..= paymentLinkCustomerCreation obj] : ["id" Data.Aeson.Types.ToJSON..= paymentLinkId obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("line_items" Data.Aeson.Types.ToJSON..=)) (paymentLinkLineItems obj) : ["livemode" Data.Aeson.Types.ToJSON..= paymentLinkLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= paymentLinkMetadata obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("on_behalf_of" Data.Aeson.Types.ToJSON..=)) (paymentLinkOnBehalfOf obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_intent_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payment_method_types" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentMethodTypes obj) : ["phone_number_collection" Data.Aeson.Types.ToJSON..= paymentLinkPhoneNumberCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("shipping_address_collection" Data.Aeson.Types.ToJSON..=)) (paymentLinkShippingAddressCollection obj) : ["shipping_options" Data.Aeson.Types.ToJSON..= paymentLinkShippingOptions obj] : ["submit_type" Data.Aeson.Types.ToJSON..= paymentLinkSubmitType obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("subscription_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkSubscriptionData obj) : ["tax_id_collection" Data.Aeson.Types.ToJSON..= paymentLinkTaxIdCollection obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("transfer_data" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData obj) : ["url" Data.Aeson.Types.ToJSON..= paymentLinkUrl obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "payment_link"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLink where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLink" (\obj -> (((((((((((((((((((((((GHC.Base.pure PaymentLink GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "active")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "after_completion")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "allow_promotion_codes")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "application_fee_amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "application_fee_percent")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "automatic_tax")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "billing_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "consent_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "customer_creation")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "line_items")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "on_behalf_of")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_intent_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payment_method_types")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "phone_number_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "shipping_address_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "shipping_options")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "submit_type")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "subscription_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "tax_id_collection")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "transfer_data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'PaymentLink' with all required fields.
mkPaymentLink ::
  -- | 'paymentLinkActive'
  GHC.Types.Bool ->
  -- | 'paymentLinkAfterCompletion'
  PaymentLinksResourceAfterCompletion ->
  -- | 'paymentLinkAllowPromotionCodes'
  GHC.Types.Bool ->
  -- | 'paymentLinkAutomaticTax'
  PaymentLinksResourceAutomaticTax ->
  -- | 'paymentLinkBillingAddressCollection'
  PaymentLinkBillingAddressCollection' ->
  -- | 'paymentLinkCustomerCreation'
  PaymentLinkCustomerCreation' ->
  -- | 'paymentLinkId'
  Data.Text.Internal.Text ->
  -- | 'paymentLinkLivemode'
  GHC.Types.Bool ->
  -- | 'paymentLinkMetadata'
  Data.Aeson.Types.Internal.Object ->
  -- | 'paymentLinkPhoneNumberCollection'
  PaymentLinksResourcePhoneNumberCollection ->
  -- | 'paymentLinkShippingOptions'
  [PaymentLinksResourceShippingOption] ->
  -- | 'paymentLinkSubmitType'
  PaymentLinkSubmitType' ->
  -- | 'paymentLinkTaxIdCollection'
  PaymentLinksResourceTaxIdCollection ->
  -- | 'paymentLinkUrl'
  Data.Text.Internal.Text ->
  PaymentLink
mkPaymentLink paymentLinkActive paymentLinkAfterCompletion paymentLinkAllowPromotionCodes paymentLinkAutomaticTax paymentLinkBillingAddressCollection paymentLinkCustomerCreation paymentLinkId paymentLinkLivemode paymentLinkMetadata paymentLinkPhoneNumberCollection paymentLinkShippingOptions paymentLinkSubmitType paymentLinkTaxIdCollection paymentLinkUrl =
  PaymentLink
    { paymentLinkActive = paymentLinkActive,
      paymentLinkAfterCompletion = paymentLinkAfterCompletion,
      paymentLinkAllowPromotionCodes = paymentLinkAllowPromotionCodes,
      paymentLinkApplicationFeeAmount = GHC.Maybe.Nothing,
      paymentLinkApplicationFeePercent = GHC.Maybe.Nothing,
      paymentLinkAutomaticTax = paymentLinkAutomaticTax,
      paymentLinkBillingAddressCollection = paymentLinkBillingAddressCollection,
      paymentLinkConsentCollection = GHC.Maybe.Nothing,
      paymentLinkCustomerCreation = paymentLinkCustomerCreation,
      paymentLinkId = paymentLinkId,
      paymentLinkLineItems = GHC.Maybe.Nothing,
      paymentLinkLivemode = paymentLinkLivemode,
      paymentLinkMetadata = paymentLinkMetadata,
      paymentLinkOnBehalfOf = GHC.Maybe.Nothing,
      paymentLinkPaymentIntentData = GHC.Maybe.Nothing,
      paymentLinkPaymentMethodTypes = GHC.Maybe.Nothing,
      paymentLinkPhoneNumberCollection = paymentLinkPhoneNumberCollection,
      paymentLinkShippingAddressCollection = GHC.Maybe.Nothing,
      paymentLinkShippingOptions = paymentLinkShippingOptions,
      paymentLinkSubmitType = paymentLinkSubmitType,
      paymentLinkSubscriptionData = GHC.Maybe.Nothing,
      paymentLinkTaxIdCollection = paymentLinkTaxIdCollection,
      paymentLinkTransferData = GHC.Maybe.Nothing,
      paymentLinkUrl = paymentLinkUrl
    }

-- | Defines the enum schema located at @components.schemas.payment_link.properties.billing_address_collection@ in the specification.
--
-- Configuration for collecting the customer\'s billing address.
data PaymentLinkBillingAddressCollection'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkBillingAddressCollection'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkBillingAddressCollection'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PaymentLinkBillingAddressCollection'EnumAuto
  | -- | Represents the JSON value @"required"@
    PaymentLinkBillingAddressCollection'EnumRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkBillingAddressCollection' where
  toJSON (PaymentLinkBillingAddressCollection'Other val) = val
  toJSON (PaymentLinkBillingAddressCollection'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkBillingAddressCollection'EnumAuto) = "auto"
  toJSON (PaymentLinkBillingAddressCollection'EnumRequired) = "required"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkBillingAddressCollection' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PaymentLinkBillingAddressCollection'EnumAuto
            | val GHC.Classes.== "required" -> PaymentLinkBillingAddressCollection'EnumRequired
            | GHC.Base.otherwise -> PaymentLinkBillingAddressCollection'Other val
      )

-- | Defines the object schema located at @components.schemas.payment_link.properties.consent_collection.anyOf@ in the specification.
--
-- When set, provides configuration to gather active consent from customers.
data PaymentLinkConsentCollection'NonNullable = PaymentLinkConsentCollection'NonNullable
  { -- | promotions: If set to \`auto\`, enables the collection of customer consent for promotional communications.
    paymentLinkConsentCollection'NonNullablePromotions :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkConsentCollection'NonNullablePromotions'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkConsentCollection'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotions" Data.Aeson.Types.ToJSON..=)) (paymentLinkConsentCollection'NonNullablePromotions obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("promotions" Data.Aeson.Types.ToJSON..=)) (paymentLinkConsentCollection'NonNullablePromotions obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkConsentCollection'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkConsentCollection'NonNullable" (\obj -> GHC.Base.pure PaymentLinkConsentCollection'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "promotions"))

-- | Create a new 'PaymentLinkConsentCollection'NonNullable' with all required fields.
mkPaymentLinkConsentCollection'NonNullable :: PaymentLinkConsentCollection'NonNullable
mkPaymentLinkConsentCollection'NonNullable = PaymentLinkConsentCollection'NonNullable {paymentLinkConsentCollection'NonNullablePromotions = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @components.schemas.payment_link.properties.consent_collection.anyOf.properties.promotions@ in the specification.
--
-- If set to \`auto\`, enables the collection of customer consent for promotional communications.
data PaymentLinkConsentCollection'NonNullablePromotions'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkConsentCollection'NonNullablePromotions'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkConsentCollection'NonNullablePromotions'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PaymentLinkConsentCollection'NonNullablePromotions'NonNullableEnumAuto
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkConsentCollection'NonNullablePromotions'NonNullable where
  toJSON (PaymentLinkConsentCollection'NonNullablePromotions'NonNullableOther val) = val
  toJSON (PaymentLinkConsentCollection'NonNullablePromotions'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkConsentCollection'NonNullablePromotions'NonNullableEnumAuto) = "auto"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkConsentCollection'NonNullablePromotions'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PaymentLinkConsentCollection'NonNullablePromotions'NonNullableEnumAuto
            | GHC.Base.otherwise -> PaymentLinkConsentCollection'NonNullablePromotions'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.payment_link.properties.customer_creation@ in the specification.
--
-- Configuration for Customer creation during checkout.
data PaymentLinkCustomerCreation'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkCustomerCreation'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkCustomerCreation'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"always"@
    PaymentLinkCustomerCreation'EnumAlways
  | -- | Represents the JSON value @"if_required"@
    PaymentLinkCustomerCreation'EnumIfRequired
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkCustomerCreation' where
  toJSON (PaymentLinkCustomerCreation'Other val) = val
  toJSON (PaymentLinkCustomerCreation'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkCustomerCreation'EnumAlways) = "always"
  toJSON (PaymentLinkCustomerCreation'EnumIfRequired) = "if_required"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkCustomerCreation' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "always" -> PaymentLinkCustomerCreation'EnumAlways
            | val GHC.Classes.== "if_required" -> PaymentLinkCustomerCreation'EnumIfRequired
            | GHC.Base.otherwise -> PaymentLinkCustomerCreation'Other val
      )

-- | Defines the object schema located at @components.schemas.payment_link.properties.line_items@ in the specification.
--
-- The line items representing what is being sold.
data PaymentLinkLineItems' = PaymentLinkLineItems'
  { -- | data: Details about each object.
    paymentLinkLineItems'Data :: ([Item]),
    -- | has_more: True if this list has another page of items after this one that can be fetched.
    paymentLinkLineItems'HasMore :: GHC.Types.Bool,
    -- | url: The URL where this list can be accessed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentLinkLineItems'Url :: Data.Text.Internal.Text
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkLineItems' where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["data" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'Data obj] : ["has_more" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'HasMore obj] : ["url" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'Url obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["data" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'Data obj] : ["has_more" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'HasMore obj] : ["url" Data.Aeson.Types.ToJSON..= paymentLinkLineItems'Url obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "list"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkLineItems' where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkLineItems'" (\obj -> ((GHC.Base.pure PaymentLinkLineItems' GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "data")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "has_more")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "url"))

-- | Create a new 'PaymentLinkLineItems'' with all required fields.
mkPaymentLinkLineItems' ::
  -- | 'paymentLinkLineItems'Data'
  [Item] ->
  -- | 'paymentLinkLineItems'HasMore'
  GHC.Types.Bool ->
  -- | 'paymentLinkLineItems'Url'
  Data.Text.Internal.Text ->
  PaymentLinkLineItems'
mkPaymentLinkLineItems' paymentLinkLineItems'Data paymentLinkLineItems'HasMore paymentLinkLineItems'Url =
  PaymentLinkLineItems'
    { paymentLinkLineItems'Data = paymentLinkLineItems'Data,
      paymentLinkLineItems'HasMore = paymentLinkLineItems'HasMore,
      paymentLinkLineItems'Url = paymentLinkLineItems'Url
    }

-- | Defines the oneOf schema located at @components.schemas.payment_link.properties.on_behalf_of.anyOf@ in the specification.
--
-- The account on behalf of which to charge. See the [Connect documentation](https:\/\/support.stripe.com\/questions\/sending-invoices-on-behalf-of-connected-accounts) for details.
data PaymentLinkOnBehalfOf'NonNullableVariants
  = PaymentLinkOnBehalfOf'NonNullableText Data.Text.Internal.Text
  | PaymentLinkOnBehalfOf'NonNullableAccount Account
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkOnBehalfOf'NonNullableVariants where
  toJSON (PaymentLinkOnBehalfOf'NonNullableText a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PaymentLinkOnBehalfOf'NonNullableAccount a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkOnBehalfOf'NonNullableVariants where
  parseJSON val = case (PaymentLinkOnBehalfOf'NonNullableText Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((PaymentLinkOnBehalfOf'NonNullableAccount Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @components.schemas.payment_link.properties.payment_intent_data.anyOf@ in the specification.
--
-- Indicates the parameters to be passed to PaymentIntent creation during checkout.
data PaymentLinkPaymentIntentData'NonNullable = PaymentLinkPaymentIntentData'NonNullable
  { -- | capture_method: Indicates when the funds will be captured from the customer\'s account.
    paymentLinkPaymentIntentData'NonNullableCaptureMethod :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullable)),
    -- | setup_future_usage: Indicates that you intend to make future payments with the payment method collected during checkout.
    paymentLinkPaymentIntentData'NonNullableSetupFutureUsage :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkPaymentIntentData'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData'NonNullableCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData'NonNullableSetupFutureUsage obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData'NonNullableCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("setup_future_usage" Data.Aeson.Types.ToJSON..=)) (paymentLinkPaymentIntentData'NonNullableSetupFutureUsage obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkPaymentIntentData'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkPaymentIntentData'NonNullable" (\obj -> (GHC.Base.pure PaymentLinkPaymentIntentData'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "setup_future_usage"))

-- | Create a new 'PaymentLinkPaymentIntentData'NonNullable' with all required fields.
mkPaymentLinkPaymentIntentData'NonNullable :: PaymentLinkPaymentIntentData'NonNullable
mkPaymentLinkPaymentIntentData'NonNullable =
  PaymentLinkPaymentIntentData'NonNullable
    { paymentLinkPaymentIntentData'NonNullableCaptureMethod = GHC.Maybe.Nothing,
      paymentLinkPaymentIntentData'NonNullableSetupFutureUsage = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_link.properties.payment_intent_data.anyOf.properties.capture_method@ in the specification.
--
-- Indicates when the funds will be captured from the customer\'s account.
data PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"automatic"@
    PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumAutomatic
  | -- | Represents the JSON value @"manual"@
    PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullable where
  toJSON (PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableOther val) = val
  toJSON (PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumAutomatic) = "automatic"
  toJSON (PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "automatic" -> PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumAutomatic
            | val GHC.Classes.== "manual" -> PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableEnumManual
            | GHC.Base.otherwise -> PaymentLinkPaymentIntentData'NonNullableCaptureMethod'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.payment_link.properties.payment_intent_data.anyOf.properties.setup_future_usage@ in the specification.
--
-- Indicates that you intend to make future payments with the payment method collected during checkout.
data PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"off_session"@
    PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOffSession
  | -- | Represents the JSON value @"on_session"@
    PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOnSession
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullable where
  toJSON (PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableOther val) = val
  toJSON (PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOffSession) = "off_session"
  toJSON (PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOnSession) = "on_session"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "off_session" -> PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOffSession
            | val GHC.Classes.== "on_session" -> PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableEnumOnSession
            | GHC.Base.otherwise -> PaymentLinkPaymentIntentData'NonNullableSetupFutureUsage'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.payment_link.properties.payment_method_types.items@ in the specification.
data PaymentLinkPaymentMethodTypes'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkPaymentMethodTypes'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkPaymentMethodTypes'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"card"@
    PaymentLinkPaymentMethodTypes'NonNullableEnumCard
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkPaymentMethodTypes'NonNullable where
  toJSON (PaymentLinkPaymentMethodTypes'NonNullableOther val) = val
  toJSON (PaymentLinkPaymentMethodTypes'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkPaymentMethodTypes'NonNullableEnumCard) = "card"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkPaymentMethodTypes'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "card" -> PaymentLinkPaymentMethodTypes'NonNullableEnumCard
            | GHC.Base.otherwise -> PaymentLinkPaymentMethodTypes'NonNullableOther val
      )

-- | Defines the object schema located at @components.schemas.payment_link.properties.shipping_address_collection.anyOf@ in the specification.
--
-- Configuration for collecting the customer\\\'s shipping address.
data PaymentLinkShippingAddressCollection'NonNullable = PaymentLinkShippingAddressCollection'NonNullable
  { -- | allowed_countries: An array of two-letter ISO country codes representing which countries Checkout should provide as options for shipping locations. Unsupported country codes: \`AS, CX, CC, CU, HM, IR, KP, MH, FM, NF, MP, PW, SD, SY, UM, VI\`.
    paymentLinkShippingAddressCollection'NonNullableAllowedCountries :: (GHC.Maybe.Maybe ([PaymentLinkShippingAddressCollection'NonNullableAllowedCountries']))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkShippingAddressCollection'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_countries" Data.Aeson.Types.ToJSON..=)) (paymentLinkShippingAddressCollection'NonNullableAllowedCountries obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_countries" Data.Aeson.Types.ToJSON..=)) (paymentLinkShippingAddressCollection'NonNullableAllowedCountries obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkShippingAddressCollection'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkShippingAddressCollection'NonNullable" (\obj -> GHC.Base.pure PaymentLinkShippingAddressCollection'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allowed_countries"))

-- | Create a new 'PaymentLinkShippingAddressCollection'NonNullable' with all required fields.
mkPaymentLinkShippingAddressCollection'NonNullable :: PaymentLinkShippingAddressCollection'NonNullable
mkPaymentLinkShippingAddressCollection'NonNullable = PaymentLinkShippingAddressCollection'NonNullable {paymentLinkShippingAddressCollection'NonNullableAllowedCountries = GHC.Maybe.Nothing}

-- | Defines the enum schema located at @components.schemas.payment_link.properties.shipping_address_collection.anyOf.properties.allowed_countries.items@ in the specification.
data PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"AC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAC
  | -- | Represents the JSON value @"AD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAD
  | -- | Represents the JSON value @"AE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAE
  | -- | Represents the JSON value @"AF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAF
  | -- | Represents the JSON value @"AG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAG
  | -- | Represents the JSON value @"AI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAI
  | -- | Represents the JSON value @"AL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAL
  | -- | Represents the JSON value @"AM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAM
  | -- | Represents the JSON value @"AO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAO
  | -- | Represents the JSON value @"AQ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAQ
  | -- | Represents the JSON value @"AR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAR
  | -- | Represents the JSON value @"AT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAT
  | -- | Represents the JSON value @"AU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAU
  | -- | Represents the JSON value @"AW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAW
  | -- | Represents the JSON value @"AX"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAX
  | -- | Represents the JSON value @"AZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAZ
  | -- | Represents the JSON value @"BA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBA
  | -- | Represents the JSON value @"BB"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBB
  | -- | Represents the JSON value @"BD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBD
  | -- | Represents the JSON value @"BE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBE
  | -- | Represents the JSON value @"BF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBF
  | -- | Represents the JSON value @"BG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBG
  | -- | Represents the JSON value @"BH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBH
  | -- | Represents the JSON value @"BI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBI
  | -- | Represents the JSON value @"BJ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBJ
  | -- | Represents the JSON value @"BL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBL
  | -- | Represents the JSON value @"BM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBM
  | -- | Represents the JSON value @"BN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBN
  | -- | Represents the JSON value @"BO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBO
  | -- | Represents the JSON value @"BQ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBQ
  | -- | Represents the JSON value @"BR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBR
  | -- | Represents the JSON value @"BS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBS
  | -- | Represents the JSON value @"BT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBT
  | -- | Represents the JSON value @"BV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBV
  | -- | Represents the JSON value @"BW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBW
  | -- | Represents the JSON value @"BY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBY
  | -- | Represents the JSON value @"BZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBZ
  | -- | Represents the JSON value @"CA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCA
  | -- | Represents the JSON value @"CD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCD
  | -- | Represents the JSON value @"CF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCF
  | -- | Represents the JSON value @"CG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCG
  | -- | Represents the JSON value @"CH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCH
  | -- | Represents the JSON value @"CI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCI
  | -- | Represents the JSON value @"CK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCK
  | -- | Represents the JSON value @"CL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCL
  | -- | Represents the JSON value @"CM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCM
  | -- | Represents the JSON value @"CN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCN
  | -- | Represents the JSON value @"CO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCO
  | -- | Represents the JSON value @"CR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCR
  | -- | Represents the JSON value @"CV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCV
  | -- | Represents the JSON value @"CW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCW
  | -- | Represents the JSON value @"CY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCY
  | -- | Represents the JSON value @"CZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCZ
  | -- | Represents the JSON value @"DE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDE
  | -- | Represents the JSON value @"DJ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDJ
  | -- | Represents the JSON value @"DK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDK
  | -- | Represents the JSON value @"DM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDM
  | -- | Represents the JSON value @"DO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDO
  | -- | Represents the JSON value @"DZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDZ
  | -- | Represents the JSON value @"EC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEC
  | -- | Represents the JSON value @"EE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEE
  | -- | Represents the JSON value @"EG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEG
  | -- | Represents the JSON value @"EH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEH
  | -- | Represents the JSON value @"ER"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumER
  | -- | Represents the JSON value @"ES"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumES
  | -- | Represents the JSON value @"ET"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumET
  | -- | Represents the JSON value @"FI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFI
  | -- | Represents the JSON value @"FJ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFJ
  | -- | Represents the JSON value @"FK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFK
  | -- | Represents the JSON value @"FO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFO
  | -- | Represents the JSON value @"FR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFR
  | -- | Represents the JSON value @"GA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGA
  | -- | Represents the JSON value @"GB"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGB
  | -- | Represents the JSON value @"GD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGD
  | -- | Represents the JSON value @"GE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGE
  | -- | Represents the JSON value @"GF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGF
  | -- | Represents the JSON value @"GG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGG
  | -- | Represents the JSON value @"GH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGH
  | -- | Represents the JSON value @"GI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGI
  | -- | Represents the JSON value @"GL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGL
  | -- | Represents the JSON value @"GM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGM
  | -- | Represents the JSON value @"GN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGN
  | -- | Represents the JSON value @"GP"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGP
  | -- | Represents the JSON value @"GQ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGQ
  | -- | Represents the JSON value @"GR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGR
  | -- | Represents the JSON value @"GS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGS
  | -- | Represents the JSON value @"GT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGT
  | -- | Represents the JSON value @"GU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGU
  | -- | Represents the JSON value @"GW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGW
  | -- | Represents the JSON value @"GY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGY
  | -- | Represents the JSON value @"HK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHK
  | -- | Represents the JSON value @"HN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHN
  | -- | Represents the JSON value @"HR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHR
  | -- | Represents the JSON value @"HT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHT
  | -- | Represents the JSON value @"HU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHU
  | -- | Represents the JSON value @"ID"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumID
  | -- | Represents the JSON value @"IE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIE
  | -- | Represents the JSON value @"IL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIL
  | -- | Represents the JSON value @"IM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIM
  | -- | Represents the JSON value @"IN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIN
  | -- | Represents the JSON value @"IO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIO
  | -- | Represents the JSON value @"IQ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIQ
  | -- | Represents the JSON value @"IS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIS
  | -- | Represents the JSON value @"IT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIT
  | -- | Represents the JSON value @"JE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJE
  | -- | Represents the JSON value @"JM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJM
  | -- | Represents the JSON value @"JO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJO
  | -- | Represents the JSON value @"JP"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJP
  | -- | Represents the JSON value @"KE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKE
  | -- | Represents the JSON value @"KG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKG
  | -- | Represents the JSON value @"KH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKH
  | -- | Represents the JSON value @"KI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKI
  | -- | Represents the JSON value @"KM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKM
  | -- | Represents the JSON value @"KN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKN
  | -- | Represents the JSON value @"KR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKR
  | -- | Represents the JSON value @"KW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKW
  | -- | Represents the JSON value @"KY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKY
  | -- | Represents the JSON value @"KZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKZ
  | -- | Represents the JSON value @"LA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLA
  | -- | Represents the JSON value @"LB"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLB
  | -- | Represents the JSON value @"LC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLC
  | -- | Represents the JSON value @"LI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLI
  | -- | Represents the JSON value @"LK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLK
  | -- | Represents the JSON value @"LR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLR
  | -- | Represents the JSON value @"LS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLS
  | -- | Represents the JSON value @"LT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLT
  | -- | Represents the JSON value @"LU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLU
  | -- | Represents the JSON value @"LV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLV
  | -- | Represents the JSON value @"LY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLY
  | -- | Represents the JSON value @"MA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMA
  | -- | Represents the JSON value @"MC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMC
  | -- | Represents the JSON value @"MD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMD
  | -- | Represents the JSON value @"ME"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumME
  | -- | Represents the JSON value @"MF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMF
  | -- | Represents the JSON value @"MG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMG
  | -- | Represents the JSON value @"MK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMK
  | -- | Represents the JSON value @"ML"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumML
  | -- | Represents the JSON value @"MM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMM
  | -- | Represents the JSON value @"MN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMN
  | -- | Represents the JSON value @"MO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMO
  | -- | Represents the JSON value @"MQ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMQ
  | -- | Represents the JSON value @"MR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMR
  | -- | Represents the JSON value @"MS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMS
  | -- | Represents the JSON value @"MT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMT
  | -- | Represents the JSON value @"MU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMU
  | -- | Represents the JSON value @"MV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMV
  | -- | Represents the JSON value @"MW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMW
  | -- | Represents the JSON value @"MX"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMX
  | -- | Represents the JSON value @"MY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMY
  | -- | Represents the JSON value @"MZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMZ
  | -- | Represents the JSON value @"NA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNA
  | -- | Represents the JSON value @"NC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNC
  | -- | Represents the JSON value @"NE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNE
  | -- | Represents the JSON value @"NG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNG
  | -- | Represents the JSON value @"NI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNI
  | -- | Represents the JSON value @"NL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNL
  | -- | Represents the JSON value @"NO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNO
  | -- | Represents the JSON value @"NP"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNP
  | -- | Represents the JSON value @"NR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNR
  | -- | Represents the JSON value @"NU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNU
  | -- | Represents the JSON value @"NZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNZ
  | -- | Represents the JSON value @"OM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumOM
  | -- | Represents the JSON value @"PA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPA
  | -- | Represents the JSON value @"PE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPE
  | -- | Represents the JSON value @"PF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPF
  | -- | Represents the JSON value @"PG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPG
  | -- | Represents the JSON value @"PH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPH
  | -- | Represents the JSON value @"PK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPK
  | -- | Represents the JSON value @"PL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPL
  | -- | Represents the JSON value @"PM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPM
  | -- | Represents the JSON value @"PN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPN
  | -- | Represents the JSON value @"PR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPR
  | -- | Represents the JSON value @"PS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPS
  | -- | Represents the JSON value @"PT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPT
  | -- | Represents the JSON value @"PY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPY
  | -- | Represents the JSON value @"QA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumQA
  | -- | Represents the JSON value @"RE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRE
  | -- | Represents the JSON value @"RO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRO
  | -- | Represents the JSON value @"RS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRS
  | -- | Represents the JSON value @"RU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRU
  | -- | Represents the JSON value @"RW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRW
  | -- | Represents the JSON value @"SA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSA
  | -- | Represents the JSON value @"SB"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSB
  | -- | Represents the JSON value @"SC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSC
  | -- | Represents the JSON value @"SE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSE
  | -- | Represents the JSON value @"SG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSG
  | -- | Represents the JSON value @"SH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSH
  | -- | Represents the JSON value @"SI"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSI
  | -- | Represents the JSON value @"SJ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSJ
  | -- | Represents the JSON value @"SK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSK
  | -- | Represents the JSON value @"SL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSL
  | -- | Represents the JSON value @"SM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSM
  | -- | Represents the JSON value @"SN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSN
  | -- | Represents the JSON value @"SO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSO
  | -- | Represents the JSON value @"SR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSR
  | -- | Represents the JSON value @"SS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSS
  | -- | Represents the JSON value @"ST"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumST
  | -- | Represents the JSON value @"SV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSV
  | -- | Represents the JSON value @"SX"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSX
  | -- | Represents the JSON value @"SZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSZ
  | -- | Represents the JSON value @"TA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTA
  | -- | Represents the JSON value @"TC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTC
  | -- | Represents the JSON value @"TD"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTD
  | -- | Represents the JSON value @"TF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTF
  | -- | Represents the JSON value @"TG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTG
  | -- | Represents the JSON value @"TH"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTH
  | -- | Represents the JSON value @"TJ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTJ
  | -- | Represents the JSON value @"TK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTK
  | -- | Represents the JSON value @"TL"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTL
  | -- | Represents the JSON value @"TM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTM
  | -- | Represents the JSON value @"TN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTN
  | -- | Represents the JSON value @"TO"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTO
  | -- | Represents the JSON value @"TR"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTR
  | -- | Represents the JSON value @"TT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTT
  | -- | Represents the JSON value @"TV"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTV
  | -- | Represents the JSON value @"TW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTW
  | -- | Represents the JSON value @"TZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTZ
  | -- | Represents the JSON value @"UA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUA
  | -- | Represents the JSON value @"UG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUG
  | -- | Represents the JSON value @"US"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUS
  | -- | Represents the JSON value @"UY"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUY
  | -- | Represents the JSON value @"UZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUZ
  | -- | Represents the JSON value @"VA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVA
  | -- | Represents the JSON value @"VC"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVC
  | -- | Represents the JSON value @"VE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVE
  | -- | Represents the JSON value @"VG"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVG
  | -- | Represents the JSON value @"VN"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVN
  | -- | Represents the JSON value @"VU"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVU
  | -- | Represents the JSON value @"WF"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWF
  | -- | Represents the JSON value @"WS"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWS
  | -- | Represents the JSON value @"XK"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumXK
  | -- | Represents the JSON value @"YE"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYE
  | -- | Represents the JSON value @"YT"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYT
  | -- | Represents the JSON value @"ZA"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZA
  | -- | Represents the JSON value @"ZM"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZM
  | -- | Represents the JSON value @"ZW"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZW
  | -- | Represents the JSON value @"ZZ"@
    PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZZ
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkShippingAddressCollection'NonNullableAllowedCountries' where
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'Other val) = val
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAC) = "AC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAD) = "AD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAE) = "AE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAF) = "AF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAG) = "AG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAI) = "AI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAL) = "AL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAM) = "AM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAO) = "AO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAQ) = "AQ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAR) = "AR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAT) = "AT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAU) = "AU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAW) = "AW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAX) = "AX"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAZ) = "AZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBA) = "BA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBB) = "BB"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBD) = "BD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBE) = "BE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBF) = "BF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBG) = "BG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBH) = "BH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBI) = "BI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBJ) = "BJ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBL) = "BL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBM) = "BM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBN) = "BN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBO) = "BO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBQ) = "BQ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBR) = "BR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBS) = "BS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBT) = "BT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBV) = "BV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBW) = "BW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBY) = "BY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBZ) = "BZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCA) = "CA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCD) = "CD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCF) = "CF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCG) = "CG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCH) = "CH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCI) = "CI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCK) = "CK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCL) = "CL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCM) = "CM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCN) = "CN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCO) = "CO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCR) = "CR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCV) = "CV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCW) = "CW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCY) = "CY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCZ) = "CZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDE) = "DE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDJ) = "DJ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDK) = "DK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDM) = "DM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDO) = "DO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDZ) = "DZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEC) = "EC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEE) = "EE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEG) = "EG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEH) = "EH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumER) = "ER"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumES) = "ES"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumET) = "ET"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFI) = "FI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFJ) = "FJ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFK) = "FK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFO) = "FO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFR) = "FR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGA) = "GA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGB) = "GB"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGD) = "GD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGE) = "GE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGF) = "GF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGG) = "GG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGH) = "GH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGI) = "GI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGL) = "GL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGM) = "GM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGN) = "GN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGP) = "GP"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGQ) = "GQ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGR) = "GR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGS) = "GS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGT) = "GT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGU) = "GU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGW) = "GW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGY) = "GY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHK) = "HK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHN) = "HN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHR) = "HR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHT) = "HT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHU) = "HU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumID) = "ID"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIE) = "IE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIL) = "IL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIM) = "IM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIN) = "IN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIO) = "IO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIQ) = "IQ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIS) = "IS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIT) = "IT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJE) = "JE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJM) = "JM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJO) = "JO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJP) = "JP"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKE) = "KE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKG) = "KG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKH) = "KH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKI) = "KI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKM) = "KM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKN) = "KN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKR) = "KR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKW) = "KW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKY) = "KY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKZ) = "KZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLA) = "LA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLB) = "LB"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLC) = "LC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLI) = "LI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLK) = "LK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLR) = "LR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLS) = "LS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLT) = "LT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLU) = "LU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLV) = "LV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLY) = "LY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMA) = "MA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMC) = "MC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMD) = "MD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumME) = "ME"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMF) = "MF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMG) = "MG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMK) = "MK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumML) = "ML"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMM) = "MM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMN) = "MN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMO) = "MO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMQ) = "MQ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMR) = "MR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMS) = "MS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMT) = "MT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMU) = "MU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMV) = "MV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMW) = "MW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMX) = "MX"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMY) = "MY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMZ) = "MZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNA) = "NA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNC) = "NC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNE) = "NE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNG) = "NG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNI) = "NI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNL) = "NL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNO) = "NO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNP) = "NP"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNR) = "NR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNU) = "NU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNZ) = "NZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumOM) = "OM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPA) = "PA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPE) = "PE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPF) = "PF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPG) = "PG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPH) = "PH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPK) = "PK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPL) = "PL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPM) = "PM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPN) = "PN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPR) = "PR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPS) = "PS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPT) = "PT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPY) = "PY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumQA) = "QA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRE) = "RE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRO) = "RO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRS) = "RS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRU) = "RU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRW) = "RW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSA) = "SA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSB) = "SB"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSC) = "SC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSE) = "SE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSG) = "SG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSH) = "SH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSI) = "SI"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSJ) = "SJ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSK) = "SK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSL) = "SL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSM) = "SM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSN) = "SN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSO) = "SO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSR) = "SR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSS) = "SS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumST) = "ST"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSV) = "SV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSX) = "SX"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSZ) = "SZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTA) = "TA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTC) = "TC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTD) = "TD"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTF) = "TF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTG) = "TG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTH) = "TH"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTJ) = "TJ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTK) = "TK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTL) = "TL"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTM) = "TM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTN) = "TN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTO) = "TO"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTR) = "TR"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTT) = "TT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTV) = "TV"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTW) = "TW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTZ) = "TZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUA) = "UA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUG) = "UG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUS) = "US"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUY) = "UY"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUZ) = "UZ"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVA) = "VA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVC) = "VC"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVE) = "VE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVG) = "VG"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVN) = "VN"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVU) = "VU"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWF) = "WF"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWS) = "WS"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumXK) = "XK"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYE) = "YE"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYT) = "YT"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZA) = "ZA"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZM) = "ZM"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZW) = "ZW"
  toJSON (PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZZ) = "ZZ"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkShippingAddressCollection'NonNullableAllowedCountries' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "AC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAC
            | val GHC.Classes.== "AD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAD
            | val GHC.Classes.== "AE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAE
            | val GHC.Classes.== "AF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAF
            | val GHC.Classes.== "AG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAG
            | val GHC.Classes.== "AI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAI
            | val GHC.Classes.== "AL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAL
            | val GHC.Classes.== "AM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAM
            | val GHC.Classes.== "AO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAO
            | val GHC.Classes.== "AQ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAQ
            | val GHC.Classes.== "AR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAR
            | val GHC.Classes.== "AT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAT
            | val GHC.Classes.== "AU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAU
            | val GHC.Classes.== "AW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAW
            | val GHC.Classes.== "AX" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAX
            | val GHC.Classes.== "AZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumAZ
            | val GHC.Classes.== "BA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBA
            | val GHC.Classes.== "BB" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBB
            | val GHC.Classes.== "BD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBD
            | val GHC.Classes.== "BE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBE
            | val GHC.Classes.== "BF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBF
            | val GHC.Classes.== "BG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBG
            | val GHC.Classes.== "BH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBH
            | val GHC.Classes.== "BI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBI
            | val GHC.Classes.== "BJ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBJ
            | val GHC.Classes.== "BL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBL
            | val GHC.Classes.== "BM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBM
            | val GHC.Classes.== "BN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBN
            | val GHC.Classes.== "BO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBO
            | val GHC.Classes.== "BQ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBQ
            | val GHC.Classes.== "BR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBR
            | val GHC.Classes.== "BS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBS
            | val GHC.Classes.== "BT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBT
            | val GHC.Classes.== "BV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBV
            | val GHC.Classes.== "BW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBW
            | val GHC.Classes.== "BY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBY
            | val GHC.Classes.== "BZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumBZ
            | val GHC.Classes.== "CA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCA
            | val GHC.Classes.== "CD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCD
            | val GHC.Classes.== "CF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCF
            | val GHC.Classes.== "CG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCG
            | val GHC.Classes.== "CH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCH
            | val GHC.Classes.== "CI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCI
            | val GHC.Classes.== "CK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCK
            | val GHC.Classes.== "CL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCL
            | val GHC.Classes.== "CM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCM
            | val GHC.Classes.== "CN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCN
            | val GHC.Classes.== "CO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCO
            | val GHC.Classes.== "CR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCR
            | val GHC.Classes.== "CV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCV
            | val GHC.Classes.== "CW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCW
            | val GHC.Classes.== "CY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCY
            | val GHC.Classes.== "CZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumCZ
            | val GHC.Classes.== "DE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDE
            | val GHC.Classes.== "DJ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDJ
            | val GHC.Classes.== "DK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDK
            | val GHC.Classes.== "DM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDM
            | val GHC.Classes.== "DO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDO
            | val GHC.Classes.== "DZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumDZ
            | val GHC.Classes.== "EC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEC
            | val GHC.Classes.== "EE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEE
            | val GHC.Classes.== "EG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEG
            | val GHC.Classes.== "EH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumEH
            | val GHC.Classes.== "ER" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumER
            | val GHC.Classes.== "ES" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumES
            | val GHC.Classes.== "ET" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumET
            | val GHC.Classes.== "FI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFI
            | val GHC.Classes.== "FJ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFJ
            | val GHC.Classes.== "FK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFK
            | val GHC.Classes.== "FO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFO
            | val GHC.Classes.== "FR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumFR
            | val GHC.Classes.== "GA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGA
            | val GHC.Classes.== "GB" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGB
            | val GHC.Classes.== "GD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGD
            | val GHC.Classes.== "GE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGE
            | val GHC.Classes.== "GF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGF
            | val GHC.Classes.== "GG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGG
            | val GHC.Classes.== "GH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGH
            | val GHC.Classes.== "GI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGI
            | val GHC.Classes.== "GL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGL
            | val GHC.Classes.== "GM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGM
            | val GHC.Classes.== "GN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGN
            | val GHC.Classes.== "GP" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGP
            | val GHC.Classes.== "GQ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGQ
            | val GHC.Classes.== "GR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGR
            | val GHC.Classes.== "GS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGS
            | val GHC.Classes.== "GT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGT
            | val GHC.Classes.== "GU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGU
            | val GHC.Classes.== "GW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGW
            | val GHC.Classes.== "GY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumGY
            | val GHC.Classes.== "HK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHK
            | val GHC.Classes.== "HN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHN
            | val GHC.Classes.== "HR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHR
            | val GHC.Classes.== "HT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHT
            | val GHC.Classes.== "HU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumHU
            | val GHC.Classes.== "ID" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumID
            | val GHC.Classes.== "IE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIE
            | val GHC.Classes.== "IL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIL
            | val GHC.Classes.== "IM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIM
            | val GHC.Classes.== "IN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIN
            | val GHC.Classes.== "IO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIO
            | val GHC.Classes.== "IQ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIQ
            | val GHC.Classes.== "IS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIS
            | val GHC.Classes.== "IT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumIT
            | val GHC.Classes.== "JE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJE
            | val GHC.Classes.== "JM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJM
            | val GHC.Classes.== "JO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJO
            | val GHC.Classes.== "JP" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumJP
            | val GHC.Classes.== "KE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKE
            | val GHC.Classes.== "KG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKG
            | val GHC.Classes.== "KH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKH
            | val GHC.Classes.== "KI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKI
            | val GHC.Classes.== "KM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKM
            | val GHC.Classes.== "KN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKN
            | val GHC.Classes.== "KR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKR
            | val GHC.Classes.== "KW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKW
            | val GHC.Classes.== "KY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKY
            | val GHC.Classes.== "KZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumKZ
            | val GHC.Classes.== "LA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLA
            | val GHC.Classes.== "LB" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLB
            | val GHC.Classes.== "LC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLC
            | val GHC.Classes.== "LI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLI
            | val GHC.Classes.== "LK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLK
            | val GHC.Classes.== "LR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLR
            | val GHC.Classes.== "LS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLS
            | val GHC.Classes.== "LT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLT
            | val GHC.Classes.== "LU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLU
            | val GHC.Classes.== "LV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLV
            | val GHC.Classes.== "LY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumLY
            | val GHC.Classes.== "MA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMA
            | val GHC.Classes.== "MC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMC
            | val GHC.Classes.== "MD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMD
            | val GHC.Classes.== "ME" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumME
            | val GHC.Classes.== "MF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMF
            | val GHC.Classes.== "MG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMG
            | val GHC.Classes.== "MK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMK
            | val GHC.Classes.== "ML" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumML
            | val GHC.Classes.== "MM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMM
            | val GHC.Classes.== "MN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMN
            | val GHC.Classes.== "MO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMO
            | val GHC.Classes.== "MQ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMQ
            | val GHC.Classes.== "MR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMR
            | val GHC.Classes.== "MS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMS
            | val GHC.Classes.== "MT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMT
            | val GHC.Classes.== "MU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMU
            | val GHC.Classes.== "MV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMV
            | val GHC.Classes.== "MW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMW
            | val GHC.Classes.== "MX" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMX
            | val GHC.Classes.== "MY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMY
            | val GHC.Classes.== "MZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumMZ
            | val GHC.Classes.== "NA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNA
            | val GHC.Classes.== "NC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNC
            | val GHC.Classes.== "NE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNE
            | val GHC.Classes.== "NG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNG
            | val GHC.Classes.== "NI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNI
            | val GHC.Classes.== "NL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNL
            | val GHC.Classes.== "NO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNO
            | val GHC.Classes.== "NP" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNP
            | val GHC.Classes.== "NR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNR
            | val GHC.Classes.== "NU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNU
            | val GHC.Classes.== "NZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumNZ
            | val GHC.Classes.== "OM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumOM
            | val GHC.Classes.== "PA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPA
            | val GHC.Classes.== "PE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPE
            | val GHC.Classes.== "PF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPF
            | val GHC.Classes.== "PG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPG
            | val GHC.Classes.== "PH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPH
            | val GHC.Classes.== "PK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPK
            | val GHC.Classes.== "PL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPL
            | val GHC.Classes.== "PM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPM
            | val GHC.Classes.== "PN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPN
            | val GHC.Classes.== "PR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPR
            | val GHC.Classes.== "PS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPS
            | val GHC.Classes.== "PT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPT
            | val GHC.Classes.== "PY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumPY
            | val GHC.Classes.== "QA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumQA
            | val GHC.Classes.== "RE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRE
            | val GHC.Classes.== "RO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRO
            | val GHC.Classes.== "RS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRS
            | val GHC.Classes.== "RU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRU
            | val GHC.Classes.== "RW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumRW
            | val GHC.Classes.== "SA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSA
            | val GHC.Classes.== "SB" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSB
            | val GHC.Classes.== "SC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSC
            | val GHC.Classes.== "SE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSE
            | val GHC.Classes.== "SG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSG
            | val GHC.Classes.== "SH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSH
            | val GHC.Classes.== "SI" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSI
            | val GHC.Classes.== "SJ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSJ
            | val GHC.Classes.== "SK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSK
            | val GHC.Classes.== "SL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSL
            | val GHC.Classes.== "SM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSM
            | val GHC.Classes.== "SN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSN
            | val GHC.Classes.== "SO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSO
            | val GHC.Classes.== "SR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSR
            | val GHC.Classes.== "SS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSS
            | val GHC.Classes.== "ST" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumST
            | val GHC.Classes.== "SV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSV
            | val GHC.Classes.== "SX" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSX
            | val GHC.Classes.== "SZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumSZ
            | val GHC.Classes.== "TA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTA
            | val GHC.Classes.== "TC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTC
            | val GHC.Classes.== "TD" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTD
            | val GHC.Classes.== "TF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTF
            | val GHC.Classes.== "TG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTG
            | val GHC.Classes.== "TH" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTH
            | val GHC.Classes.== "TJ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTJ
            | val GHC.Classes.== "TK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTK
            | val GHC.Classes.== "TL" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTL
            | val GHC.Classes.== "TM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTM
            | val GHC.Classes.== "TN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTN
            | val GHC.Classes.== "TO" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTO
            | val GHC.Classes.== "TR" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTR
            | val GHC.Classes.== "TT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTT
            | val GHC.Classes.== "TV" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTV
            | val GHC.Classes.== "TW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTW
            | val GHC.Classes.== "TZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumTZ
            | val GHC.Classes.== "UA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUA
            | val GHC.Classes.== "UG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUG
            | val GHC.Classes.== "US" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUS
            | val GHC.Classes.== "UY" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUY
            | val GHC.Classes.== "UZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumUZ
            | val GHC.Classes.== "VA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVA
            | val GHC.Classes.== "VC" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVC
            | val GHC.Classes.== "VE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVE
            | val GHC.Classes.== "VG" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVG
            | val GHC.Classes.== "VN" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVN
            | val GHC.Classes.== "VU" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumVU
            | val GHC.Classes.== "WF" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWF
            | val GHC.Classes.== "WS" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumWS
            | val GHC.Classes.== "XK" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumXK
            | val GHC.Classes.== "YE" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYE
            | val GHC.Classes.== "YT" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumYT
            | val GHC.Classes.== "ZA" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZA
            | val GHC.Classes.== "ZM" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZM
            | val GHC.Classes.== "ZW" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZW
            | val GHC.Classes.== "ZZ" -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'EnumZZ
            | GHC.Base.otherwise -> PaymentLinkShippingAddressCollection'NonNullableAllowedCountries'Other val
      )

-- | Defines the enum schema located at @components.schemas.payment_link.properties.submit_type@ in the specification.
--
-- Indicates the type of transaction being performed which customizes relevant text on the page, such as the submit button.
data PaymentLinkSubmitType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentLinkSubmitType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentLinkSubmitType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"auto"@
    PaymentLinkSubmitType'EnumAuto
  | -- | Represents the JSON value @"book"@
    PaymentLinkSubmitType'EnumBook
  | -- | Represents the JSON value @"donate"@
    PaymentLinkSubmitType'EnumDonate
  | -- | Represents the JSON value @"pay"@
    PaymentLinkSubmitType'EnumPay
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkSubmitType' where
  toJSON (PaymentLinkSubmitType'Other val) = val
  toJSON (PaymentLinkSubmitType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentLinkSubmitType'EnumAuto) = "auto"
  toJSON (PaymentLinkSubmitType'EnumBook) = "book"
  toJSON (PaymentLinkSubmitType'EnumDonate) = "donate"
  toJSON (PaymentLinkSubmitType'EnumPay) = "pay"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkSubmitType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "auto" -> PaymentLinkSubmitType'EnumAuto
            | val GHC.Classes.== "book" -> PaymentLinkSubmitType'EnumBook
            | val GHC.Classes.== "donate" -> PaymentLinkSubmitType'EnumDonate
            | val GHC.Classes.== "pay" -> PaymentLinkSubmitType'EnumPay
            | GHC.Base.otherwise -> PaymentLinkSubmitType'Other val
      )

-- | Defines the object schema located at @components.schemas.payment_link.properties.subscription_data.anyOf@ in the specification.
--
-- When creating a subscription, the specified configuration data will be used. There must be at least one line item with a recurring price to use \\\`subscription_data\\\`.
data PaymentLinkSubscriptionData'NonNullable = PaymentLinkSubscriptionData'NonNullable
  { -- | trial_period_days: Integer representing the number of trial period days before the customer is charged for the first time.
    paymentLinkSubscriptionData'NonNullableTrialPeriodDays :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkSubscriptionData'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("trial_period_days" Data.Aeson.Types.ToJSON..=)) (paymentLinkSubscriptionData'NonNullableTrialPeriodDays obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("trial_period_days" Data.Aeson.Types.ToJSON..=)) (paymentLinkSubscriptionData'NonNullableTrialPeriodDays obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkSubscriptionData'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkSubscriptionData'NonNullable" (\obj -> GHC.Base.pure PaymentLinkSubscriptionData'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "trial_period_days"))

-- | Create a new 'PaymentLinkSubscriptionData'NonNullable' with all required fields.
mkPaymentLinkSubscriptionData'NonNullable :: PaymentLinkSubscriptionData'NonNullable
mkPaymentLinkSubscriptionData'NonNullable = PaymentLinkSubscriptionData'NonNullable {paymentLinkSubscriptionData'NonNullableTrialPeriodDays = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.payment_link.properties.transfer_data.anyOf@ in the specification.
--
-- The account (if any) the payments will be attributed to for tax reporting, and where funds from each payment will be transferred to.
data PaymentLinkTransferData'NonNullable = PaymentLinkTransferData'NonNullable
  { -- | amount: The amount in %s that will be transferred to the destination account. By default, the entire amount is transferred to the destination.
    paymentLinkTransferData'NonNullableAmount :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int)),
    -- | destination: The connected account receiving the transfer.
    paymentLinkTransferData'NonNullableDestination :: (GHC.Maybe.Maybe PaymentLinkTransferData'NonNullableDestination'Variants)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkTransferData'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData'NonNullableAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("destination" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData'NonNullableDestination obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("amount" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData'NonNullableAmount obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("destination" Data.Aeson.Types.ToJSON..=)) (paymentLinkTransferData'NonNullableDestination obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkTransferData'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentLinkTransferData'NonNullable" (\obj -> (GHC.Base.pure PaymentLinkTransferData'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "amount")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "destination"))

-- | Create a new 'PaymentLinkTransferData'NonNullable' with all required fields.
mkPaymentLinkTransferData'NonNullable :: PaymentLinkTransferData'NonNullable
mkPaymentLinkTransferData'NonNullable =
  PaymentLinkTransferData'NonNullable
    { paymentLinkTransferData'NonNullableAmount = GHC.Maybe.Nothing,
      paymentLinkTransferData'NonNullableDestination = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @components.schemas.payment_link.properties.transfer_data.anyOf.properties.destination.anyOf@ in the specification.
--
-- The connected account receiving the transfer.
data PaymentLinkTransferData'NonNullableDestination'Variants
  = PaymentLinkTransferData'NonNullableDestination'Text Data.Text.Internal.Text
  | PaymentLinkTransferData'NonNullableDestination'Account Account
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentLinkTransferData'NonNullableDestination'Variants where
  toJSON (PaymentLinkTransferData'NonNullableDestination'Text a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (PaymentLinkTransferData'NonNullableDestination'Account a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON PaymentLinkTransferData'NonNullableDestination'Variants where
  parseJSON val = case (PaymentLinkTransferData'NonNullableDestination'Text Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((PaymentLinkTransferData'NonNullableDestination'Account Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a
