{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema PaymentMethodOptionsPaypal
module StripeAPI.Types.PaymentMethodOptionsPaypal where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.payment_method_options_paypal@ in the specification.
data PaymentMethodOptionsPaypal = PaymentMethodOptionsPaypal
  { -- | capture_method: Controls when the funds will be captured from the customer\'s account.
    paymentMethodOptionsPaypalCaptureMethod :: (GHC.Maybe.Maybe PaymentMethodOptionsPaypalCaptureMethod'),
    -- | preferred_locale: Preferred locale of the PayPal checkout page that the customer is redirected to.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    paymentMethodOptionsPaypalPreferredLocale :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsPaypal where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsPaypalCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_locale" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsPaypalPreferredLocale obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("capture_method" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsPaypalCaptureMethod obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("preferred_locale" Data.Aeson.Types.ToJSON..=)) (paymentMethodOptionsPaypalPreferredLocale obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsPaypal where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "PaymentMethodOptionsPaypal" (\obj -> (GHC.Base.pure PaymentMethodOptionsPaypal GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "capture_method")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "preferred_locale"))

-- | Create a new 'PaymentMethodOptionsPaypal' with all required fields.
mkPaymentMethodOptionsPaypal :: PaymentMethodOptionsPaypal
mkPaymentMethodOptionsPaypal =
  PaymentMethodOptionsPaypal
    { paymentMethodOptionsPaypalCaptureMethod = GHC.Maybe.Nothing,
      paymentMethodOptionsPaypalPreferredLocale = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.payment_method_options_paypal.properties.capture_method@ in the specification.
--
-- Controls when the funds will be captured from the customer\'s account.
data PaymentMethodOptionsPaypalCaptureMethod'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    PaymentMethodOptionsPaypalCaptureMethod'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    PaymentMethodOptionsPaypalCaptureMethod'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"manual"@
    PaymentMethodOptionsPaypalCaptureMethod'EnumManual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON PaymentMethodOptionsPaypalCaptureMethod' where
  toJSON (PaymentMethodOptionsPaypalCaptureMethod'Other val) = val
  toJSON (PaymentMethodOptionsPaypalCaptureMethod'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (PaymentMethodOptionsPaypalCaptureMethod'EnumManual) = "manual"

instance Data.Aeson.Types.FromJSON.FromJSON PaymentMethodOptionsPaypalCaptureMethod' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "manual" -> PaymentMethodOptionsPaypalCaptureMethod'EnumManual
            | GHC.Base.otherwise -> PaymentMethodOptionsPaypalCaptureMethod'Other val
      )
