{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema ReceivedCreditsResourceTreasuryLinkedFlows
module StripeAPI.Types.ReceivedCreditsResourceTreasuryLinkedFlows where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.Payout
import {-# SOURCE #-} StripeAPI.Types.ReceivedCreditsResourceTreasurySourceFlowsDetails
import {-# SOURCE #-} StripeAPI.Types.Treasury_CreditReversal
import {-# SOURCE #-} StripeAPI.Types.Treasury_OutboundPayment
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.received_credits_resource_treasury_linked_flows@ in the specification.
data ReceivedCreditsResourceTreasuryLinkedFlows = ReceivedCreditsResourceTreasuryLinkedFlows
  { -- | credit_reversal: The CreditReversal created as a result of this ReceivedCredit being reversed.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    receivedCreditsResourceTreasuryLinkedFlowsCreditReversal :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | issuing_authorization: Set if the ReceivedCredit was created due to an [Issuing Authorization](https:\/\/stripe.com\/docs\/api\#issuing_authorizations) object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    receivedCreditsResourceTreasuryLinkedFlowsIssuingAuthorization :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | issuing_transaction: Set if the ReceivedCredit is also viewable as an [Issuing transaction](https:\/\/stripe.com\/docs\/api\#issuing_transactions) object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    receivedCreditsResourceTreasuryLinkedFlowsIssuingTransaction :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | source_flow: ID of the source flow. Set if \`network\` is \`stripe\` and the source flow is visible to the merchant. Examples of source flows include OutboundPayments, payouts, or CreditReversals.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlow :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | source_flow_details: The expandable object of the source flow.
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable)),
    -- | source_flow_type: The type of flow that originated the ReceivedCredit (for example, \`outbound_payment\`).
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowType :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ReceivedCreditsResourceTreasuryLinkedFlows where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("credit_reversal" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsCreditReversal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("issuing_authorization" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsIssuingAuthorization obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("issuing_transaction" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsIssuingTransaction obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlow obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow_details" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow_type" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("credit_reversal" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsCreditReversal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("issuing_authorization" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsIssuingAuthorization obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("issuing_transaction" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsIssuingTransaction obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlow obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow_details" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("source_flow_type" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ReceivedCreditsResourceTreasuryLinkedFlows where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ReceivedCreditsResourceTreasuryLinkedFlows" (\obj -> (((((GHC.Base.pure ReceivedCreditsResourceTreasuryLinkedFlows GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "credit_reversal")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "issuing_authorization")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "issuing_transaction")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "source_flow")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "source_flow_details")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "source_flow_type"))

-- | Create a new 'ReceivedCreditsResourceTreasuryLinkedFlows' with all required fields.
mkReceivedCreditsResourceTreasuryLinkedFlows :: ReceivedCreditsResourceTreasuryLinkedFlows
mkReceivedCreditsResourceTreasuryLinkedFlows =
  ReceivedCreditsResourceTreasuryLinkedFlows
    { receivedCreditsResourceTreasuryLinkedFlowsCreditReversal = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsIssuingAuthorization = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsIssuingTransaction = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlow = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlowType = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.received_credits_resource_treasury_linked_flows.properties.source_flow_details.anyOf@ in the specification.
--
-- The expandable object of the source flow.
data ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable = ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable
  { -- | credit_reversal: You can reverse some [ReceivedCredits](https:\/\/stripe.com\/docs\/api\#received_credits) depending on their network and source flow. Reversing a ReceivedCredit leads to the creation of a new object known as a CreditReversal.
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableCreditReversal :: (GHC.Maybe.Maybe Treasury'creditReversal),
    -- | outbound_payment: Use OutboundPayments to send funds to another party\'s external bank account or [FinancialAccount](https:\/\/stripe.com\/docs\/api\#financial_accounts). To send money to an account belonging to the same user, use an [OutboundTransfer](https:\/\/stripe.com\/docs\/api\#outbound_transfers).
    --
    -- Simulate OutboundPayment state changes with the \`\/v1\/test_helpers\/treasury\/outbound_payments\` endpoints. These methods can only be called on test mode objects.
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableOutboundPayment :: (GHC.Maybe.Maybe Treasury'outboundPayment),
    -- | payout: A \`Payout\` object is created when you receive funds from Stripe, or when you
    -- initiate a payout to either a bank account or debit card of a [connected
    -- Stripe account](\/docs\/connect\/bank-debit-card-payouts). You can retrieve individual payouts,
    -- as well as list all payouts. Payouts are made on [varying
    -- schedules](\/docs\/connect\/manage-payout-schedule), depending on your country and
    -- industry.
    --
    -- Related guide: [Receiving Payouts](https:\/\/stripe.com\/docs\/payouts).
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullablePayout :: (GHC.Maybe.Maybe Payout),
    -- | type: The type of the source flow that originated the ReceivedCredit.
    receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType :: (GHC.Maybe.Maybe ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType')
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("credit_reversal" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableCreditReversal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("outbound_payment" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableOutboundPayment obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payout" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullablePayout obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("credit_reversal" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableCreditReversal obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("outbound_payment" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableOutboundPayment obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("payout" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullablePayout obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("type" Data.Aeson.Types.ToJSON..=)) (receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable" (\obj -> (((GHC.Base.pure ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "credit_reversal")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "outbound_payment")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "payout")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "type"))

-- | Create a new 'ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable' with all required fields.
mkReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable :: ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable
mkReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable =
  ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullable
    { receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableCreditReversal = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableOutboundPayment = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullablePayout = GHC.Maybe.Nothing,
      receivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.received_credits_resource_treasury_linked_flows.properties.source_flow_details.anyOf.properties.type@ in the specification.
--
-- The type of the source flow that originated the ReceivedCredit.
data ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"credit_reversal"@
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumCreditReversal
  | -- | Represents the JSON value @"other"@
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOther
  | -- | Represents the JSON value @"outbound_payment"@
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOutboundPayment
  | -- | Represents the JSON value @"payout"@
    ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumPayout
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType' where
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'Other val) = val
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumCreditReversal) = "credit_reversal"
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOther) = "other"
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOutboundPayment) = "outbound_payment"
  toJSON (ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumPayout) = "payout"

instance Data.Aeson.Types.FromJSON.FromJSON ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "credit_reversal" -> ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumCreditReversal
            | val GHC.Classes.== "other" -> ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOther
            | val GHC.Classes.== "outbound_payment" -> ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumOutboundPayment
            | val GHC.Classes.== "payout" -> ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'EnumPayout
            | GHC.Base.otherwise -> ReceivedCreditsResourceTreasuryLinkedFlowsSourceFlowDetails'NonNullableType'Other val
      )
