{-# LANGUAGE MultiWayIf #-}
-- CHANGE WITH CAUTION: This is a generated code file generated by https://github.com/Haskell-OpenAPI-Code-Generator/Haskell-OpenAPI-Client-Code-Generator.
{-# LANGUAGE OverloadedStrings #-}

-- | Contains the types generated from the schema Issuing_Cardholder
module StripeAPI.Types.Issuing_Cardholder where

import qualified Control.Monad.Fail
import qualified Data.Aeson
import qualified Data.Aeson as Data.Aeson.Encoding.Internal
import qualified Data.Aeson as Data.Aeson.Types
import qualified Data.Aeson as Data.Aeson.Types.FromJSON
import qualified Data.Aeson as Data.Aeson.Types.Internal
import qualified Data.Aeson as Data.Aeson.Types.ToJSON
import qualified Data.ByteString.Char8
import qualified Data.ByteString.Char8 as Data.ByteString.Internal
import qualified Data.Foldable
import qualified Data.Functor
import qualified Data.Maybe
import qualified Data.Scientific
import qualified Data.Text
import qualified Data.Text.Internal
import qualified Data.Time.Calendar as Data.Time.Calendar.Days
import qualified Data.Time.LocalTime as Data.Time.LocalTime.Internal.ZonedTime
import qualified GHC.Base
import qualified GHC.Classes
import qualified GHC.Int
import qualified GHC.Show
import qualified GHC.Types
import qualified StripeAPI.Common
import StripeAPI.TypeAlias
import {-# SOURCE #-} StripeAPI.Types.File
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderAddress
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderAuthorizationControls
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderCompany
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIdDocument
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIndividual
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderIndividualDob
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderRequirements
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderSpendingLimit
import {-# SOURCE #-} StripeAPI.Types.IssuingCardholderVerification
import qualified Prelude as GHC.Integer.Type
import qualified Prelude as GHC.Maybe

-- | Defines the object schema located at @components.schemas.issuing.cardholder@ in the specification.
--
-- An Issuing \`Cardholder\` object represents an individual or business entity who is [issued](https:\/\/stripe.com\/docs\/issuing) cards.
--
-- Related guide: [How to create a Cardholder](https:\/\/stripe.com\/docs\/issuing\/cards\#create-cardholder)
data Issuing'cardholder = Issuing'cardholder
  { -- | billing:
    issuing'cardholderBilling :: IssuingCardholderAddress,
    -- | company: Additional information about a \`company\` cardholder.
    issuing'cardholderCompany :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderCompany'NonNullable)),
    -- | created: Time at which the object was created. Measured in seconds since the Unix epoch.
    issuing'cardholderCreated :: GHC.Types.Int,
    -- | email: The cardholder\'s email address.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderEmail :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | id: Unique identifier for the object.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderId :: Data.Text.Internal.Text,
    -- | individual: Additional information about an \`individual\` cardholder.
    issuing'cardholderIndividual :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullable)),
    -- | livemode: Has the value \`true\` if the object exists in live mode or the value \`false\` if the object exists in test mode.
    issuing'cardholderLivemode :: GHC.Types.Bool,
    -- | metadata: Set of [key-value pairs](https:\/\/stripe.com\/docs\/api\/metadata) that you can attach to an object. This can be useful for storing additional information about the object in a structured format.
    issuing'cardholderMetadata :: Data.Aeson.Types.Internal.Object,
    -- | name: The cardholder\'s name. This will be printed on cards issued to them.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderName :: Data.Text.Internal.Text,
    -- | phone_number: The cardholder\'s phone number. This is required for all cardholders who will be creating EU cards. See the [3D Secure documentation](https:\/\/stripe.com\/docs\/issuing\/3d-secure\#when-is-3d-secure-applied) for more details.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderPhoneNumber :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text)),
    -- | requirements:
    issuing'cardholderRequirements :: IssuingCardholderRequirements,
    -- | spending_controls: Rules that control spending across this cardholder\'s cards. Refer to our [documentation](https:\/\/stripe.com\/docs\/issuing\/controls\/spending-controls) for more details.
    issuing'cardholderSpendingControls :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderSpendingControls'NonNullable)),
    -- | status: Specifies whether to permit authorizations on this cardholder\'s cards.
    issuing'cardholderStatus :: Issuing'cardholderStatus',
    -- | type: One of \`individual\` or \`company\`.
    issuing'cardholderType :: Issuing'cardholderType'
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholder where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (["billing" Data.Aeson.Types.ToJSON..= issuing'cardholderBilling obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("company" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderCompany obj) : ["created" Data.Aeson.Types.ToJSON..= issuing'cardholderCreated obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderEmail obj) : ["id" Data.Aeson.Types.ToJSON..= issuing'cardholderId obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("individual" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual obj) : ["livemode" Data.Aeson.Types.ToJSON..= issuing'cardholderLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= issuing'cardholderMetadata obj] : ["name" Data.Aeson.Types.ToJSON..= issuing'cardholderName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderPhoneNumber obj) : ["requirements" Data.Aeson.Types.ToJSON..= issuing'cardholderRequirements obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls obj) : ["status" Data.Aeson.Types.ToJSON..= issuing'cardholderStatus obj] : ["type" Data.Aeson.Types.ToJSON..= issuing'cardholderType obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuing.cardholder"] : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (["billing" Data.Aeson.Types.ToJSON..= issuing'cardholderBilling obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("company" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderCompany obj) : ["created" Data.Aeson.Types.ToJSON..= issuing'cardholderCreated obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("email" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderEmail obj) : ["id" Data.Aeson.Types.ToJSON..= issuing'cardholderId obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("individual" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual obj) : ["livemode" Data.Aeson.Types.ToJSON..= issuing'cardholderLivemode obj] : ["metadata" Data.Aeson.Types.ToJSON..= issuing'cardholderMetadata obj] : ["name" Data.Aeson.Types.ToJSON..= issuing'cardholderName obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("phone_number" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderPhoneNumber obj) : ["requirements" Data.Aeson.Types.ToJSON..= issuing'cardholderRequirements obj] : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_controls" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls obj) : ["status" Data.Aeson.Types.ToJSON..= issuing'cardholderStatus obj] : ["type" Data.Aeson.Types.ToJSON..= issuing'cardholderType obj] : ["object" Data.Aeson.Types.ToJSON..= Data.Aeson.Types.Internal.String "issuing.cardholder"] : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholder where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholder" (\obj -> (((((((((((((GHC.Base.pure Issuing'cardholder GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "billing")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "company")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "created")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "email")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "id")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "individual")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "livemode")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "metadata")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "phone_number")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "requirements")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_controls")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "status")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..: "type"))

-- | Create a new 'Issuing'cardholder' with all required fields.
mkIssuing'cardholder ::
  -- | 'issuing'cardholderBilling'
  IssuingCardholderAddress ->
  -- | 'issuing'cardholderCreated'
  GHC.Types.Int ->
  -- | 'issuing'cardholderId'
  Data.Text.Internal.Text ->
  -- | 'issuing'cardholderLivemode'
  GHC.Types.Bool ->
  -- | 'issuing'cardholderMetadata'
  Data.Aeson.Types.Internal.Object ->
  -- | 'issuing'cardholderName'
  Data.Text.Internal.Text ->
  -- | 'issuing'cardholderRequirements'
  IssuingCardholderRequirements ->
  -- | 'issuing'cardholderStatus'
  Issuing'cardholderStatus' ->
  -- | 'issuing'cardholderType'
  Issuing'cardholderType' ->
  Issuing'cardholder
mkIssuing'cardholder issuing'cardholderBilling issuing'cardholderCreated issuing'cardholderId issuing'cardholderLivemode issuing'cardholderMetadata issuing'cardholderName issuing'cardholderRequirements issuing'cardholderStatus issuing'cardholderType =
  Issuing'cardholder
    { issuing'cardholderBilling = issuing'cardholderBilling,
      issuing'cardholderCompany = GHC.Maybe.Nothing,
      issuing'cardholderCreated = issuing'cardholderCreated,
      issuing'cardholderEmail = GHC.Maybe.Nothing,
      issuing'cardholderId = issuing'cardholderId,
      issuing'cardholderIndividual = GHC.Maybe.Nothing,
      issuing'cardholderLivemode = issuing'cardholderLivemode,
      issuing'cardholderMetadata = issuing'cardholderMetadata,
      issuing'cardholderName = issuing'cardholderName,
      issuing'cardholderPhoneNumber = GHC.Maybe.Nothing,
      issuing'cardholderRequirements = issuing'cardholderRequirements,
      issuing'cardholderSpendingControls = GHC.Maybe.Nothing,
      issuing'cardholderStatus = issuing'cardholderStatus,
      issuing'cardholderType = issuing'cardholderType
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.company.anyOf@ in the specification.
--
-- Additional information about a \\\`company\\\` cardholder.
data Issuing'cardholderCompany'NonNullable = Issuing'cardholderCompany'NonNullable
  { -- | tax_id_provided: Whether the company\'s business ID number was provided.
    issuing'cardholderCompany'NonNullableTaxIdProvided :: (GHC.Maybe.Maybe GHC.Types.Bool)
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderCompany'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id_provided" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderCompany'NonNullableTaxIdProvided obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("tax_id_provided" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderCompany'NonNullableTaxIdProvided obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderCompany'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderCompany'NonNullable" (\obj -> GHC.Base.pure Issuing'cardholderCompany'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "tax_id_provided"))

-- | Create a new 'Issuing'cardholderCompany'NonNullable' with all required fields.
mkIssuing'cardholderCompany'NonNullable :: Issuing'cardholderCompany'NonNullable
mkIssuing'cardholderCompany'NonNullable = Issuing'cardholderCompany'NonNullable {issuing'cardholderCompany'NonNullableTaxIdProvided = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf@ in the specification.
--
-- Additional information about an \\\`individual\\\` cardholder.
data Issuing'cardholderIndividual'NonNullable = Issuing'cardholderIndividual'NonNullable
  { -- | dob: The date of birth of this cardholder.
    issuing'cardholderIndividual'NonNullableDob :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullableDob'NonNullable)),
    -- | first_name: The first name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderIndividual'NonNullableFirstName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | last_name: The last name of this cardholder.
    --
    -- Constraints:
    --
    -- * Maximum length of 5000
    issuing'cardholderIndividual'NonNullableLastName :: (GHC.Maybe.Maybe Data.Text.Internal.Text),
    -- | verification: Government-issued ID document for this cardholder.
    issuing'cardholderIndividual'NonNullableVerification :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullableVerification'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("first_name" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableFirstName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("last_name" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableLastName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("dob" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("first_name" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableFirstName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("last_name" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableLastName obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("verification" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'NonNullable" (\obj -> (((GHC.Base.pure Issuing'cardholderIndividual'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "dob")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "first_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "last_name")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "verification"))

-- | Create a new 'Issuing'cardholderIndividual'NonNullable' with all required fields.
mkIssuing'cardholderIndividual'NonNullable :: Issuing'cardholderIndividual'NonNullable
mkIssuing'cardholderIndividual'NonNullable =
  Issuing'cardholderIndividual'NonNullable
    { issuing'cardholderIndividual'NonNullableDob = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableFirstName = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableLastName = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableVerification = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.dob.anyOf@ in the specification.
--
-- The date of birth of this cardholder.
data Issuing'cardholderIndividual'NonNullableDob'NonNullable = Issuing'cardholderIndividual'NonNullableDob'NonNullable
  { -- | day: The day of birth, between 1 and 31.
    issuing'cardholderIndividual'NonNullableDob'NonNullableDay :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int)),
    -- | month: The month of birth, between 1 and 12.
    issuing'cardholderIndividual'NonNullableDob'NonNullableMonth :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int)),
    -- | year: The four-digit year of birth.
    issuing'cardholderIndividual'NonNullableDob'NonNullableYear :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable GHC.Types.Int))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullableDob'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("day" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableDay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("month" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableMonth obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("year" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableYear obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("day" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableDay obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("month" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableMonth obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("year" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableDob'NonNullableYear obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullableDob'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'NonNullableDob'NonNullable" (\obj -> ((GHC.Base.pure Issuing'cardholderIndividual'NonNullableDob'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "day")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "month")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "year"))

-- | Create a new 'Issuing'cardholderIndividual'NonNullableDob'NonNullable' with all required fields.
mkIssuing'cardholderIndividual'NonNullableDob'NonNullable :: Issuing'cardholderIndividual'NonNullableDob'NonNullable
mkIssuing'cardholderIndividual'NonNullableDob'NonNullable =
  Issuing'cardholderIndividual'NonNullableDob'NonNullable
    { issuing'cardholderIndividual'NonNullableDob'NonNullableDay = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableDob'NonNullableMonth = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableDob'NonNullableYear = GHC.Maybe.Nothing
    }

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf@ in the specification.
--
-- Government-issued ID document for this cardholder.
data Issuing'cardholderIndividual'NonNullableVerification'NonNullable = Issuing'cardholderIndividual'NonNullableVerification'NonNullable
  { -- | document: An identifying document, either a passport or local ID card.
    issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("document" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("document" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'NonNullableVerification'NonNullable" (\obj -> GHC.Base.pure Issuing'cardholderIndividual'NonNullableVerification'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "document"))

-- | Create a new 'Issuing'cardholderIndividual'NonNullableVerification'NonNullable' with all required fields.
mkIssuing'cardholderIndividual'NonNullableVerification'NonNullable :: Issuing'cardholderIndividual'NonNullableVerification'NonNullable
mkIssuing'cardholderIndividual'NonNullableVerification'NonNullable = Issuing'cardholderIndividual'NonNullableVerification'NonNullable {issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument = GHC.Maybe.Nothing}

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf@ in the specification.
--
-- An identifying document, either a passport or local ID card.
data Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable = Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable
  { -- | back: The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableVariants)),
    -- | front: The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
    issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableVariants))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("back" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("front" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("back" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("front" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable" (\obj -> (GHC.Base.pure Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "back")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "front"))

-- | Create a new 'Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable' with all required fields.
mkIssuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable :: Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable
mkIssuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable =
  Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullable
    { issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack = GHC.Maybe.Nothing,
      issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront = GHC.Maybe.Nothing
    }

-- | Defines the oneOf schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf.properties.back.anyOf@ in the specification.
--
-- The back of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableVariants
  = Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableText Data.Text.Internal.Text
  | Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableFile File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableVariants where
  toJSON (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableText a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableFile a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableVariants where
  parseJSON val = case (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableText Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableBack'NonNullableFile Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the oneOf schema located at @components.schemas.issuing.cardholder.properties.individual.anyOf.properties.verification.anyOf.properties.document.anyOf.properties.front.anyOf@ in the specification.
--
-- The front of a document returned by a [file upload](https:\/\/stripe.com\/docs\/api\#create_file) with a \`purpose\` value of \`identity_document\`.
data Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableVariants
  = Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableText Data.Text.Internal.Text
  | Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableFile File
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableVariants where
  toJSON (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableText a) = Data.Aeson.Types.ToJSON.toJSON a
  toJSON (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableFile a) = Data.Aeson.Types.ToJSON.toJSON a

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableVariants where
  parseJSON val = case (Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableText Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> ((Issuing'cardholderIndividual'NonNullableVerification'NonNullableDocument'NonNullableFront'NonNullableFile Data.Functor.<$> Data.Aeson.Types.FromJSON.fromJSON val) GHC.Base.<|> Data.Aeson.Types.Internal.Error "No variant matched") of
    Data.Aeson.Types.Internal.Success a -> GHC.Base.pure a
    Data.Aeson.Types.Internal.Error a -> Control.Monad.Fail.fail a

-- | Defines the object schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf@ in the specification.
--
-- Rules that control spending across this cardholder\\\'s cards. Refer to our [documentation](https:\\\/\\\/stripe.com\\\/docs\\\/issuing\\\/controls\\\/spending-controls) for more details.
data Issuing'cardholderSpendingControls'NonNullable = Issuing'cardholderSpendingControls'NonNullable
  { -- | allowed_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to allow. All other categories will be blocked. Cannot be set with \`blocked_categories\`.
    issuing'cardholderSpendingControls'NonNullableAllowedCategories :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ([Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullable]))),
    -- | blocked_categories: Array of strings containing [categories](https:\/\/stripe.com\/docs\/api\#issuing_authorization_object-merchant_data-category) of authorizations to decline. All other categories will be allowed. Cannot be set with \`allowed_categories\`.
    issuing'cardholderSpendingControls'NonNullableBlockedCategories :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ([Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullable]))),
    -- | spending_limits: Limit spending with amount-based rules that apply across this cardholder\'s cards.
    issuing'cardholderSpendingControls'NonNullableSpendingLimits :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable ([IssuingCardholderSpendingLimit]))),
    -- | spending_limits_currency: Currency of the amounts within \`spending_limits\`.
    issuing'cardholderSpendingControls'NonNullableSpendingLimitsCurrency :: (GHC.Maybe.Maybe (StripeAPI.Common.Nullable Data.Text.Internal.Text))
  }
  deriving
    ( GHC.Show.Show,
      GHC.Classes.Eq
    )

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls'NonNullable where
  toJSON obj = Data.Aeson.Types.Internal.object (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableAllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableBlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableSpendingLimits obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits_currency" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableSpendingLimitsCurrency obj) : GHC.Base.mempty))
  toEncoding obj = Data.Aeson.Encoding.Internal.pairs (GHC.Base.mconcat (Data.Foldable.concat (Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("allowed_categories" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableAllowedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("blocked_categories" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableBlockedCategories obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableSpendingLimits obj) : Data.Maybe.maybe GHC.Base.mempty (GHC.Base.pure GHC.Base.. ("spending_limits_currency" Data.Aeson.Types.ToJSON..=)) (issuing'cardholderSpendingControls'NonNullableSpendingLimitsCurrency obj) : GHC.Base.mempty)))

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls'NonNullable where
  parseJSON = Data.Aeson.Types.FromJSON.withObject "Issuing'cardholderSpendingControls'NonNullable" (\obj -> (((GHC.Base.pure Issuing'cardholderSpendingControls'NonNullable GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "allowed_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "blocked_categories")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_limits")) GHC.Base.<*> (obj Data.Aeson.Types.FromJSON..:! "spending_limits_currency"))

-- | Create a new 'Issuing'cardholderSpendingControls'NonNullable' with all required fields.
mkIssuing'cardholderSpendingControls'NonNullable :: Issuing'cardholderSpendingControls'NonNullable
mkIssuing'cardholderSpendingControls'NonNullable =
  Issuing'cardholderSpendingControls'NonNullable
    { issuing'cardholderSpendingControls'NonNullableAllowedCategories = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'NonNullableBlockedCategories = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'NonNullableSpendingLimits = GHC.Maybe.Nothing,
      issuing'cardholderSpendingControls'NonNullableSpendingLimitsCurrency = GHC.Maybe.Nothing
    }

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf.properties.allowed_categories.items@ in the specification.
data Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullable where
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableOther val) = val
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAdvertisingServices) = "advertising_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmbulanceServices) = "ambulance_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueReproductions) = "antique_reproductions"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueShops) = "antique_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAquariums) = "aquariums"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoPaintShops) = "auto_paint_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoServiceShops) = "auto_service_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomobileAssociations) = "automobile_associations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBakeries) = "bakeries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBandsOrchestras) = "bands_orchestras"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBicycleShops) = "bicycle_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatDealers) = "boat_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBookStores) = "book_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBowlingAlleys) = "bowling_alleys"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusLines) = "bus_lines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarWashes) = "car_washes"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpentryServices) = "carpentry_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCaterers) = "caterers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildCareServices) = "child_care_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropractors) = "chiropractors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumClothingRental) = "clothing_rental"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCollegesUniversities) = "colleges_universities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialEquipment) = "commercial_equipment"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialFootwear) = "commercial_footwear"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerNetworkServices) = "computer_network_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerProgramming) = "computer_programming"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerRepair) = "computer_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConcreteWorkServices) = "concrete_work_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConstructionMaterials) = "construction_materials"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCosmeticStores) = "cosmetic_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCounselingServices) = "counseling_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCountryClubs) = "country_clubs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourierServices) = "courier_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourtCosts) = "court_costs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCruiseLines) = "cruise_lines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDairyProductsStores) = "dairy_products_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDatingEscortServices) = "dating_escort_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDepartmentStores) = "department_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDetectiveAgencies) = "detective_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDiscountStores) = "discount_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoctors) = "doctors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrinkingPlaces) = "drinking_places"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDryCleaners) = "dry_cleaners"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDurableGoods) = "durable_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDutyFreeStores) = "duty_free_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEducationalServices) = "educational_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricRazorStores) = "electric_razor_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalServices) = "electrical_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsStores) = "electronics_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEquipmentRental) = "equipment_rental"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumExterminatingServices) = "exterminating_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinancialInstitutions) = "financial_institutions"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFlorists) = "florists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGeneralServices) = "general_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGovernmentServices) = "government_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareStores) = "hardware_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHospitals) = "hospitals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIndustrialSupplies) = "industrial_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceDefault) = "insurance_default"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLandscapingServices) = "landscaping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundries) = "laundries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMassageParlors) = "massage_parlors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalServices) = "medical_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMembershipOrganizations) = "membership_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMetalServiceCenters) = "metal_service_centers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneous) = "miscellaneous"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNondurableGoods) = "nondurable_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOsteopaths) = "osteopaths"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPassengerRailways) = "passenger_railways"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPawnShops) = "pawn_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotoDeveloping) = "photo_developing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicStudios) = "photographic_studios"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPictureVideoProduction) = "picture_video_production"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPoliticalOrganizations) = "political_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumProfessionalServices) = "professional_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRailroads) = "railroads"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecordStores) = "record_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousOrganizations) = "religious_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumServiceStations) = "service_stations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeStores) = "shoe_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialTradeServices) = "special_trade_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTailorsAlterations) = "tailors_alterations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationServices) = "telecommunication_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelegraphServices) = "telegraph_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTestingLaboratories) = "testing_laboratories"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTimeshares) = "timeshares"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTowingServices) = "towing_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTransportationServices) = "transportation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypewriterStores) = "typewriter_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUtilities) = "utilities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVarietyStores) = "variety_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVeterinaryServices) = "veterinary_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoGameArcades) = "video_game_arcades"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWeldingRepair) = "welding_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWholesaleClubs) = "wholesale_clubs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCountryClubs
            | val GHC.Classes.== "courier_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourierServices
            | val GHC.Classes.== "court_costs" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDiscountStores
            | val GHC.Classes.== "doctors" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLandscapingServices
            | val GHC.Classes.== "laundries" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumUtilities
            | val GHC.Classes.== "variety_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableEnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> Issuing'cardholderSpendingControls'NonNullableAllowedCategories'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.spending_controls.anyOf.properties.blocked_categories.items@ in the specification.
data Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullable
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableOther Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableTyped Data.Text.Internal.Text
  | -- | Represents the JSON value @"ac_refrigeration_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAcRefrigerationRepair
  | -- | Represents the JSON value @"accounting_bookkeeping_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAccountingBookkeepingServices
  | -- | Represents the JSON value @"advertising_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAdvertisingServices
  | -- | Represents the JSON value @"agricultural_cooperative"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAgriculturalCooperative
  | -- | Represents the JSON value @"airlines_air_carriers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirlinesAirCarriers
  | -- | Represents the JSON value @"airports_flying_fields"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirportsFlyingFields
  | -- | Represents the JSON value @"ambulance_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmbulanceServices
  | -- | Represents the JSON value @"amusement_parks_carnivals"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmusementParksCarnivals
  | -- | Represents the JSON value @"antique_reproductions"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueReproductions
  | -- | Represents the JSON value @"antique_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueShops
  | -- | Represents the JSON value @"aquariums"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAquariums
  | -- | Represents the JSON value @"architectural_surveying_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArchitecturalSurveyingServices
  | -- | Represents the JSON value @"art_dealers_and_galleries"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtDealersAndGalleries
  | -- | Represents the JSON value @"artists_supply_and_craft_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtistsSupplyAndCraftShops
  | -- | Represents the JSON value @"auto_and_home_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoAndHomeSupplyStores
  | -- | Represents the JSON value @"auto_body_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoBodyRepairShops
  | -- | Represents the JSON value @"auto_paint_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoPaintShops
  | -- | Represents the JSON value @"auto_service_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoServiceShops
  | -- | Represents the JSON value @"automated_cash_disburse"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedCashDisburse
  | -- | Represents the JSON value @"automated_fuel_dispensers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedFuelDispensers
  | -- | Represents the JSON value @"automobile_associations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomobileAssociations
  | -- | Represents the JSON value @"automotive_parts_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
  | -- | Represents the JSON value @"automotive_tire_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotiveTireStores
  | -- | Represents the JSON value @"bail_and_bond_payments"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBailAndBondPayments
  | -- | Represents the JSON value @"bakeries"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBakeries
  | -- | Represents the JSON value @"bands_orchestras"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBandsOrchestras
  | -- | Represents the JSON value @"barber_and_beauty_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBarberAndBeautyShops
  | -- | Represents the JSON value @"betting_casino_gambling"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBettingCasinoGambling
  | -- | Represents the JSON value @"bicycle_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBicycleShops
  | -- | Represents the JSON value @"billiard_pool_establishments"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBilliardPoolEstablishments
  | -- | Represents the JSON value @"boat_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatDealers
  | -- | Represents the JSON value @"boat_rentals_and_leases"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatRentalsAndLeases
  | -- | Represents the JSON value @"book_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBookStores
  | -- | Represents the JSON value @"books_periodicals_and_newspapers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
  | -- | Represents the JSON value @"bowling_alleys"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBowlingAlleys
  | -- | Represents the JSON value @"bus_lines"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusLines
  | -- | Represents the JSON value @"business_secretarial_schools"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusinessSecretarialSchools
  | -- | Represents the JSON value @"buying_shopping_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBuyingShoppingServices
  | -- | Represents the JSON value @"cable_satellite_and_other_pay_television_and_radio"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
  | -- | Represents the JSON value @"camera_and_photographic_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCameraAndPhotographicSupplyStores
  | -- | Represents the JSON value @"candy_nut_and_confectionery_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCandyNutAndConfectioneryStores
  | -- | Represents the JSON value @"car_and_truck_dealers_new_used"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersNewUsed
  | -- | Represents the JSON value @"car_and_truck_dealers_used_only"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersUsedOnly
  | -- | Represents the JSON value @"car_rental_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarRentalAgencies
  | -- | Represents the JSON value @"car_washes"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarWashes
  | -- | Represents the JSON value @"carpentry_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpentryServices
  | -- | Represents the JSON value @"carpet_upholstery_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpetUpholsteryCleaning
  | -- | Represents the JSON value @"caterers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCaterers
  | -- | Represents the JSON value @"charitable_and_social_service_organizations_fundraising"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
  | -- | Represents the JSON value @"chemicals_and_allied_products"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChemicalsAndAlliedProducts
  | -- | Represents the JSON value @"child_care_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildCareServices
  | -- | Represents the JSON value @"childrens_and_infants_wear_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildrensAndInfantsWearStores
  | -- | Represents the JSON value @"chiropodists_podiatrists"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropodistsPodiatrists
  | -- | Represents the JSON value @"chiropractors"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropractors
  | -- | Represents the JSON value @"cigar_stores_and_stands"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCigarStoresAndStands
  | -- | Represents the JSON value @"civic_social_fraternal_associations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCivicSocialFraternalAssociations
  | -- | Represents the JSON value @"cleaning_and_maintenance"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCleaningAndMaintenance
  | -- | Represents the JSON value @"clothing_rental"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumClothingRental
  | -- | Represents the JSON value @"colleges_universities"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCollegesUniversities
  | -- | Represents the JSON value @"commercial_equipment"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialEquipment
  | -- | Represents the JSON value @"commercial_footwear"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialFootwear
  | -- | Represents the JSON value @"commercial_photography_art_and_graphics"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
  | -- | Represents the JSON value @"commuter_transport_and_ferries"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommuterTransportAndFerries
  | -- | Represents the JSON value @"computer_network_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerNetworkServices
  | -- | Represents the JSON value @"computer_programming"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerProgramming
  | -- | Represents the JSON value @"computer_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerRepair
  | -- | Represents the JSON value @"computer_software_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerSoftwareStores
  | -- | Represents the JSON value @"computers_peripherals_and_software"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputersPeripheralsAndSoftware
  | -- | Represents the JSON value @"concrete_work_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConcreteWorkServices
  | -- | Represents the JSON value @"construction_materials"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConstructionMaterials
  | -- | Represents the JSON value @"consulting_public_relations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConsultingPublicRelations
  | -- | Represents the JSON value @"correspondence_schools"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCorrespondenceSchools
  | -- | Represents the JSON value @"cosmetic_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCosmeticStores
  | -- | Represents the JSON value @"counseling_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCounselingServices
  | -- | Represents the JSON value @"country_clubs"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCountryClubs
  | -- | Represents the JSON value @"courier_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourierServices
  | -- | Represents the JSON value @"court_costs"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourtCosts
  | -- | Represents the JSON value @"credit_reporting_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCreditReportingAgencies
  | -- | Represents the JSON value @"cruise_lines"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCruiseLines
  | -- | Represents the JSON value @"dairy_products_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDairyProductsStores
  | -- | Represents the JSON value @"dance_hall_studios_schools"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDanceHallStudiosSchools
  | -- | Represents the JSON value @"dating_escort_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDatingEscortServices
  | -- | Represents the JSON value @"dentists_orthodontists"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDentistsOrthodontists
  | -- | Represents the JSON value @"department_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDepartmentStores
  | -- | Represents the JSON value @"detective_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDetectiveAgencies
  | -- | Represents the JSON value @"digital_goods_applications"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsApplications
  | -- | Represents the JSON value @"digital_goods_games"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsGames
  | -- | Represents the JSON value @"digital_goods_large_volume"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsLargeVolume
  | -- | Represents the JSON value @"digital_goods_media"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsMedia
  | -- | Represents the JSON value @"direct_marketing_catalog_merchant"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCatalogMerchant
  | -- | Represents the JSON value @"direct_marketing_combination_catalog_and_retail_merchant"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
  | -- | Represents the JSON value @"direct_marketing_inbound_telemarketing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_insurance_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInsuranceServices
  | -- | Represents the JSON value @"direct_marketing_other"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOther
  | -- | Represents the JSON value @"direct_marketing_outbound_telemarketing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
  | -- | Represents the JSON value @"direct_marketing_subscription"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingSubscription
  | -- | Represents the JSON value @"direct_marketing_travel"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingTravel
  | -- | Represents the JSON value @"discount_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDiscountStores
  | -- | Represents the JSON value @"doctors"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoctors
  | -- | Represents the JSON value @"door_to_door_sales"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoorToDoorSales
  | -- | Represents the JSON value @"drapery_window_covering_and_upholstery_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
  | -- | Represents the JSON value @"drinking_places"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrinkingPlaces
  | -- | Represents the JSON value @"drug_stores_and_pharmacies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugStoresAndPharmacies
  | -- | Represents the JSON value @"drugs_drug_proprietaries_and_druggist_sundries"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
  | -- | Represents the JSON value @"dry_cleaners"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDryCleaners
  | -- | Represents the JSON value @"durable_goods"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDurableGoods
  | -- | Represents the JSON value @"duty_free_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDutyFreeStores
  | -- | Represents the JSON value @"eating_places_restaurants"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEatingPlacesRestaurants
  | -- | Represents the JSON value @"educational_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEducationalServices
  | -- | Represents the JSON value @"electric_razor_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricRazorStores
  | -- | Represents the JSON value @"electrical_parts_and_equipment"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalPartsAndEquipment
  | -- | Represents the JSON value @"electrical_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalServices
  | -- | Represents the JSON value @"electronics_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsRepairShops
  | -- | Represents the JSON value @"electronics_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsStores
  | -- | Represents the JSON value @"elementary_secondary_schools"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElementarySecondarySchools
  | -- | Represents the JSON value @"employment_temp_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEmploymentTempAgencies
  | -- | Represents the JSON value @"equipment_rental"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEquipmentRental
  | -- | Represents the JSON value @"exterminating_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumExterminatingServices
  | -- | Represents the JSON value @"family_clothing_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFamilyClothingStores
  | -- | Represents the JSON value @"fast_food_restaurants"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFastFoodRestaurants
  | -- | Represents the JSON value @"financial_institutions"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinancialInstitutions
  | -- | Represents the JSON value @"fines_government_administrative_entities"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
  | -- | Represents the JSON value @"fireplace_fireplace_screens_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
  | -- | Represents the JSON value @"floor_covering_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloorCoveringStores
  | -- | Represents the JSON value @"florists"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFlorists
  | -- | Represents the JSON value @"florists_supplies_nursery_stock_and_flowers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
  | -- | Represents the JSON value @"freezer_and_locker_meat_provisioners"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
  | -- | Represents the JSON value @"fuel_dealers_non_automotive"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuelDealersNonAutomotive
  | -- | Represents the JSON value @"funeral_services_crematories"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuneralServicesCrematories
  | -- | Represents the JSON value @"furniture_home_furnishings_and_equipment_stores_except_appliances"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
  | -- | Represents the JSON value @"furniture_repair_refinishing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureRepairRefinishing
  | -- | Represents the JSON value @"furriers_and_fur_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurriersAndFurShops
  | -- | Represents the JSON value @"general_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGeneralServices
  | -- | Represents the JSON value @"gift_card_novelty_and_souvenir_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
  | -- | Represents the JSON value @"glass_paint_and_wallpaper_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlassPaintAndWallpaperStores
  | -- | Represents the JSON value @"glassware_crystal_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlasswareCrystalStores
  | -- | Represents the JSON value @"golf_courses_public"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGolfCoursesPublic
  | -- | Represents the JSON value @"government_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGovernmentServices
  | -- | Represents the JSON value @"grocery_stores_supermarkets"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGroceryStoresSupermarkets
  | -- | Represents the JSON value @"hardware_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareEquipmentAndSupplies
  | -- | Represents the JSON value @"hardware_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareStores
  | -- | Represents the JSON value @"health_and_beauty_spas"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHealthAndBeautySpas
  | -- | Represents the JSON value @"hearing_aids_sales_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHearingAidsSalesAndSupplies
  | -- | Represents the JSON value @"heating_plumbing_a_c"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHeatingPlumbingAC
  | -- | Represents the JSON value @"hobby_toy_and_game_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHobbyToyAndGameShops
  | -- | Represents the JSON value @"home_supply_warehouse_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHomeSupplyWarehouseStores
  | -- | Represents the JSON value @"hospitals"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHospitals
  | -- | Represents the JSON value @"hotels_motels_and_resorts"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHotelsMotelsAndResorts
  | -- | Represents the JSON value @"household_appliance_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHouseholdApplianceStores
  | -- | Represents the JSON value @"industrial_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIndustrialSupplies
  | -- | Represents the JSON value @"information_retrieval_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInformationRetrievalServices
  | -- | Represents the JSON value @"insurance_default"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceDefault
  | -- | Represents the JSON value @"insurance_underwriting_premiums"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceUnderwritingPremiums
  | -- | Represents the JSON value @"intra_company_purchases"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIntraCompanyPurchases
  | -- | Represents the JSON value @"jewelry_stores_watches_clocks_and_silverware_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
  | -- | Represents the JSON value @"landscaping_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLandscapingServices
  | -- | Represents the JSON value @"laundries"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundries
  | -- | Represents the JSON value @"laundry_cleaning_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundryCleaningServices
  | -- | Represents the JSON value @"legal_services_attorneys"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLegalServicesAttorneys
  | -- | Represents the JSON value @"luggage_and_leather_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLuggageAndLeatherGoodsStores
  | -- | Represents the JSON value @"lumber_building_materials_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLumberBuildingMaterialsStores
  | -- | Represents the JSON value @"manual_cash_disburse"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumManualCashDisburse
  | -- | Represents the JSON value @"marinas_service_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMarinasServiceAndSupplies
  | -- | Represents the JSON value @"masonry_stonework_and_plaster"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMasonryStoneworkAndPlaster
  | -- | Represents the JSON value @"massage_parlors"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMassageParlors
  | -- | Represents the JSON value @"medical_and_dental_labs"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalAndDentalLabs
  | -- | Represents the JSON value @"medical_dental_ophthalmic_and_hospital_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
  | -- | Represents the JSON value @"medical_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalServices
  | -- | Represents the JSON value @"membership_organizations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMembershipOrganizations
  | -- | Represents the JSON value @"mens_and_boys_clothing_and_accessories_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
  | -- | Represents the JSON value @"mens_womens_clothing_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensWomensClothingStores
  | -- | Represents the JSON value @"metal_service_centers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMetalServiceCenters
  | -- | Represents the JSON value @"miscellaneous"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneous
  | -- | Represents the JSON value @"miscellaneous_apparel_and_accessory_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
  | -- | Represents the JSON value @"miscellaneous_auto_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousAutoDealers
  | -- | Represents the JSON value @"miscellaneous_business_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousBusinessServices
  | -- | Represents the JSON value @"miscellaneous_food_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousFoodStores
  | -- | Represents the JSON value @"miscellaneous_general_merchandise"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralMerchandise
  | -- | Represents the JSON value @"miscellaneous_general_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralServices
  | -- | Represents the JSON value @"miscellaneous_home_furnishing_specialty_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
  | -- | Represents the JSON value @"miscellaneous_publishing_and_printing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
  | -- | Represents the JSON value @"miscellaneous_recreation_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRecreationServices
  | -- | Represents the JSON value @"miscellaneous_repair_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRepairShops
  | -- | Represents the JSON value @"miscellaneous_specialty_retail"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousSpecialtyRetail
  | -- | Represents the JSON value @"mobile_home_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMobileHomeDealers
  | -- | Represents the JSON value @"motion_picture_theaters"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotionPictureTheaters
  | -- | Represents the JSON value @"motor_freight_carriers_and_trucking"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorFreightCarriersAndTrucking
  | -- | Represents the JSON value @"motor_homes_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorHomesDealers
  | -- | Represents the JSON value @"motor_vehicle_supplies_and_new_parts"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
  | -- | Represents the JSON value @"motorcycle_shops_and_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsAndDealers
  | -- | Represents the JSON value @"motorcycle_shops_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsDealers
  | -- | Represents the JSON value @"music_stores_musical_instruments_pianos_and_sheet_music"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
  | -- | Represents the JSON value @"news_dealers_and_newsstands"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNewsDealersAndNewsstands
  | -- | Represents the JSON value @"non_fi_money_orders"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiMoneyOrders
  | -- | Represents the JSON value @"non_fi_stored_value_card_purchase_load"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
  | -- | Represents the JSON value @"nondurable_goods"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNondurableGoods
  | -- | Represents the JSON value @"nurseries_lawn_and_garden_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
  | -- | Represents the JSON value @"nursing_personal_care"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNursingPersonalCare
  | -- | Represents the JSON value @"office_and_commercial_furniture"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOfficeAndCommercialFurniture
  | -- | Represents the JSON value @"opticians_eyeglasses"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOpticiansEyeglasses
  | -- | Represents the JSON value @"optometrists_ophthalmologist"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOptometristsOphthalmologist
  | -- | Represents the JSON value @"orthopedic_goods_prosthetic_devices"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
  | -- | Represents the JSON value @"osteopaths"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOsteopaths
  | -- | Represents the JSON value @"package_stores_beer_wine_and_liquor"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
  | -- | Represents the JSON value @"paints_varnishes_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPaintsVarnishesAndSupplies
  | -- | Represents the JSON value @"parking_lots_garages"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumParkingLotsGarages
  | -- | Represents the JSON value @"passenger_railways"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPassengerRailways
  | -- | Represents the JSON value @"pawn_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPawnShops
  | -- | Represents the JSON value @"pet_shops_pet_food_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetShopsPetFoodAndSupplies
  | -- | Represents the JSON value @"petroleum_and_petroleum_products"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetroleumAndPetroleumProducts
  | -- | Represents the JSON value @"photo_developing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotoDeveloping
  | -- | Represents the JSON value @"photographic_photocopy_microfilm_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
  | -- | Represents the JSON value @"photographic_studios"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicStudios
  | -- | Represents the JSON value @"picture_video_production"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPictureVideoProduction
  | -- | Represents the JSON value @"piece_goods_notions_and_other_dry_goods"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
  | -- | Represents the JSON value @"plumbing_heating_equipment_and_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
  | -- | Represents the JSON value @"political_organizations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPoliticalOrganizations
  | -- | Represents the JSON value @"postal_services_government_only"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPostalServicesGovernmentOnly
  | -- | Represents the JSON value @"precious_stones_and_metals_watches_and_jewelry"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
  | -- | Represents the JSON value @"professional_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumProfessionalServices
  | -- | Represents the JSON value @"public_warehousing_and_storage"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPublicWarehousingAndStorage
  | -- | Represents the JSON value @"quick_copy_repro_and_blueprint"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumQuickCopyReproAndBlueprint
  | -- | Represents the JSON value @"railroads"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRailroads
  | -- | Represents the JSON value @"real_estate_agents_and_managers_rentals"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
  | -- | Represents the JSON value @"record_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecordStores
  | -- | Represents the JSON value @"recreational_vehicle_rentals"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecreationalVehicleRentals
  | -- | Represents the JSON value @"religious_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousGoodsStores
  | -- | Represents the JSON value @"religious_organizations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousOrganizations
  | -- | Represents the JSON value @"roofing_siding_sheet_metal"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRoofingSidingSheetMetal
  | -- | Represents the JSON value @"secretarial_support_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecretarialSupportServices
  | -- | Represents the JSON value @"security_brokers_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecurityBrokersDealers
  | -- | Represents the JSON value @"service_stations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumServiceStations
  | -- | Represents the JSON value @"sewing_needlework_fabric_and_piece_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
  | -- | Represents the JSON value @"shoe_repair_hat_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeRepairHatCleaning
  | -- | Represents the JSON value @"shoe_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeStores
  | -- | Represents the JSON value @"small_appliance_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSmallApplianceRepair
  | -- | Represents the JSON value @"snowmobile_dealers"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSnowmobileDealers
  | -- | Represents the JSON value @"special_trade_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialTradeServices
  | -- | Represents the JSON value @"specialty_cleaning"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialtyCleaning
  | -- | Represents the JSON value @"sporting_goods_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingGoodsStores
  | -- | Represents the JSON value @"sporting_recreation_camps"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingRecreationCamps
  | -- | Represents the JSON value @"sports_and_riding_apparel_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsAndRidingApparelStores
  | -- | Represents the JSON value @"sports_clubs_fields"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsClubsFields
  | -- | Represents the JSON value @"stamp_and_coin_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStampAndCoinStores
  | -- | Represents the JSON value @"stationary_office_supplies_printing_and_writing_paper"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
  | -- | Represents the JSON value @"stationery_stores_office_and_school_supply_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
  | -- | Represents the JSON value @"swimming_pools_sales"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSwimmingPoolsSales
  | -- | Represents the JSON value @"t_ui_travel_germany"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTUiTravelGermany
  | -- | Represents the JSON value @"tailors_alterations"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTailorsAlterations
  | -- | Represents the JSON value @"tax_payments_government_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
  | -- | Represents the JSON value @"tax_preparation_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPreparationServices
  | -- | Represents the JSON value @"taxicabs_limousines"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxicabsLimousines
  | -- | Represents the JSON value @"telecommunication_equipment_and_telephone_sales"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
  | -- | Represents the JSON value @"telecommunication_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationServices
  | -- | Represents the JSON value @"telegraph_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelegraphServices
  | -- | Represents the JSON value @"tent_and_awning_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTentAndAwningShops
  | -- | Represents the JSON value @"testing_laboratories"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTestingLaboratories
  | -- | Represents the JSON value @"theatrical_ticket_agencies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTheatricalTicketAgencies
  | -- | Represents the JSON value @"timeshares"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTimeshares
  | -- | Represents the JSON value @"tire_retreading_and_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTireRetreadingAndRepair
  | -- | Represents the JSON value @"tolls_bridge_fees"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTollsBridgeFees
  | -- | Represents the JSON value @"tourist_attractions_and_exhibits"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTouristAttractionsAndExhibits
  | -- | Represents the JSON value @"towing_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTowingServices
  | -- | Represents the JSON value @"trailer_parks_campgrounds"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTrailerParksCampgrounds
  | -- | Represents the JSON value @"transportation_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTransportationServices
  | -- | Represents the JSON value @"travel_agencies_tour_operators"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTravelAgenciesTourOperators
  | -- | Represents the JSON value @"truck_stop_iteration"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckStopIteration
  | -- | Represents the JSON value @"truck_utility_trailer_rentals"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckUtilityTrailerRentals
  | -- | Represents the JSON value @"typesetting_plate_making_and_related_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
  | -- | Represents the JSON value @"typewriter_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypewriterStores
  | -- | Represents the JSON value @"u_s_federal_government_agencies_or_departments"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
  | -- | Represents the JSON value @"uniforms_commercial_clothing"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUniformsCommercialClothing
  | -- | Represents the JSON value @"used_merchandise_and_secondhand_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
  | -- | Represents the JSON value @"utilities"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUtilities
  | -- | Represents the JSON value @"variety_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVarietyStores
  | -- | Represents the JSON value @"veterinary_services"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVeterinaryServices
  | -- | Represents the JSON value @"video_amusement_game_supplies"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoAmusementGameSupplies
  | -- | Represents the JSON value @"video_game_arcades"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoGameArcades
  | -- | Represents the JSON value @"video_tape_rental_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoTapeRentalStores
  | -- | Represents the JSON value @"vocational_trade_schools"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVocationalTradeSchools
  | -- | Represents the JSON value @"watch_jewelry_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWatchJewelryRepair
  | -- | Represents the JSON value @"welding_repair"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWeldingRepair
  | -- | Represents the JSON value @"wholesale_clubs"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWholesaleClubs
  | -- | Represents the JSON value @"wig_and_toupee_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWigAndToupeeStores
  | -- | Represents the JSON value @"wires_money_orders"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWiresMoneyOrders
  | -- | Represents the JSON value @"womens_accessory_and_specialty_shops"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
  | -- | Represents the JSON value @"womens_ready_to_wear_stores"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensReadyToWearStores
  | -- | Represents the JSON value @"wrecking_and_salvage_yards"@
    Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWreckingAndSalvageYards
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullable where
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableOther val) = val
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableTyped val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAcRefrigerationRepair) = "ac_refrigeration_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAccountingBookkeepingServices) = "accounting_bookkeeping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAdvertisingServices) = "advertising_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAgriculturalCooperative) = "agricultural_cooperative"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirlinesAirCarriers) = "airlines_air_carriers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirportsFlyingFields) = "airports_flying_fields"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmbulanceServices) = "ambulance_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmusementParksCarnivals) = "amusement_parks_carnivals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueReproductions) = "antique_reproductions"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueShops) = "antique_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAquariums) = "aquariums"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArchitecturalSurveyingServices) = "architectural_surveying_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtDealersAndGalleries) = "art_dealers_and_galleries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtistsSupplyAndCraftShops) = "artists_supply_and_craft_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoAndHomeSupplyStores) = "auto_and_home_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoBodyRepairShops) = "auto_body_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoPaintShops) = "auto_paint_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoServiceShops) = "auto_service_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedCashDisburse) = "automated_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedFuelDispensers) = "automated_fuel_dispensers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomobileAssociations) = "automobile_associations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores) = "automotive_parts_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotiveTireStores) = "automotive_tire_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBailAndBondPayments) = "bail_and_bond_payments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBakeries) = "bakeries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBandsOrchestras) = "bands_orchestras"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBarberAndBeautyShops) = "barber_and_beauty_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBettingCasinoGambling) = "betting_casino_gambling"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBicycleShops) = "bicycle_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBilliardPoolEstablishments) = "billiard_pool_establishments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatDealers) = "boat_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatRentalsAndLeases) = "boat_rentals_and_leases"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBookStores) = "book_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers) = "books_periodicals_and_newspapers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBowlingAlleys) = "bowling_alleys"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusLines) = "bus_lines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusinessSecretarialSchools) = "business_secretarial_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBuyingShoppingServices) = "buying_shopping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio) = "cable_satellite_and_other_pay_television_and_radio"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCameraAndPhotographicSupplyStores) = "camera_and_photographic_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCandyNutAndConfectioneryStores) = "candy_nut_and_confectionery_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersNewUsed) = "car_and_truck_dealers_new_used"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersUsedOnly) = "car_and_truck_dealers_used_only"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarRentalAgencies) = "car_rental_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarWashes) = "car_washes"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpentryServices) = "carpentry_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpetUpholsteryCleaning) = "carpet_upholstery_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCaterers) = "caterers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising) = "charitable_and_social_service_organizations_fundraising"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChemicalsAndAlliedProducts) = "chemicals_and_allied_products"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildCareServices) = "child_care_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildrensAndInfantsWearStores) = "childrens_and_infants_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropodistsPodiatrists) = "chiropodists_podiatrists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropractors) = "chiropractors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCigarStoresAndStands) = "cigar_stores_and_stands"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCivicSocialFraternalAssociations) = "civic_social_fraternal_associations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCleaningAndMaintenance) = "cleaning_and_maintenance"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumClothingRental) = "clothing_rental"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCollegesUniversities) = "colleges_universities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialEquipment) = "commercial_equipment"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialFootwear) = "commercial_footwear"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics) = "commercial_photography_art_and_graphics"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommuterTransportAndFerries) = "commuter_transport_and_ferries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerNetworkServices) = "computer_network_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerProgramming) = "computer_programming"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerRepair) = "computer_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerSoftwareStores) = "computer_software_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputersPeripheralsAndSoftware) = "computers_peripherals_and_software"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConcreteWorkServices) = "concrete_work_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConstructionMaterials) = "construction_materials"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConsultingPublicRelations) = "consulting_public_relations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCorrespondenceSchools) = "correspondence_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCosmeticStores) = "cosmetic_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCounselingServices) = "counseling_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCountryClubs) = "country_clubs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourierServices) = "courier_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourtCosts) = "court_costs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCreditReportingAgencies) = "credit_reporting_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCruiseLines) = "cruise_lines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDairyProductsStores) = "dairy_products_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDanceHallStudiosSchools) = "dance_hall_studios_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDatingEscortServices) = "dating_escort_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDentistsOrthodontists) = "dentists_orthodontists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDepartmentStores) = "department_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDetectiveAgencies) = "detective_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsApplications) = "digital_goods_applications"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsGames) = "digital_goods_games"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsLargeVolume) = "digital_goods_large_volume"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsMedia) = "digital_goods_media"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCatalogMerchant) = "direct_marketing_catalog_merchant"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant) = "direct_marketing_combination_catalog_and_retail_merchant"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInboundTelemarketing) = "direct_marketing_inbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInsuranceServices) = "direct_marketing_insurance_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOther) = "direct_marketing_other"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing) = "direct_marketing_outbound_telemarketing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingSubscription) = "direct_marketing_subscription"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingTravel) = "direct_marketing_travel"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDiscountStores) = "discount_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoctors) = "doctors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoorToDoorSales) = "door_to_door_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores) = "drapery_window_covering_and_upholstery_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrinkingPlaces) = "drinking_places"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugStoresAndPharmacies) = "drug_stores_and_pharmacies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries) = "drugs_drug_proprietaries_and_druggist_sundries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDryCleaners) = "dry_cleaners"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDurableGoods) = "durable_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDutyFreeStores) = "duty_free_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEatingPlacesRestaurants) = "eating_places_restaurants"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEducationalServices) = "educational_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricRazorStores) = "electric_razor_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalPartsAndEquipment) = "electrical_parts_and_equipment"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalServices) = "electrical_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsRepairShops) = "electronics_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsStores) = "electronics_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElementarySecondarySchools) = "elementary_secondary_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEmploymentTempAgencies) = "employment_temp_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEquipmentRental) = "equipment_rental"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumExterminatingServices) = "exterminating_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFamilyClothingStores) = "family_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFastFoodRestaurants) = "fast_food_restaurants"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinancialInstitutions) = "financial_institutions"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities) = "fines_government_administrative_entities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores) = "fireplace_fireplace_screens_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloorCoveringStores) = "floor_covering_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFlorists) = "florists"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers) = "florists_supplies_nursery_stock_and_flowers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners) = "freezer_and_locker_meat_provisioners"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuelDealersNonAutomotive) = "fuel_dealers_non_automotive"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuneralServicesCrematories) = "funeral_services_crematories"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances) = "furniture_home_furnishings_and_equipment_stores_except_appliances"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureRepairRefinishing) = "furniture_repair_refinishing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurriersAndFurShops) = "furriers_and_fur_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGeneralServices) = "general_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops) = "gift_card_novelty_and_souvenir_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlassPaintAndWallpaperStores) = "glass_paint_and_wallpaper_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlasswareCrystalStores) = "glassware_crystal_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGolfCoursesPublic) = "golf_courses_public"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGovernmentServices) = "government_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGroceryStoresSupermarkets) = "grocery_stores_supermarkets"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareEquipmentAndSupplies) = "hardware_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareStores) = "hardware_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHealthAndBeautySpas) = "health_and_beauty_spas"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHearingAidsSalesAndSupplies) = "hearing_aids_sales_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHeatingPlumbingAC) = "heating_plumbing_a_c"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHobbyToyAndGameShops) = "hobby_toy_and_game_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHomeSupplyWarehouseStores) = "home_supply_warehouse_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHospitals) = "hospitals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHotelsMotelsAndResorts) = "hotels_motels_and_resorts"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHouseholdApplianceStores) = "household_appliance_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIndustrialSupplies) = "industrial_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInformationRetrievalServices) = "information_retrieval_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceDefault) = "insurance_default"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceUnderwritingPremiums) = "insurance_underwriting_premiums"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIntraCompanyPurchases) = "intra_company_purchases"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores) = "jewelry_stores_watches_clocks_and_silverware_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLandscapingServices) = "landscaping_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundries) = "laundries"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundryCleaningServices) = "laundry_cleaning_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLegalServicesAttorneys) = "legal_services_attorneys"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLuggageAndLeatherGoodsStores) = "luggage_and_leather_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLumberBuildingMaterialsStores) = "lumber_building_materials_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumManualCashDisburse) = "manual_cash_disburse"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMarinasServiceAndSupplies) = "marinas_service_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMasonryStoneworkAndPlaster) = "masonry_stonework_and_plaster"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMassageParlors) = "massage_parlors"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalAndDentalLabs) = "medical_and_dental_labs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies) = "medical_dental_ophthalmic_and_hospital_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalServices) = "medical_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMembershipOrganizations) = "membership_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores) = "mens_and_boys_clothing_and_accessories_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensWomensClothingStores) = "mens_womens_clothing_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMetalServiceCenters) = "metal_service_centers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneous) = "miscellaneous"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops) = "miscellaneous_apparel_and_accessory_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousAutoDealers) = "miscellaneous_auto_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousBusinessServices) = "miscellaneous_business_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousFoodStores) = "miscellaneous_food_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralMerchandise) = "miscellaneous_general_merchandise"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralServices) = "miscellaneous_general_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores) = "miscellaneous_home_furnishing_specialty_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting) = "miscellaneous_publishing_and_printing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRecreationServices) = "miscellaneous_recreation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRepairShops) = "miscellaneous_repair_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousSpecialtyRetail) = "miscellaneous_specialty_retail"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMobileHomeDealers) = "mobile_home_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotionPictureTheaters) = "motion_picture_theaters"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorFreightCarriersAndTrucking) = "motor_freight_carriers_and_trucking"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorHomesDealers) = "motor_homes_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts) = "motor_vehicle_supplies_and_new_parts"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsAndDealers) = "motorcycle_shops_and_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsDealers) = "motorcycle_shops_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic) = "music_stores_musical_instruments_pianos_and_sheet_music"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNewsDealersAndNewsstands) = "news_dealers_and_newsstands"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiMoneyOrders) = "non_fi_money_orders"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad) = "non_fi_stored_value_card_purchase_load"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNondurableGoods) = "nondurable_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores) = "nurseries_lawn_and_garden_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNursingPersonalCare) = "nursing_personal_care"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOfficeAndCommercialFurniture) = "office_and_commercial_furniture"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOpticiansEyeglasses) = "opticians_eyeglasses"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOptometristsOphthalmologist) = "optometrists_ophthalmologist"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices) = "orthopedic_goods_prosthetic_devices"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOsteopaths) = "osteopaths"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor) = "package_stores_beer_wine_and_liquor"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPaintsVarnishesAndSupplies) = "paints_varnishes_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumParkingLotsGarages) = "parking_lots_garages"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPassengerRailways) = "passenger_railways"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPawnShops) = "pawn_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetShopsPetFoodAndSupplies) = "pet_shops_pet_food_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetroleumAndPetroleumProducts) = "petroleum_and_petroleum_products"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotoDeveloping) = "photo_developing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies) = "photographic_photocopy_microfilm_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicStudios) = "photographic_studios"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPictureVideoProduction) = "picture_video_production"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods) = "piece_goods_notions_and_other_dry_goods"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies) = "plumbing_heating_equipment_and_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPoliticalOrganizations) = "political_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPostalServicesGovernmentOnly) = "postal_services_government_only"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry) = "precious_stones_and_metals_watches_and_jewelry"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumProfessionalServices) = "professional_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPublicWarehousingAndStorage) = "public_warehousing_and_storage"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumQuickCopyReproAndBlueprint) = "quick_copy_repro_and_blueprint"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRailroads) = "railroads"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals) = "real_estate_agents_and_managers_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecordStores) = "record_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecreationalVehicleRentals) = "recreational_vehicle_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousGoodsStores) = "religious_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousOrganizations) = "religious_organizations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRoofingSidingSheetMetal) = "roofing_siding_sheet_metal"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecretarialSupportServices) = "secretarial_support_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecurityBrokersDealers) = "security_brokers_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumServiceStations) = "service_stations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores) = "sewing_needlework_fabric_and_piece_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeRepairHatCleaning) = "shoe_repair_hat_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeStores) = "shoe_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSmallApplianceRepair) = "small_appliance_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSnowmobileDealers) = "snowmobile_dealers"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialTradeServices) = "special_trade_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialtyCleaning) = "specialty_cleaning"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingGoodsStores) = "sporting_goods_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingRecreationCamps) = "sporting_recreation_camps"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsAndRidingApparelStores) = "sports_and_riding_apparel_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsClubsFields) = "sports_clubs_fields"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStampAndCoinStores) = "stamp_and_coin_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper) = "stationary_office_supplies_printing_and_writing_paper"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores) = "stationery_stores_office_and_school_supply_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSwimmingPoolsSales) = "swimming_pools_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTUiTravelGermany) = "t_ui_travel_germany"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTailorsAlterations) = "tailors_alterations"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies) = "tax_payments_government_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPreparationServices) = "tax_preparation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxicabsLimousines) = "taxicabs_limousines"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales) = "telecommunication_equipment_and_telephone_sales"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationServices) = "telecommunication_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelegraphServices) = "telegraph_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTentAndAwningShops) = "tent_and_awning_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTestingLaboratories) = "testing_laboratories"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTheatricalTicketAgencies) = "theatrical_ticket_agencies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTimeshares) = "timeshares"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTireRetreadingAndRepair) = "tire_retreading_and_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTollsBridgeFees) = "tolls_bridge_fees"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTouristAttractionsAndExhibits) = "tourist_attractions_and_exhibits"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTowingServices) = "towing_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTrailerParksCampgrounds) = "trailer_parks_campgrounds"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTransportationServices) = "transportation_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTravelAgenciesTourOperators) = "travel_agencies_tour_operators"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckStopIteration) = "truck_stop_iteration"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckUtilityTrailerRentals) = "truck_utility_trailer_rentals"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices) = "typesetting_plate_making_and_related_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypewriterStores) = "typewriter_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments) = "u_s_federal_government_agencies_or_departments"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUniformsCommercialClothing) = "uniforms_commercial_clothing"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores) = "used_merchandise_and_secondhand_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUtilities) = "utilities"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVarietyStores) = "variety_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVeterinaryServices) = "veterinary_services"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoAmusementGameSupplies) = "video_amusement_game_supplies"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoGameArcades) = "video_game_arcades"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoTapeRentalStores) = "video_tape_rental_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVocationalTradeSchools) = "vocational_trade_schools"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWatchJewelryRepair) = "watch_jewelry_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWeldingRepair) = "welding_repair"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWholesaleClubs) = "wholesale_clubs"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWigAndToupeeStores) = "wig_and_toupee_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWiresMoneyOrders) = "wires_money_orders"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops) = "womens_accessory_and_specialty_shops"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensReadyToWearStores) = "womens_ready_to_wear_stores"
  toJSON (Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWreckingAndSalvageYards) = "wrecking_and_salvage_yards"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullable where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "ac_refrigeration_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAcRefrigerationRepair
            | val GHC.Classes.== "accounting_bookkeeping_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAccountingBookkeepingServices
            | val GHC.Classes.== "advertising_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAdvertisingServices
            | val GHC.Classes.== "agricultural_cooperative" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAgriculturalCooperative
            | val GHC.Classes.== "airlines_air_carriers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirlinesAirCarriers
            | val GHC.Classes.== "airports_flying_fields" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAirportsFlyingFields
            | val GHC.Classes.== "ambulance_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmbulanceServices
            | val GHC.Classes.== "amusement_parks_carnivals" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAmusementParksCarnivals
            | val GHC.Classes.== "antique_reproductions" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueReproductions
            | val GHC.Classes.== "antique_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAntiqueShops
            | val GHC.Classes.== "aquariums" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAquariums
            | val GHC.Classes.== "architectural_surveying_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArchitecturalSurveyingServices
            | val GHC.Classes.== "art_dealers_and_galleries" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtDealersAndGalleries
            | val GHC.Classes.== "artists_supply_and_craft_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumArtistsSupplyAndCraftShops
            | val GHC.Classes.== "auto_and_home_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoAndHomeSupplyStores
            | val GHC.Classes.== "auto_body_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoBodyRepairShops
            | val GHC.Classes.== "auto_paint_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoPaintShops
            | val GHC.Classes.== "auto_service_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutoServiceShops
            | val GHC.Classes.== "automated_cash_disburse" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedCashDisburse
            | val GHC.Classes.== "automated_fuel_dispensers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomatedFuelDispensers
            | val GHC.Classes.== "automobile_associations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomobileAssociations
            | val GHC.Classes.== "automotive_parts_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotivePartsAndAccessoriesStores
            | val GHC.Classes.== "automotive_tire_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumAutomotiveTireStores
            | val GHC.Classes.== "bail_and_bond_payments" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBailAndBondPayments
            | val GHC.Classes.== "bakeries" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBakeries
            | val GHC.Classes.== "bands_orchestras" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBandsOrchestras
            | val GHC.Classes.== "barber_and_beauty_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBarberAndBeautyShops
            | val GHC.Classes.== "betting_casino_gambling" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBettingCasinoGambling
            | val GHC.Classes.== "bicycle_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBicycleShops
            | val GHC.Classes.== "billiard_pool_establishments" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBilliardPoolEstablishments
            | val GHC.Classes.== "boat_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatDealers
            | val GHC.Classes.== "boat_rentals_and_leases" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBoatRentalsAndLeases
            | val GHC.Classes.== "book_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBookStores
            | val GHC.Classes.== "books_periodicals_and_newspapers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBooksPeriodicalsAndNewspapers
            | val GHC.Classes.== "bowling_alleys" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBowlingAlleys
            | val GHC.Classes.== "bus_lines" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusLines
            | val GHC.Classes.== "business_secretarial_schools" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBusinessSecretarialSchools
            | val GHC.Classes.== "buying_shopping_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumBuyingShoppingServices
            | val GHC.Classes.== "cable_satellite_and_other_pay_television_and_radio" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCableSatelliteAndOtherPayTelevisionAndRadio
            | val GHC.Classes.== "camera_and_photographic_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCameraAndPhotographicSupplyStores
            | val GHC.Classes.== "candy_nut_and_confectionery_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCandyNutAndConfectioneryStores
            | val GHC.Classes.== "car_and_truck_dealers_new_used" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersNewUsed
            | val GHC.Classes.== "car_and_truck_dealers_used_only" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarAndTruckDealersUsedOnly
            | val GHC.Classes.== "car_rental_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarRentalAgencies
            | val GHC.Classes.== "car_washes" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarWashes
            | val GHC.Classes.== "carpentry_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpentryServices
            | val GHC.Classes.== "carpet_upholstery_cleaning" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCarpetUpholsteryCleaning
            | val GHC.Classes.== "caterers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCaterers
            | val GHC.Classes.== "charitable_and_social_service_organizations_fundraising" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCharitableAndSocialServiceOrganizationsFundraising
            | val GHC.Classes.== "chemicals_and_allied_products" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChemicalsAndAlliedProducts
            | val GHC.Classes.== "child_care_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildCareServices
            | val GHC.Classes.== "childrens_and_infants_wear_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChildrensAndInfantsWearStores
            | val GHC.Classes.== "chiropodists_podiatrists" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropodistsPodiatrists
            | val GHC.Classes.== "chiropractors" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumChiropractors
            | val GHC.Classes.== "cigar_stores_and_stands" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCigarStoresAndStands
            | val GHC.Classes.== "civic_social_fraternal_associations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCivicSocialFraternalAssociations
            | val GHC.Classes.== "cleaning_and_maintenance" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCleaningAndMaintenance
            | val GHC.Classes.== "clothing_rental" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumClothingRental
            | val GHC.Classes.== "colleges_universities" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCollegesUniversities
            | val GHC.Classes.== "commercial_equipment" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialEquipment
            | val GHC.Classes.== "commercial_footwear" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialFootwear
            | val GHC.Classes.== "commercial_photography_art_and_graphics" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommercialPhotographyArtAndGraphics
            | val GHC.Classes.== "commuter_transport_and_ferries" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCommuterTransportAndFerries
            | val GHC.Classes.== "computer_network_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerNetworkServices
            | val GHC.Classes.== "computer_programming" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerProgramming
            | val GHC.Classes.== "computer_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerRepair
            | val GHC.Classes.== "computer_software_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputerSoftwareStores
            | val GHC.Classes.== "computers_peripherals_and_software" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumComputersPeripheralsAndSoftware
            | val GHC.Classes.== "concrete_work_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConcreteWorkServices
            | val GHC.Classes.== "construction_materials" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConstructionMaterials
            | val GHC.Classes.== "consulting_public_relations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumConsultingPublicRelations
            | val GHC.Classes.== "correspondence_schools" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCorrespondenceSchools
            | val GHC.Classes.== "cosmetic_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCosmeticStores
            | val GHC.Classes.== "counseling_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCounselingServices
            | val GHC.Classes.== "country_clubs" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCountryClubs
            | val GHC.Classes.== "courier_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourierServices
            | val GHC.Classes.== "court_costs" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCourtCosts
            | val GHC.Classes.== "credit_reporting_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCreditReportingAgencies
            | val GHC.Classes.== "cruise_lines" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumCruiseLines
            | val GHC.Classes.== "dairy_products_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDairyProductsStores
            | val GHC.Classes.== "dance_hall_studios_schools" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDanceHallStudiosSchools
            | val GHC.Classes.== "dating_escort_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDatingEscortServices
            | val GHC.Classes.== "dentists_orthodontists" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDentistsOrthodontists
            | val GHC.Classes.== "department_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDepartmentStores
            | val GHC.Classes.== "detective_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDetectiveAgencies
            | val GHC.Classes.== "digital_goods_applications" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsApplications
            | val GHC.Classes.== "digital_goods_games" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsGames
            | val GHC.Classes.== "digital_goods_large_volume" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsLargeVolume
            | val GHC.Classes.== "digital_goods_media" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDigitalGoodsMedia
            | val GHC.Classes.== "direct_marketing_catalog_merchant" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCatalogMerchant
            | val GHC.Classes.== "direct_marketing_combination_catalog_and_retail_merchant" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingCombinationCatalogAndRetailMerchant
            | val GHC.Classes.== "direct_marketing_inbound_telemarketing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInboundTelemarketing
            | val GHC.Classes.== "direct_marketing_insurance_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingInsuranceServices
            | val GHC.Classes.== "direct_marketing_other" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOther
            | val GHC.Classes.== "direct_marketing_outbound_telemarketing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingOutboundTelemarketing
            | val GHC.Classes.== "direct_marketing_subscription" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingSubscription
            | val GHC.Classes.== "direct_marketing_travel" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDirectMarketingTravel
            | val GHC.Classes.== "discount_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDiscountStores
            | val GHC.Classes.== "doctors" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoctors
            | val GHC.Classes.== "door_to_door_sales" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDoorToDoorSales
            | val GHC.Classes.== "drapery_window_covering_and_upholstery_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDraperyWindowCoveringAndUpholsteryStores
            | val GHC.Classes.== "drinking_places" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrinkingPlaces
            | val GHC.Classes.== "drug_stores_and_pharmacies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugStoresAndPharmacies
            | val GHC.Classes.== "drugs_drug_proprietaries_and_druggist_sundries" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDrugsDrugProprietariesAndDruggistSundries
            | val GHC.Classes.== "dry_cleaners" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDryCleaners
            | val GHC.Classes.== "durable_goods" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDurableGoods
            | val GHC.Classes.== "duty_free_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumDutyFreeStores
            | val GHC.Classes.== "eating_places_restaurants" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEatingPlacesRestaurants
            | val GHC.Classes.== "educational_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEducationalServices
            | val GHC.Classes.== "electric_razor_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricRazorStores
            | val GHC.Classes.== "electrical_parts_and_equipment" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalPartsAndEquipment
            | val GHC.Classes.== "electrical_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectricalServices
            | val GHC.Classes.== "electronics_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsRepairShops
            | val GHC.Classes.== "electronics_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElectronicsStores
            | val GHC.Classes.== "elementary_secondary_schools" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumElementarySecondarySchools
            | val GHC.Classes.== "employment_temp_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEmploymentTempAgencies
            | val GHC.Classes.== "equipment_rental" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumEquipmentRental
            | val GHC.Classes.== "exterminating_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumExterminatingServices
            | val GHC.Classes.== "family_clothing_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFamilyClothingStores
            | val GHC.Classes.== "fast_food_restaurants" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFastFoodRestaurants
            | val GHC.Classes.== "financial_institutions" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinancialInstitutions
            | val GHC.Classes.== "fines_government_administrative_entities" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFinesGovernmentAdministrativeEntities
            | val GHC.Classes.== "fireplace_fireplace_screens_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFireplaceFireplaceScreensAndAccessoriesStores
            | val GHC.Classes.== "floor_covering_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloorCoveringStores
            | val GHC.Classes.== "florists" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFlorists
            | val GHC.Classes.== "florists_supplies_nursery_stock_and_flowers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFloristsSuppliesNurseryStockAndFlowers
            | val GHC.Classes.== "freezer_and_locker_meat_provisioners" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFreezerAndLockerMeatProvisioners
            | val GHC.Classes.== "fuel_dealers_non_automotive" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuelDealersNonAutomotive
            | val GHC.Classes.== "funeral_services_crematories" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFuneralServicesCrematories
            | val GHC.Classes.== "furniture_home_furnishings_and_equipment_stores_except_appliances" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureHomeFurnishingsAndEquipmentStoresExceptAppliances
            | val GHC.Classes.== "furniture_repair_refinishing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurnitureRepairRefinishing
            | val GHC.Classes.== "furriers_and_fur_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumFurriersAndFurShops
            | val GHC.Classes.== "general_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGeneralServices
            | val GHC.Classes.== "gift_card_novelty_and_souvenir_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGiftCardNoveltyAndSouvenirShops
            | val GHC.Classes.== "glass_paint_and_wallpaper_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlassPaintAndWallpaperStores
            | val GHC.Classes.== "glassware_crystal_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGlasswareCrystalStores
            | val GHC.Classes.== "golf_courses_public" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGolfCoursesPublic
            | val GHC.Classes.== "government_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGovernmentServices
            | val GHC.Classes.== "grocery_stores_supermarkets" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumGroceryStoresSupermarkets
            | val GHC.Classes.== "hardware_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareEquipmentAndSupplies
            | val GHC.Classes.== "hardware_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHardwareStores
            | val GHC.Classes.== "health_and_beauty_spas" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHealthAndBeautySpas
            | val GHC.Classes.== "hearing_aids_sales_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHearingAidsSalesAndSupplies
            | val GHC.Classes.== "heating_plumbing_a_c" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHeatingPlumbingAC
            | val GHC.Classes.== "hobby_toy_and_game_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHobbyToyAndGameShops
            | val GHC.Classes.== "home_supply_warehouse_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHomeSupplyWarehouseStores
            | val GHC.Classes.== "hospitals" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHospitals
            | val GHC.Classes.== "hotels_motels_and_resorts" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHotelsMotelsAndResorts
            | val GHC.Classes.== "household_appliance_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumHouseholdApplianceStores
            | val GHC.Classes.== "industrial_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIndustrialSupplies
            | val GHC.Classes.== "information_retrieval_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInformationRetrievalServices
            | val GHC.Classes.== "insurance_default" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceDefault
            | val GHC.Classes.== "insurance_underwriting_premiums" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumInsuranceUnderwritingPremiums
            | val GHC.Classes.== "intra_company_purchases" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumIntraCompanyPurchases
            | val GHC.Classes.== "jewelry_stores_watches_clocks_and_silverware_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumJewelryStoresWatchesClocksAndSilverwareStores
            | val GHC.Classes.== "landscaping_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLandscapingServices
            | val GHC.Classes.== "laundries" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundries
            | val GHC.Classes.== "laundry_cleaning_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLaundryCleaningServices
            | val GHC.Classes.== "legal_services_attorneys" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLegalServicesAttorneys
            | val GHC.Classes.== "luggage_and_leather_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLuggageAndLeatherGoodsStores
            | val GHC.Classes.== "lumber_building_materials_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumLumberBuildingMaterialsStores
            | val GHC.Classes.== "manual_cash_disburse" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumManualCashDisburse
            | val GHC.Classes.== "marinas_service_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMarinasServiceAndSupplies
            | val GHC.Classes.== "masonry_stonework_and_plaster" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMasonryStoneworkAndPlaster
            | val GHC.Classes.== "massage_parlors" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMassageParlors
            | val GHC.Classes.== "medical_and_dental_labs" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalAndDentalLabs
            | val GHC.Classes.== "medical_dental_ophthalmic_and_hospital_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalDentalOphthalmicAndHospitalEquipmentAndSupplies
            | val GHC.Classes.== "medical_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMedicalServices
            | val GHC.Classes.== "membership_organizations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMembershipOrganizations
            | val GHC.Classes.== "mens_and_boys_clothing_and_accessories_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensAndBoysClothingAndAccessoriesStores
            | val GHC.Classes.== "mens_womens_clothing_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMensWomensClothingStores
            | val GHC.Classes.== "metal_service_centers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMetalServiceCenters
            | val GHC.Classes.== "miscellaneous" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneous
            | val GHC.Classes.== "miscellaneous_apparel_and_accessory_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousApparelAndAccessoryShops
            | val GHC.Classes.== "miscellaneous_auto_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousAutoDealers
            | val GHC.Classes.== "miscellaneous_business_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousBusinessServices
            | val GHC.Classes.== "miscellaneous_food_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousFoodStores
            | val GHC.Classes.== "miscellaneous_general_merchandise" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralMerchandise
            | val GHC.Classes.== "miscellaneous_general_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousGeneralServices
            | val GHC.Classes.== "miscellaneous_home_furnishing_specialty_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousHomeFurnishingSpecialtyStores
            | val GHC.Classes.== "miscellaneous_publishing_and_printing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousPublishingAndPrinting
            | val GHC.Classes.== "miscellaneous_recreation_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRecreationServices
            | val GHC.Classes.== "miscellaneous_repair_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousRepairShops
            | val GHC.Classes.== "miscellaneous_specialty_retail" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMiscellaneousSpecialtyRetail
            | val GHC.Classes.== "mobile_home_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMobileHomeDealers
            | val GHC.Classes.== "motion_picture_theaters" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotionPictureTheaters
            | val GHC.Classes.== "motor_freight_carriers_and_trucking" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorFreightCarriersAndTrucking
            | val GHC.Classes.== "motor_homes_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorHomesDealers
            | val GHC.Classes.== "motor_vehicle_supplies_and_new_parts" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorVehicleSuppliesAndNewParts
            | val GHC.Classes.== "motorcycle_shops_and_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsAndDealers
            | val GHC.Classes.== "motorcycle_shops_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMotorcycleShopsDealers
            | val GHC.Classes.== "music_stores_musical_instruments_pianos_and_sheet_music" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumMusicStoresMusicalInstrumentsPianosAndSheetMusic
            | val GHC.Classes.== "news_dealers_and_newsstands" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNewsDealersAndNewsstands
            | val GHC.Classes.== "non_fi_money_orders" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiMoneyOrders
            | val GHC.Classes.== "non_fi_stored_value_card_purchase_load" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNonFiStoredValueCardPurchaseLoad
            | val GHC.Classes.== "nondurable_goods" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNondurableGoods
            | val GHC.Classes.== "nurseries_lawn_and_garden_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNurseriesLawnAndGardenSupplyStores
            | val GHC.Classes.== "nursing_personal_care" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumNursingPersonalCare
            | val GHC.Classes.== "office_and_commercial_furniture" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOfficeAndCommercialFurniture
            | val GHC.Classes.== "opticians_eyeglasses" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOpticiansEyeglasses
            | val GHC.Classes.== "optometrists_ophthalmologist" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOptometristsOphthalmologist
            | val GHC.Classes.== "orthopedic_goods_prosthetic_devices" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOrthopedicGoodsProstheticDevices
            | val GHC.Classes.== "osteopaths" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumOsteopaths
            | val GHC.Classes.== "package_stores_beer_wine_and_liquor" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPackageStoresBeerWineAndLiquor
            | val GHC.Classes.== "paints_varnishes_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPaintsVarnishesAndSupplies
            | val GHC.Classes.== "parking_lots_garages" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumParkingLotsGarages
            | val GHC.Classes.== "passenger_railways" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPassengerRailways
            | val GHC.Classes.== "pawn_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPawnShops
            | val GHC.Classes.== "pet_shops_pet_food_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetShopsPetFoodAndSupplies
            | val GHC.Classes.== "petroleum_and_petroleum_products" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPetroleumAndPetroleumProducts
            | val GHC.Classes.== "photo_developing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotoDeveloping
            | val GHC.Classes.== "photographic_photocopy_microfilm_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicPhotocopyMicrofilmEquipmentAndSupplies
            | val GHC.Classes.== "photographic_studios" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPhotographicStudios
            | val GHC.Classes.== "picture_video_production" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPictureVideoProduction
            | val GHC.Classes.== "piece_goods_notions_and_other_dry_goods" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPieceGoodsNotionsAndOtherDryGoods
            | val GHC.Classes.== "plumbing_heating_equipment_and_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPlumbingHeatingEquipmentAndSupplies
            | val GHC.Classes.== "political_organizations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPoliticalOrganizations
            | val GHC.Classes.== "postal_services_government_only" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPostalServicesGovernmentOnly
            | val GHC.Classes.== "precious_stones_and_metals_watches_and_jewelry" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPreciousStonesAndMetalsWatchesAndJewelry
            | val GHC.Classes.== "professional_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumProfessionalServices
            | val GHC.Classes.== "public_warehousing_and_storage" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumPublicWarehousingAndStorage
            | val GHC.Classes.== "quick_copy_repro_and_blueprint" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumQuickCopyReproAndBlueprint
            | val GHC.Classes.== "railroads" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRailroads
            | val GHC.Classes.== "real_estate_agents_and_managers_rentals" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRealEstateAgentsAndManagersRentals
            | val GHC.Classes.== "record_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecordStores
            | val GHC.Classes.== "recreational_vehicle_rentals" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRecreationalVehicleRentals
            | val GHC.Classes.== "religious_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousGoodsStores
            | val GHC.Classes.== "religious_organizations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumReligiousOrganizations
            | val GHC.Classes.== "roofing_siding_sheet_metal" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumRoofingSidingSheetMetal
            | val GHC.Classes.== "secretarial_support_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecretarialSupportServices
            | val GHC.Classes.== "security_brokers_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSecurityBrokersDealers
            | val GHC.Classes.== "service_stations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumServiceStations
            | val GHC.Classes.== "sewing_needlework_fabric_and_piece_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSewingNeedleworkFabricAndPieceGoodsStores
            | val GHC.Classes.== "shoe_repair_hat_cleaning" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeRepairHatCleaning
            | val GHC.Classes.== "shoe_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumShoeStores
            | val GHC.Classes.== "small_appliance_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSmallApplianceRepair
            | val GHC.Classes.== "snowmobile_dealers" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSnowmobileDealers
            | val GHC.Classes.== "special_trade_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialTradeServices
            | val GHC.Classes.== "specialty_cleaning" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSpecialtyCleaning
            | val GHC.Classes.== "sporting_goods_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingGoodsStores
            | val GHC.Classes.== "sporting_recreation_camps" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportingRecreationCamps
            | val GHC.Classes.== "sports_and_riding_apparel_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsAndRidingApparelStores
            | val GHC.Classes.== "sports_clubs_fields" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSportsClubsFields
            | val GHC.Classes.== "stamp_and_coin_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStampAndCoinStores
            | val GHC.Classes.== "stationary_office_supplies_printing_and_writing_paper" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationaryOfficeSuppliesPrintingAndWritingPaper
            | val GHC.Classes.== "stationery_stores_office_and_school_supply_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumStationeryStoresOfficeAndSchoolSupplyStores
            | val GHC.Classes.== "swimming_pools_sales" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumSwimmingPoolsSales
            | val GHC.Classes.== "t_ui_travel_germany" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTUiTravelGermany
            | val GHC.Classes.== "tailors_alterations" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTailorsAlterations
            | val GHC.Classes.== "tax_payments_government_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPaymentsGovernmentAgencies
            | val GHC.Classes.== "tax_preparation_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxPreparationServices
            | val GHC.Classes.== "taxicabs_limousines" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTaxicabsLimousines
            | val GHC.Classes.== "telecommunication_equipment_and_telephone_sales" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationEquipmentAndTelephoneSales
            | val GHC.Classes.== "telecommunication_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelecommunicationServices
            | val GHC.Classes.== "telegraph_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTelegraphServices
            | val GHC.Classes.== "tent_and_awning_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTentAndAwningShops
            | val GHC.Classes.== "testing_laboratories" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTestingLaboratories
            | val GHC.Classes.== "theatrical_ticket_agencies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTheatricalTicketAgencies
            | val GHC.Classes.== "timeshares" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTimeshares
            | val GHC.Classes.== "tire_retreading_and_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTireRetreadingAndRepair
            | val GHC.Classes.== "tolls_bridge_fees" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTollsBridgeFees
            | val GHC.Classes.== "tourist_attractions_and_exhibits" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTouristAttractionsAndExhibits
            | val GHC.Classes.== "towing_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTowingServices
            | val GHC.Classes.== "trailer_parks_campgrounds" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTrailerParksCampgrounds
            | val GHC.Classes.== "transportation_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTransportationServices
            | val GHC.Classes.== "travel_agencies_tour_operators" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTravelAgenciesTourOperators
            | val GHC.Classes.== "truck_stop_iteration" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckStopIteration
            | val GHC.Classes.== "truck_utility_trailer_rentals" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTruckUtilityTrailerRentals
            | val GHC.Classes.== "typesetting_plate_making_and_related_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypesettingPlateMakingAndRelatedServices
            | val GHC.Classes.== "typewriter_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumTypewriterStores
            | val GHC.Classes.== "u_s_federal_government_agencies_or_departments" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUSFederalGovernmentAgenciesOrDepartments
            | val GHC.Classes.== "uniforms_commercial_clothing" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUniformsCommercialClothing
            | val GHC.Classes.== "used_merchandise_and_secondhand_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUsedMerchandiseAndSecondhandStores
            | val GHC.Classes.== "utilities" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumUtilities
            | val GHC.Classes.== "variety_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVarietyStores
            | val GHC.Classes.== "veterinary_services" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVeterinaryServices
            | val GHC.Classes.== "video_amusement_game_supplies" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoAmusementGameSupplies
            | val GHC.Classes.== "video_game_arcades" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoGameArcades
            | val GHC.Classes.== "video_tape_rental_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVideoTapeRentalStores
            | val GHC.Classes.== "vocational_trade_schools" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumVocationalTradeSchools
            | val GHC.Classes.== "watch_jewelry_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWatchJewelryRepair
            | val GHC.Classes.== "welding_repair" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWeldingRepair
            | val GHC.Classes.== "wholesale_clubs" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWholesaleClubs
            | val GHC.Classes.== "wig_and_toupee_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWigAndToupeeStores
            | val GHC.Classes.== "wires_money_orders" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWiresMoneyOrders
            | val GHC.Classes.== "womens_accessory_and_specialty_shops" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensAccessoryAndSpecialtyShops
            | val GHC.Classes.== "womens_ready_to_wear_stores" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWomensReadyToWearStores
            | val GHC.Classes.== "wrecking_and_salvage_yards" -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableEnumWreckingAndSalvageYards
            | GHC.Base.otherwise -> Issuing'cardholderSpendingControls'NonNullableBlockedCategories'NonNullableOther val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.status@ in the specification.
--
-- Specifies whether to permit authorizations on this cardholder\'s cards.
data Issuing'cardholderStatus'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderStatus'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderStatus'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"active"@
    Issuing'cardholderStatus'EnumActive
  | -- | Represents the JSON value @"blocked"@
    Issuing'cardholderStatus'EnumBlocked
  | -- | Represents the JSON value @"inactive"@
    Issuing'cardholderStatus'EnumInactive
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderStatus' where
  toJSON (Issuing'cardholderStatus'Other val) = val
  toJSON (Issuing'cardholderStatus'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderStatus'EnumActive) = "active"
  toJSON (Issuing'cardholderStatus'EnumBlocked) = "blocked"
  toJSON (Issuing'cardholderStatus'EnumInactive) = "inactive"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderStatus' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "active" -> Issuing'cardholderStatus'EnumActive
            | val GHC.Classes.== "blocked" -> Issuing'cardholderStatus'EnumBlocked
            | val GHC.Classes.== "inactive" -> Issuing'cardholderStatus'EnumInactive
            | GHC.Base.otherwise -> Issuing'cardholderStatus'Other val
      )

-- | Defines the enum schema located at @components.schemas.issuing.cardholder.properties.type@ in the specification.
--
-- One of \`individual\` or \`company\`.
data Issuing'cardholderType'
  = -- | This case is used if the value encountered during decoding does not match any of the provided cases in the specification.
    Issuing'cardholderType'Other Data.Aeson.Types.Internal.Value
  | -- | This constructor can be used to send values to the server which are not present in the specification yet.
    Issuing'cardholderType'Typed Data.Text.Internal.Text
  | -- | Represents the JSON value @"company"@
    Issuing'cardholderType'EnumCompany
  | -- | Represents the JSON value @"individual"@
    Issuing'cardholderType'EnumIndividual
  deriving (GHC.Show.Show, GHC.Classes.Eq)

instance Data.Aeson.Types.ToJSON.ToJSON Issuing'cardholderType' where
  toJSON (Issuing'cardholderType'Other val) = val
  toJSON (Issuing'cardholderType'Typed val) = Data.Aeson.Types.ToJSON.toJSON val
  toJSON (Issuing'cardholderType'EnumCompany) = "company"
  toJSON (Issuing'cardholderType'EnumIndividual) = "individual"

instance Data.Aeson.Types.FromJSON.FromJSON Issuing'cardholderType' where
  parseJSON val =
    GHC.Base.pure
      ( if
            | val GHC.Classes.== "company" -> Issuing'cardholderType'EnumCompany
            | val GHC.Classes.== "individual" -> Issuing'cardholderType'EnumIndividual
            | GHC.Base.otherwise -> Issuing'cardholderType'Other val
      )
